************************************************************************
*                                                                      *
*    Datei                                                             *
*      CoTAM.for                                                       *
*                                                                      *
*    Inhalt                                                            *
*      Namen. Stellt die Copyright-Meldung auf dem Bildschirm dar.     *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*         Menue_System                                                 *
*                                                                      *
*      Menue_System                                                    *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*                                                                      *
*      Edit_Pfad                                                       *
*      Wird aufgerufen in:                                             *
*         Menue_System                                                 *
*                                                                      *
*      Menu_Datei                                                      *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*                                                                      *
*      Messwerte_editieren                                             *
*      Wird aufgerufen in:                                             *
*         Menue_Datei                                                  *
*                                                                      *
*      Menue_Hydrodynamik                                              *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*                                                                      *
*      Menue_Zeit                                                      *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*                                                                      *
*      Menue_Numerik                                                   *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*                                                                      *
*      Menue_Tracerparameter                                           *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*                                                                      *
*      Start_Simulation. Startet die Simulation.                       *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*                                                                      *
*      Programmende. Wie der Name schon sagt.                          *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*         Menue_Datei                                                  *
*                                                                      *
*      Daten_korrekt. Test der Daten auf Konsistenz.                   *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*         Menue_Datei                                                  *
*         Menue_Numerik                                                *
*         Start_Simulation                                             *
*                                                                      *
*      Del_Mess. Lscht alle eingelesenen Messwerte                    *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*         Menue_Datei                                                  *
*                                                                      *
*      Maschinengenauigkeit. Ermittelt die Maschinengenauigkeit.       *
*      Wird aufgerufen in:                                             *
*         Menue_Numerik                                                *
*                                                                      *
************************************************************************
*                                                                      *
*    Copyright                                                         *
*      Der in dieser Datei enthaltene Quellcode darf ohne Genehmigung  *
*      und weitere Vergtung weiterentwickelt werden. Diese Copyright  *
*      Erklrung darf um eigene Urherberrechtserklrungen erweitert    *
*      werden. Die Verwendung dieses Quelltextes fr Publikationen     *
*      ist, auch bei auszugsweiser Verwendung, grundstzlich Genehmi-  *
*      gungspflichtig (kostet nix, ich wrdes halt nur gerne wissen).  *
*                                                                      *
*      Der Programmautor weist darauf hin, da Software nicht fehler-  *
*      frei zu erstellen ist. Die Korrektheit des Quellcodes ist da-   *
*      her auf geeignete Weise zu berprfen.                          *
*                                                                      *
************************************************************************
*                                                                      *
*    Programmautor                                                     *
*      Dr. Rainer Sieger                                               *
*      Alfred-Wegener-Institut fr Meeres- und Polarforschung          *
*      Postfach 12 01 61                                               *
*      27515 Bremerhaven                                               *
*      e-mail: rsieger@AWI-Bremerhaven.de                              *
*                                                                      *
************************************************************************
*                                                                      *
*    letztes Editierdatum                                              *
*      16.3.94                                                         *
*                                                                      *
************************************************************************

      PROGRAM CoTAM

************************************************************************
*     Variablendeklaration

      Include 'nT.inc'
      Include 'nmess.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)       ! # der Eingabeparameter

************************************************************************

      Integer*2      i                   ! Laufvariable
      Integer*2      Plot                ! Plotter ja/nein
      Integer*2      Auswahl, Auswahl2   ! Menauswahl
      Integer*2      Sf                  ! Daten schon gespeichert ?
      Integer*2      Status              ! Daten korrekt ?
      Integer*2      Anzahl_MS           ! # der aktiven Masterspezies
      Integer*2      Anzahl_MS_g         ! # der gesetzten Masterspezies
      Integer*2      MS(nT)              ! aktive Masterspezies
      Integer*2      Waits               ! Warteschleife

      Real           Messwerte(nmess,4)  ! Messwerte
      Real           SW(11,nT)           ! Sorptionsparameter
      Real           Wert(Anzahl)        ! Datenvektor

      Character*10   MS_Name(nT)         ! Namen der Masterspezies
      Character*37   Titel(2)            ! Datensatz-Titel

      Character*12   DAT_File            ! Dateiname
      Character*12   PAR_File            ! Dateiname
      Character*12   EXP_File            ! Dateiname
      Character*12   PRN_File            ! Dateiname
      Character*12   PRX_File            ! Dateiname
      Character*12   PRX_File_neu        ! Dateiname
      Character*12   UMS_File            ! Dateiname
      Character*12   PHR_File            ! Dateiname
      Character*12   LPR_File            ! Dateiname

      Character*30   DAT_Pfad            ! Pfad fr DAT-File
      Character*30   PAR_Pfad            ! Pfad fr PAR-File
      Character*30   EXP_Pfad            ! Pfad fr EXP-File
      Character*30   PRN_Pfad            ! Pfad fr PRN-File
      Character*30   PRX_Pfad            ! Pfad fr PRX-File
      Character*30   UMS_Pfad            ! Pfad fr KIN-File
      Character*30   PHR_Pfad            ! Pfad fr PHR-File
      Character*30   LPR_Pfad            ! Pfad fr PHR-File
      Character*80   Buffer(21), CMNAM   ! Commandline, FTN-Funktion

      Logical        Menue               ! Menue gewnscht
      Logical        Help                ! Hilfsbildschirm gewnscht
      Logical        Calc                ! Berechnung gleich starten
      Logical        Farbe               ! Farbdarstellung mglich
      Logical        I_set               ! DAT_File gesetzt ?
      Logical        O_set               ! PRN_File gesetzt ?
      Logical        C_set               ! PRX_File gesetzt ?
      Logical        L_set               ! LPR_File gesetzt ?
      Logical        M_set               ! EXP_File gesetzt ?
      Logical        P_set               ! PAR_File gesetzt ?
      Logical        U_set               ! UMS_File gesetzt ?
      Logical        PHR_set             ! PHR_File gesetzt ?

************************************************************************
*     Lscht Bildschirm und schaltet Textmode ein

      call cls
      call Set_Text_mode

************************************************************************
*     Initialisierungs-File lesen und Pfade setzen

      call Setze_Pfade(0,                                ! Aufruf
     *                 DAT_Pfad,DAT_File,                ! DAT
     *                 PAR_Pfad,PAR_File,                ! PAR
     *                 UMS_Pfad,UMS_File,                ! KIN
     *                 PHR_Pfad,PHR_File,                ! PHR
     *                 EXP_Pfad,EXP_File,                ! EXP
     *                 PRN_Pfad,PRN_File,                ! PRN
     *                 PRX_Pfad,PRX_File,PRX_File_neu,   ! PRX
     *                 LPR_Pfad,LPR_File)                ! LPR

************************************************************************
*     Initialisierung der Flags

      Status = 0                                         ! Dateistatus
      Sf     = 1                                         ! Speicherflag

************************************************************************
*     Laden aller Daten der letzten Sitzung aus COTAM.WRK

      call Load_Workfile(Status,Plot,Menue,Waits,  ! Kontroll-Flags
     *                   Messwerte,                ! Messwerte
     *                   Titel,Wert,MS_Name,SW,    ! Daten
     *                   DAT_Pfad,DAT_File,        ! DAT
     *                   PAR_Pfad,PAR_File,        ! PAR
     *                   UMS_Pfad,UMS_File,        ! UMS
     *                   PHR_Pfad,PHR_File,        ! PHR
     *                   PRN_Pfad,PRN_File,        ! PRN
     *                   PRX_Pfad,PRX_File,        ! PRX
     *                   PRX_File_neu,             ! PRX
     *                   LPR_Pfad,LPR_File)        ! LPR

      Menue   = .true.        ! Men ist gewnscht
      Calc    = .false.       ! Simulation soll nicht gestartet werden
      Help    = .false.       ! Hilfsbildschirm nicht gewnscht
      Farbe   = .true.        ! Farbbildschirm erforderlich
      I_set   = .false.       ! Kein DAT_File ber Commandline gesetzt
      O_set   = .false.       ! Kein PRN_File ber Commandline gesetzt
      C_set   = .false.       ! Kein PRX_File ber Commandline gesetzt
      L_set   = .false.       ! Kein LPR_File ber Commandline gesetzt
      M_set   = .false.       ! Kein EXP_File ber Commandline gesetzt
      P_set   = .false.       ! Kein PAR_File ber Commandline gesetzt
      U_set   = .false.       ! Kein UMS_File ber Commandline gesetzt
      PHR_set = .false.       ! Kein PHR_File ber Commandline gesetzt

      Waits   = 0             ! Keine Warteschleife

************************************************************************
*     Auswertung der Commandline (FTN77)
*
*     /i     = Input-File
*     /o     = Output-File
*     /c     = Hintergrundkonzentration
*     /m     = Messwerte
*     /p     = variable Parameter
*     /u     = Umsatzraten
*     /phr   = PHREEQE-Datensatz
*     /s     = STOP nach Modellierung
*     /b     = Berechnung starten
*     /h     = Hilfsbildschirm
*     /?     = Hilfsbildschirm
*     /bw    = Monochromemodus
*     /wait  = Warteschleife
*     /t     = Testbildschirm, nur fr Programmierer
*     /g     = Durchgangskurve
*     /gg    = Durchgangskurve, Sulenverteilungen
*     /g    = Durchgangskurve, Sulenverteilungen in bersicht
*     /ga   = Durchgangskurve, SV in bersicht, Animation
*     /gs    = Animierte Sulenverteilung in Sediment-Darstellung
*     /text  = Textmodus
*     /analy = analytische Berechnung
*     /batch = Batch-Betrieb
*
************************************************************************

      do i=1,10
        Buffer(i) = ' '
      end do

      call Command_line(Buffer(1))
      n = 1
      do while (Buffer(n).GT.' ')
        n = n + 1
        Buffer(n) = CMNAM()
      end do

      do i=2,n
        if ((Buffer(i).EQ.'/i').OR.(Buffer(i).EQ.'/I')) then
          DAT_File = Buffer(i+1)      ! Input-File
          I_set    = .true.
        end if
        if ((Buffer(i).EQ.'/o').OR.(Buffer(i).EQ.'/O')) then
          PRN_File     = Buffer(i+1)  ! Output-File
          PRX_File_neu = PRN_File
          O_set        = .true.
        end if
        if ((Buffer(i).EQ.'/c').OR.(Buffer(i).EQ.'/C')) then
          PRX_File = Buffer(i+1)      ! Hintergrundkonzentration
          C_set    = .true.           ! C_0_laden, PRX-File
        end if
        if ((Buffer(i).EQ.'/l').OR.(Buffer(i).EQ.'/L')) then
          LPR_File = Buffer(i+1)      ! Hintergrundkonzentration
          L_set    = .true.           ! C_0_laden, LPR-File
        end if
        if ((Buffer(i).EQ.'/m').OR.(Buffer(i).EQ.'/M')) then
          EXP_File = Buffer(i+1)      ! Messwerte
          M_set    = .true.
        end if
        if ((Buffer(i).EQ.'/p').OR.(Buffer(i).EQ.'/P')) then
          PAR_File = Buffer(i+1)      ! variable Parameter
          P_set    = .true.
        end if
        if ((Buffer(i).EQ.'/u').OR.(Buffer(i).EQ.'/U')) then
          UMS_File = Buffer(i+1)      ! Umsatzraten
          U_set    = .true.
        end if
        if ((Buffer(i).EQ.'/phr').OR.(Buffer(i).EQ.'/PHR')) then
          PHR_File = Buffer(i+1)      ! PHREEQE-Datensatz
          PHR_set  = .true.
        end if
        if ((Buffer(i).EQ.'/s').OR.(Buffer(i).EQ.'/S')) then
          Menue = .false.             ! Kein Menue, gleich Stop
        end if
        if ((Buffer(i).EQ.'/b').OR.(Buffer(i).EQ.'/B')) then
          Calc = .true.               ! Berechnung starten
        end if
        if ((Buffer(i).EQ.'/h').OR.(Buffer(i).EQ.'/H')) then
          Help = .true.               ! Hilfsbildschirm
        end if
        if (Buffer(i).EQ.'/?')  Help = .true.
        if ((Buffer(i).EQ.'/bw').OR.(Buffer(i).EQ.'/BW')) then
          Farbe = .false.             ! Monochromemodus
        end if
        if ((Buffer(i).EQ.'/wait').OR.(Buffer(i).EQ.'/WAIT')) then
          Waits = Waits + 5           ! Warteschleife
        end if
        if ((Buffer(i).EQ.'/t').OR.(Buffer(i).EQ.'/T')) then
          Plot = -1                   ! Testbildschirm
        end if
        if ((Buffer(i).EQ.'/g').OR.(Buffer(i).EQ.'/G')) then
          Plot = 1                    ! Durchgangskurve
        end if
        if ((Buffer(i).EQ.'/gg').OR.(Buffer(i).EQ.'/GG')) then
          Plot = 2                    ! Grundwasser
        end if
        if ((Buffer(i).EQ.'/g').OR.(Buffer(i).EQ.'/G')) then
          Plot = 3                    ! Grundwasser
        end if
        if ((Buffer(i).EQ.'/ga').OR.(Buffer(i).EQ.'/GA')) then
          Plot = 4                    ! Grundwasser
        end if
        if ((Buffer(i).EQ.'/ga').OR.(Buffer(i).EQ.'/GA')) then
          Plot = 5                    ! Grundwasser
        end if
        if ((Buffer(i).EQ.'/gs').OR.(Buffer(i).EQ.'/GS')) then
          Plot = 6                    ! Sediment
        end if
        if ((Buffer(i).EQ.'/text').OR.(Buffer(i).EQ.'/TEXT')) then
          Plot = 7                    ! Textmodus
        end if
        if ((Buffer(i).EQ.'/analy').OR.(Buffer(i).EQ.'/ANALY')) then
          Plot = 8                    ! analytische Berechnung
        end if
        if ((Buffer(i).EQ.'/batch').OR.(Buffer(i).EQ.'/BATCH')) then
          Plot = 9                    ! Batch-Betrieb
        end if
      end do

************************************************************************
*     Dateinamen und Erweiterungen setzen

      if (I_set) then   ! wenn Input-File angegeben wurde
        if (.NOT. M_set)    EXP_File = 'NONAME.EXP'
        if (.NOT. P_set)    PAR_File = 'NONAME.PAR'
        if (.NOT. U_set)    UMS_File = 'NONAME.UMS'
        if (.NOT. PHR_set)  PHR_File = 'NONAME.PHR'
      end if

      if (.NOT. O_Set) then
        PRN_File     = DAT_File
        PRX_File_neu = DAT_File
      end if

      call Setze_Extension(DAT_File,'.DAT')
      call Setze_Extension(PAR_File,'.PAR')
      call Setze_Extension(UMS_File,'.UMS')
      call Setze_Extension(PHR_File,'.PHR')
      call Setze_Extension(EXP_File,'.EXP')
      call Setze_Extension(PRN_File,'.PRN')
      call Setze_Extension(PRX_File,'.PRX')
      call Setze_Extension(PRX_File_neu,'.PRX')
      call Setze_Extension(LPR_File,'.LPR')

************************************************************************
*     Daten laden (/i <DAT-File>)

      if (I_set) then
        Status = 0
        call Daten_laden(Status,Titel,Wert,MS_Name,SW,
     *                   DAT_Pfad,DAT_File)

        if (C_set)  Wert(9) = 1.0  ! C_0_laden = .true.
        if (L_set)  Wert(9) = 2.0  ! C_0_laden = .true.
        call Aktive_Masterspezies(SW,MS,Anzahl_MS,Anzahl_MS_g)
        call Del_Mess(Messwerte)
        call Loesche_Datei('COTAM.WRK')
      end if

************************************************************************
*     Daten laden (/m <EXP-File>)

      if (M_set) then
        Status = 0
        call Del_Mess(Messwerte)
        call Loesche_Datei('COTAM.WRK')
        call Messwerte_laden(Status,Messwerte,EXP_Pfad,EXP_File)
      end if

************************************************************************
*     Simulation starten (/b)

      if (Calc) then
        call cls
        call Daten_korrekt(1,Wert,SW,Status)
        if (Status.EQ.1) then
          if (Plot.NE.8) then
            call Save_Workfile(Plot,Menue,Waits,         ! Kontroll-Flag
     *                         Messwerte,                ! Messwerte
     *                         Titel,Wert,MS_Name,SW,    ! Daten
     *                         DAT_Pfad,DAT_File,        ! DAT
     *                         PAR_Pfad,PAR_File,        ! PAR
     *                         UMS_Pfad,UMS_File,        ! KIN
     *                         PHR_Pfad,PHR_File,        ! PHR
     *                         EXP_Pfad,EXP_File,        ! PHR
     *                         PRN_Pfad,PRN_File,        ! PRN
     *                         PRX_Pfad,PRX_File,        ! PRX
     *                         PRX_File_neu,             ! PRX
     *                         LPR_Pfad,LPR_File)        ! LPR
            call Simulation
          else
            call Tracerauswertung(Menue,Waits,
     *                            Messwerte,Wert,MS_Name,SW,Titel,
     *                            DAT_Pfad,DAT_File,PRN_Pfad,PRN_File,
     *                            PRX_Pfad,PRX_File_neu)
          end if
        else
          call warten(2,5)
        end if
        Calc = .false.
      end if

************************************************************************
*     Programmabbruch (/s)

      if (.NOT. Menue) then  ! wenn also kein Men gewnscht
        Sf       = 1
        PRX_File = PRX_File_neu
        call Programmende(Sf,Titel,Wert,MS_Name,SW,   ! Daten
     *                    DAT_Pfad,DAT_File,          ! DAT
     *                    PAR_Pfad,PAR_File,          ! PAR
     *                    UMS_Pfad,UMS_File,          ! UMS
     *                    PHR_Pfad,PHR_File,          ! PHR
     *                    EXP_Pfad,EXP_File,          ! EXP
     *                    PRN_Pfad,PRN_File,          ! PRN
     *                    PRX_Pfad,PRX_File,          ! PRX
     *                    LPR_Pfad,LPR_File)          ! LPR
      end if

************************************************************************
*     Erffnen der Bibliothek MASKEN.RSC fr VIDPOP

      call Installiere_Bibliothek(Farbe)

************************************************************************
*     Hilfsbildschirm und Programmabbruch (/h)

      if (Help) then
        Menue =.false.
        call Maske_o('Help')
        call Taste
        Sf       = 1
        PRX_File = PRX_File_neu
        call Programmende(Sf,                         ! Speicher-Flag
     *                    Titel,Wert,MS_Name,SW,      ! Daten
     *                    DAT_Pfad,DAT_File,          ! DAT
     *                    PAR_Pfad,PAR_File,          ! PAR
     *                    UMS_Pfad,UMS_File,          ! UMS
     *                    PHR_Pfad,PHR_File,          ! PHR
     *                    EXP_Pfad,EXP_File,          ! EXP
     *                    PRN_Pfad,PRN_File,          ! PRN
     *                    PRX_Pfad,PRX_File,          ! PRX
     *                    LPR_Pfad,LPR_File)          ! LPR
      end if

************************************************************************
*     Men

      call Namen
      Auswahl = 1
      do while (Auswahl.NE.0)
        call Menue_o('Menue_H',Auswahl)
* = 0
        if (Auswahl.EQ.0) then
          call Menue_m('Ende',Auswahl2)
          if (Auswahl2.EQ.1) then
            PRX_File = PRX_File_neu
            call Programmende(Sf,Titel,Wert,MS_Name,SW,   ! Daten
     *                        DAT_Pfad,DAT_File,          ! DAT
     *                        PAR_Pfad,PAR_File,          ! PAR
     *                        UMS_Pfad,UMS_File,          ! UMS
     *                        PHR_Pfad,PHR_File,          ! PHR
     *                        EXP_Pfad,EXP_File,          ! EXP
     *                        PRN_Pfad,PRN_File,          ! PRN
     *                        PRX_Pfad,PRX_File,          ! PRX
     *                        LPR_Pfad,LPR_File)          ! LPR
          else
            Auswahl = -1  ! Abbruch war wohl doch nicht gewnscht
          end if
        end if
* = 1
        if (Auswahl.EQ.1) then
          call Menue_System(DAT_Pfad,DAT_File,               ! DAT
     *                      PAR_Pfad,PAR_File,               ! PAR
     *                      UMS_Pfad,UMS_File,               ! KIN
     *                      PHR_Pfad,PHR_File,               ! PHR
     *                      EXP_Pfad,EXP_File,               ! EXP
     *                      PRN_Pfad,PRN_File,               ! PRN
     *                      PRX_Pfad,PRX_File,               ! PRX
     *                      PRX_File_neu,                    ! PRX
     *                      LPR_Pfad,LPR_File)               ! LPR
        end if
* = 2
        if (Auswahl.EQ.2) then   ! Datei
          call Aktive_Masterspezies(SW,MS,Anzahl_MS,Anzahl_MS_g)
          call Menue_Datei(Sf,                         ! Speicherflag
     *                     Messwerte,                  ! Messwerte
     *                     Titel,Wert,MS_Name,SW,      ! Daten
     *                     Anzahl_MS_g,                ! # Masterspezies
     *                     DAT_Pfad,DAT_File,          ! DAT
     *                     PAR_Pfad,PAR_File,          ! PAR
     *                     UMS_Pfad,UMS_File,          ! KIN
     *                     PHR_Pfad,PHR_File,          ! PHR
     *                     EXP_Pfad,EXP_File,          ! EXP
     *                     PRN_Pfad,PRN_File,          ! PRN
     *                     PRX_Pfad,PRX_File,          ! PRX
     *                     PRX_File_neu,               ! PRX
     *                     LPR_Pfad,LPR_File)          ! LPR

          call Aktive_Masterspezies(SW,MS,Anzahl_MS,Anzahl_MS_g)
        end if
* = 3
        if (Auswahl.EQ.3) then   ! Sule
          call Menue_Saeule(Sf,Titel,Wert)
        end if
* = 4
        if (Auswahl.EQ.4) then   ! Hydrodynamik
          call Menue_Hydrodynamik(Sf,Wert)
        end if
* = 5
        if (Auswahl.EQ.5) then   ! Zeit
          call Menue_Zeit(Sf,Wert,PRX_Pfad,PRX_File,LPR_Pfad,LPR_File)
        end if
* = 6
        if (Auswahl.EQ.6) then   ! Numerik
          call Menue_Numerik(Sf,SW,Wert)
        end if
* = 7
        if (Auswahl.EQ.7) then  ! Tracerparameter eingeben
          call Menue_Tracerparameter(Sf,Wert,MS_Name,SW)
        end if
* = 8
        if (Auswahl.EQ.8) then  ! Simulation
          call Start_Simulation(Sf,Plot,O_set,Menue,  ! Kontroll-Flags
     *                    Waits,Messwerte,            ! Messwerte
     *                    Titel,Wert,MS_Name,SW,      ! Daten
     *                    DAT_Pfad,DAT_File,          ! DAT
     *                    PAR_Pfad,PAR_File,          ! PAR
     *                    UMS_Pfad,UMS_File,          ! KIN
     *                    PHR_Pfad,PHR_File,          ! PHR
     *                    EXP_Pfad,EXP_File,          ! EXP
     *                    PRN_Pfad,PRN_File,          ! PRN
     *                    PRX_Pfad,PRX_File,          ! PRX
     *                    PRX_File_neu,               ! PRX
     *                    LPR_Pfad,LPR_File)          ! LPR

        end if
      end do         ! Ende Men

************************************************************************

      END            ! Ende des Hauptprogramms

************************************************************************
********************** Subroutinen *************************************
***********************************************************************

      Subroutine Namen

      call Maske_o('NoMenue')
      call Maske_m('Namen')

      call Editierdatum
      call Taste

      End

************************************************************************
************************************************************************
************************************************************************

      Subroutine Menue_System(DAT_Pfad,DAT_File,               ! DAT
     *                        PAR_Pfad,PAR_File,               ! PAR
     *                        UMS_Pfad,UMS_File,               ! KIN
     *                        PHR_Pfad,PHR_File,               ! PHR
     *                        EXP_Pfad,EXP_File,               ! EXP
     *                        PRN_Pfad,PRN_File,               ! PRN
     *                        PRX_Pfad,PRX_File,               ! PRX
     *                        PRX_File_neu,                    ! PRX
     *                        LPR_Pfad,LPR_File)               ! LPR

***********************************************************************

      Integer*2      Auswahl1, Auswahl2  ! Menauswahl

      Character*12   DAT_File            ! Dateiname
      Character*12   PAR_File            ! Dateiname
      Character*12   EXP_File            ! Dateiname
      Character*12   PRN_File            ! Dateiname
      Character*12   PRX_File            ! Dateiname
      Character*12   PRX_File_neu        ! Dateiname
      Character*12   UMS_File            ! Dateiname
      Character*12   PHR_File            ! Dateiname
      Character*12   LPR_File            ! Dateiname

      Character*30   DAT_Pfad            ! Pfad fr DAT-File
      Character*30   PAR_Pfad            ! Pfad fr PAR-File
      Character*30   EXP_Pfad            ! Pfad fr EXP-File
      Character*30   PRN_Pfad            ! Pfad fr PRN-File
      Character*30   PRX_Pfad            ! Pfad fr PRX-File
      Character*30   UMS_Pfad            ! Pfad fr KIN-File
      Character*30   PHR_Pfad            ! Pfad fr PHR-File
      Character*30   LPR_Pfad            ! Pfad fr PHR-File

***********************************************************************

      call Menue_m('Menue1',Auswahl1)
      call Maske_o('NoMenue')

      if (Auswahl1.EQ.1) then
        call Namen
      end if

      if (Auswahl1.EQ.2) then
        Auswahl2 = 1
        do while (Auswahl2.GT.0)
          call Maske_m('EditPfad')
          call Schreibe_Pfad(31,9,DAT_Pfad)
          call Schreibe_Pfad(31,10,PAR_Pfad)
          call Schreibe_Pfad(31,11,UMS_Pfad)
          call Schreibe_Pfad(31,12,PHR_Pfad)
          call Schreibe_Pfad(31,13,EXP_Pfad)
          call Schreibe_Pfad(31,14,PRN_Pfad)
          call Schreibe_Pfad(31,15,PRX_Pfad)
          call Schreibe_Pfad(31,16,LPR_Pfad)

          call Menue_o('Menue_P',Auswahl2)

          if (Auswahl2.EQ.1)  call Edit_Pfad(31,9,DAT_Pfad)
          if (Auswahl2.EQ.2)  call Edit_Pfad(31,10,PAR_Pfad)
          if (Auswahl2.EQ.3)  call Edit_Pfad(31,11,UMS_Pfad)
          if (Auswahl2.EQ.4)  call Edit_Pfad(31,12,PHR_Pfad)
          if (Auswahl2.EQ.5)  call Edit_Pfad(31,13,EXP_Pfad)
          if (Auswahl2.EQ.6)  call Edit_Pfad(31,14,PRN_Pfad)
          if (Auswahl2.EQ.7)  call Edit_Pfad(31,15,PRX_Pfad)
          if (Auswahl2.EQ.8)  call Edit_Pfad(31,16,LPR_Pfad)
        end do
      end if

      if (Auswahl1.EQ.3) then
        call Setze_Pfade(1,                               ! wer ruft ?
     *                   DAT_Pfad,DAT_File,               ! DAT
     *                   PAR_Pfad,PAR_File,               ! PAR
     *                   UMS_Pfad,UMS_File,               ! UMS
     *                   PHR_Pfad,PHR_File,               ! PHR
     *                   EXP_Pfad,EXP_File,               ! EXP
     *                   PRN_Pfad,PRN_File,               ! PRN
     *                   PRX_Pfad,PRX_File,               ! PRX
     *                   PRX_File_neu,                    ! PRX
     *                   LPR_Pfad,LPR_File)               ! LPR
        call Loesche_Datei('COTAM.WRK')
      end if

      if (Auswahl1.EQ.4) then
        call Schreibe_INI_File(1,                         ! wer ruft ?
     *                         DAT_Pfad,DAT_File,         ! DAT
     *                         PAR_Pfad,PAR_File,         ! PAR
     *                         UMS_Pfad,UMS_File,         ! KIN
     *                         PHR_Pfad,PHR_File,         ! PHR
     *                         EXP_Pfad,EXP_File,         ! EXP
     *                         PRN_Pfad,PRN_File,         ! PRN
     *                         PRX_Pfad,PRX_File,         ! PRX
     *                         LPR_Pfad,LPR_File)         ! LPR
        call Loesche_Datei('COTAM.WRK')
      end if

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Edit_Pfad(Spalte,Zeile,Pfad)

************************************************************************

      Integer*2      IC                  ! Checkflag
      Integer*2      Spalte, Zeile       ! Zellenzeiger
      Integer*2      p                   ! Dummy

      Character*3    Laufwerk            ! Laufwerksbuchstabe
      Character*30   Pfad                ! zu editierender Pfad
      Character*30   Pfad_alt            ! alter Pfad
      Character*33   Dummy               ! Dummy
      Character*42   Pfad_Dummy          ! Dummy

************************************************************************

      Laufwerk   = Pfad(1:3)
      Pfad_alt   = Pfad
      Dummy      = ' '

      call Lies_Text(Pfad,Spalte,Zeile,112,IC)

      if (IC.LT.0) then
        call Aktuelles_Verzeichnis(Pfad_Dummy)
        Pfad = Pfad_Dummy(1:30)
        p    = INDEX(Pfad,' ')
        if (p.LE.30)  Pfad(p:p) = '\'
      else
        call Gross(Pfad)
        call Links(Pfad)
        if (Pfad(1:1).EQ.'\')  call Schiebe_Zeichen(Pfad,1)
        if (Pfad(2:2).NE.':') then
          Dummy(1:3)  = Laufwerk(1:3)
          Dummy(4:33) = Pfad(1:30)
          Pfad(1:30)  = Dummy(1:30)
        end if
        p = INDEX(Pfad,' ') - 1
        if ((p.GT.3) .AND. (p.LE.29)) then
          if (Pfad(p:p).NE.'\')  Pfad(p+1:p+1) = '\'
        end if
        if ((p.GE.0) .AND. (p.LE.3))   Pfad = Pfad_alt
        if (p.EQ.-1)  Pfad(30:30) = '\'

        call Lege_Verzeichnis_an(Pfad,IC)

        if (IC.EQ.3) then
          call Maske_o('NoMenue')
          call Maske_m('Warnung3')
          call Taste
          Pfad = Pfad_alt
        end if
      end if

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Menue_Datei(Sf,                         ! Speicher-Flag
     *                       Messwerte,                  ! Messwerte
     *                       Titel,Wert,MS_Name,SW,      ! Daten
     *                       Anzahl_MS_g,                ! # MS
     *                       DAT_Pfad,DAT_File,          ! DAT
     *                       PAR_Pfad,PAR_File,          ! PAR
     *                       UMS_Pfad,UMS_File,          ! UMS
     *                       PHR_Pfad,PHR_File,          ! PHR
     *                       EXP_Pfad,EXP_File,          ! EXP
     *                       PRN_Pfad,PRN_File,          ! PRN
     *                       PRX_Pfad,PRX_File,          ! PRX
     *                       PRX_File_neu,               ! PRX
     *                       LPR_Pfad,LPR_File)          ! LPR

************************************************************************

      Include 'nt.inc'
      Include 'nmess.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)       ! # der Eingabeparameter

************************************************************************

      Integer*2      Auswahl             ! Menauswahl
      Integer*2      Sf                  ! Daten schon gespeichert ?
      Integer*2      Status              ! Daten korrekt ?
      Integer*2      Anzahl_MS_g         ! # der gesetzten Masterspezies

      Real           SW(11,nT)           ! Sorptionsparameter
      Real           Wert(Anzahl)        ! Datenvektor
      Real           Messwerte(nmess,4)  ! Messwerte

      Character*10   MS_Name(nT)         ! Namen der Masterspezies
      Character*37   Titel(2)            ! Datensatz-Titel

      Character*12   DAT_File            ! Dateiname
      Character*12   PAR_File            ! Dateiname
      Character*12   EXP_File            ! Dateiname
      Character*12   PRN_File            ! Dateiname
      Character*12   PRX_File            ! Dateiname
      Character*12   PRX_File_neu        ! Dateiname
      Character*12   UMS_File            ! Dateiname
      Character*12   PHR_File            ! Dateiname
      Character*12   LPR_File            ! Dateiname

      Character*30   DAT_Pfad            ! Pfad fr DAT-File
      Character*30   PAR_Pfad            ! Pfad fr PAR-File
      Character*30   EXP_Pfad            ! Pfad fr EXP-File
      Character*30   PRN_Pfad            ! Pfad fr PRN-File
      Character*30   PRX_Pfad            ! Pfad fr PRX-File
      Character*30   UMS_Pfad            ! Pfad fr KIN-File
      Character*30   PHR_Pfad            ! Pfad fr PHR-File
      Character*30   LPR_Pfad            ! Pfad fr PHR-File

************************************************************************

      call Menue_m('Menue2',Auswahl)
* = 1
      if (Auswahl.EQ.1) then
        Status = 1
        call Maske_o('NoMenue')
        call Daten_laden(Status,Titel,Wert,MS_Name,SW,
     *                   DAT_Pfad,DAT_File)
        call Del_Mess(Messwerte)
        call Loesche_Datei('COTAM.WRK')

        PAR_File = 'NONAME.PAR'  ! Kein Name eingegeben
        UMS_File = 'NONAME.UMS'  ! Kein Name eingegeben
        PHR_File = 'NONAME.PHR'  ! Kein Name eingegeben
        EXP_File = 'NONAME.EXP'  ! Kein Name eingegeben
        PRN_File = 'NONAME.PRN'  ! Kein Name eingegeben
        PRX_File = 'NONAME.PRX'  ! Kein Name eingegeben
        Wert(9)  = 0.
        Sf       = 1
      end if
* = 2
      if (Auswahl.EQ.2) then
        call Maske_o('NoMenue')
        call Daten_speichern(Titel,Wert,MS_Name,SW,DAT_Pfad,DAT_File)
        Sf = 1
      end if
* = 3
      if (Auswahl.EQ.3) then
        call Maske_o('NoMenue')
        call PAR_Filename(PAR_Pfad,PAR_File)
      end if
* = 4
      if (Auswahl.EQ.4) then
        call Maske_o('NoMenue')
        call Daten_korrekt(3,Wert,SW,Status)
        if (Status.NE.-1) then
          call PAR_File_erstellen(Wert,SW,PAR_Pfad,PAR_File)
        end if
      end if
* = 5
      if (Auswahl.EQ.5) then
        call Maske_o('NoMenue')
        call UMS_Filename(UMS_Pfad,UMS_File)
      end if
* = 6
      if (Auswahl.EQ.6) then
        call Maske_o('NoMenue')
        call Daten_korrekt(4,Wert,SW,Status)
        if (Status.NE.-1) then
          call UMS_File_erstellen(Wert,SW,Anzahl_MS_g,
     *                            PAR_Pfad,PAR_File,
     *                            UMS_Pfad,UMS_File)
        end if
      end if
* = 7
      if (Auswahl.EQ.7) then
        call Maske_o('NoMenue')
        call PHR_Filename(PHR_Pfad,PHR_File)
      end if
* = 8
      if (Auswahl.EQ.8) then
        Status = 1
        call Messwerte_laden(Status,Messwerte,EXP_Pfad,EXP_File)
        call Loesche_Datei('COTAM.WRK')
      end if
* = 9
      if (Auswahl.EQ.9) then
        call Maske_o('NoMenue')
        call Messwerte_speichern(Messwerte,EXP_Pfad,EXP_File)
      end if
* = 10
      if (Auswahl.EQ.10) then
        call Messwerte_editieren(Messwerte)
      end if
* = 11
      if (Auswahl.EQ.11) then
        call Maske_o('NoMenue')
        PRX_File = DAT_File
        LPR_File = DAT_File
        call Setze_Extension(PRX_File,'.PRX')
        call Setze_Extension(LPR_File,'.LPR')
        call Export_PRX_to_LOTUS(Wert,SW,
     *                           PRX_Pfad,PRX_File,
     *                           LPR_Pfad,LPR_File)
      end if
* = 12
      if (Auswahl.EQ.12) then  ! Programmende
        PRX_File = PRX_File_neu
        call Programmende(Sf,Titel,Wert,MS_Name,SW,   ! Daten
     *                    DAT_Pfad,DAT_File,          ! DAT
     *                    PAR_Pfad,PAR_File,          ! PAR
     *                    UMS_Pfad,UMS_File,          ! KIN
     *                    PHR_Pfad,PHR_File,          ! PHR
     *                    EXP_Pfad,EXP_File,          ! EXP
     *                    PRN_Pfad,PRN_File,          ! PRN
     *                    PRX_Pfad,PRX_File,          ! PRX
     *                    LPR_Pfad,LPR_File)          ! LPR
      end if

      END

************************************************************************
************************************************************************
************************************************************************
*                                                                      *
*       Programm zum Eingeben von Medaten.                            *
*                                                                      *
*       Programmautor : Rainer Sieger, Universitt Bremen, FB5         *
*                                                                      *
*       letztes Editierdatum : 06-Juli-1992                            *
*                                                                      *
************************************************************************

      Subroutine Messwerte_editieren(Messwert)

************************************************************************

      Include 'nmess.inc'

************************************************************************

      integer*2     n_MW                         ! # der Messwerte
      integer*2     Zeile, Spalte                ! Zeile, Spalte
      integer*2     Z                            ! Zeichen (ASCII)
      integer*2     i                            ! Zeiger
      integer*2     Format                       ! 1=C(t), 2=C(x)

      real          Messwert(nmess,4)            ! Messwerte
      real          a(nmess)                     ! Dummy
      real          b(nmess)                     ! Dummy
      real          Max_Wert                     ! Dummy

************************************************************************

      n_MW = 0
      call Menue_m('Messwert',Format)
      call Maske_o('NoMenue')
      if (Format.EQ.1) then
        n_MW = NINT(Messwert(1,1))
        call Maske_o('Edit_t')
      end if
      if (Format.EQ.2) then
        n_MW = NINT(Messwert(1,3))
        call Maske_o('Edit_x')
      end if

************************************************************************
*     Ausgabe bereits eingegbener Werte

      if (Format.GE.1) then
        if (Format.EQ.1) then
          do i=1,n_MW
            a(i) = Messwert(i+1,1)
            b(i) = Messwert(i+1,2)
          end do
        else
          do i=1,n_MW
            a(i) = Messwert(i+1,3)
            b(i) = Messwert(i+1,4)
          end do
        end if

        do i=1,Min(n_MW,49)
          if ((i.GE.1) .AND. (i.LE.17)) then
            Zeile  = i + 4
            Spalte = 9
          end if
          if ((i.GE.18) .AND. (i.LE.34)) then
            Zeile  = i - 13
            Spalte = 34
          end if
          if ((i.GE.35) .AND. (i.LE.49)) then
            Zeile  = i - 30
            Spalte = 59
          end if
          call gotoxy(Spalte,Zeile)
          write(*,'(F5.1)') a(i)
          call Schreibe_Wert(Spalte+7,Zeile,b(i))
        end do

        if (Format.EQ.1) then
          if (Messwert(1,2).LE.0.0) then
            Max_Wert = 0.0
            do i=1,n_MW
              Max_Wert = MAX(Max_Wert,Messwert(i+1,2))
            end do
            Messwert(1,2) = Max_Wert
          end if
          call Schreibe_Wert(66,21,Messwert(1,2))
        else
          if (Messwert(1,4).LE.0.0) then
            Max_Wert = 0.0
            do i=1,n_MW
              Max_Wert = MAX(Max_Wert,Messwert(i+1,4))
            end do
            Messwert(1,4) = Max_Wert
          end if
          call Schreibe_Wert(66,21,Messwert(1,4))
        end if

************************************************************************
*       Eingabe neuer Werte

        Max_Wert = 0.0
        do while (n_MW.LT.17)
          n_MW = n_MW + 1
          call gotoxy(9,n_MW+4)
          read(*,*,ERR=1) a(n_MW)
          call gotoxy(9,n_MW+4)
          write(*,'(F5.1)') a(n_MW)
          call gotoxy(16,n_MW+4)
          read(*,*,ERR=1) b(n_MW)
          call Schreibe_Wert(16,n_MW+4,b(n_MW))
          Max_Wert = MAX(Max_Wert,b(n_MW))
          call Schreibe_Wert(66,21,Max_Wert)
        end do
        do while (n_MW.LT.34)
          n_MW = n_MW + 1
          call gotoxy(34,n_MW-13)
          read(*,*,ERR=1) a(n_MW)
          call gotoxy(34,n_MW-13)
          write(*,'(F5.1)') a(n_MW)
          call gotoxy(41,n_MW-13)
          read(*,*,ERR=1) b(n_MW)
          call Schreibe_Wert(41,n_MW-13,b(n_MW))
          Max_Wert = MAX(Max_Wert,b(n_MW))
          call Schreibe_Wert(66,21,Max_Wert)
        end do
        do while (n_MW.LT.49)
          n_MW = n_MW + 1
          call gotoxy(59,n_MW-30)
          read(*,*,ERR=1) a(n_MW)
          call gotoxy(59,n_MW-30)
          write(*,'(F5.1)') a(n_MW)
          call gotoxy(66,n_MW-30)
          read(*,*,ERR=1) b(n_MW)
          call Schreibe_Wert(66,n_MW-30,b(n_MW))
          Max_Wert = MAX(Max_Wert,b(n_MW))
          call Schreibe_Wert(66,21,Max_Wert)
        end do

    1   if ((n_MW.GE.1) .AND. (n_MW.LE.17)) then
          call loesch_zeile(9,n_MW+4,5)
          write(*,'(A)') ' '
          call loesch_zeile(16,n_MW+4,10)
          write(*,'(A)') ' '
          n_MW = n_MW - 1
        end if
        if ((n_MW.GE.18) .AND. (n_MW.LE.34)) then
          call loesch_zeile(34,n_MW-13,5)
          write(*,'(A)') ' '
          call loesch_zeile(41,n_MW-13,10)
          write(*,'(A)') ' '
          n_MW = n_MW - 1
        end if
        if ((n_MW.GE.35) .AND. (n_MW.LT.49)) then
          call loesch_zeile(59,n_MW-30,5)
          write(*,'(A)') ' '
          call loesch_zeile(66,n_MW-30,10)
          write(*,'(A)') ' '
          n_MW = n_MW - 1
        end if

        if (Format.EQ.1) then
          if (Messwert(1,2).LE.0.0)  Messwert(1,2) = Max_Wert
        else
          if (Messwert(1,4).LE.0.0)  Messwert(1,4) = Max_Wert
        end if

    2   z = 110
        do while ((z.EQ.110) .OR. (z.EQ.78))
          call loesch_zeile(3,23,70)
          write(*,'(A\)') 'Alles korrekt ? (j/n) '
          call Lies_Zeichen(Z)
          if ((Z.EQ.110) .OR. (Z.EQ.78)) then
            call loesch_zeile(3,23,50)
            write(*,'(A,$)') 'Datenpaar ? '
            write(*,'(A,$)') '(Alles lschen = 0; Normierung = -1) : '
            read(*,'(I2)',ERR=2) i

            if ((i.GE.1) .AND. (i.LE.17)) then
              Zeile  = i + 4
              Spalte = 9
            end if
            if ((i.GE.18) .AND. (i.LE.34)) then
              Zeile  = i - 13
              Spalte = 34
            end if
            if ((i.GE.35) .AND. (i.LE.49)) then
              Zeile  = i - 30
              Spalte = 59
            end if

    3       if ((i.LE.n_MW+1) .AND. (i.GT.0) .AND. (i.LE.49)) then
              call loesch_zeile(Spalte,Zeile,5)
              read(*,*,ERR=3) a(i)
              call gotoxy(Spalte,Zeile)
              write(*,'(F5.1)') a(i)
              call loesch_zeile(Spalte+7,Zeile,10)
              read(*,*,ERR=3) b(i)
              call Schreibe_Wert(Spalte+7,Zeile,b(i))
              Max_Wert = MAX(Max_Wert,b(n_MW))
              call Schreibe_Wert(66,21,Max_Wert)
              if (Format.EQ.1) then
                if (Messwert(1,2).LE.0.0)  Messwert(1,2) = Max_Wert
              else
                if (Messwert(1,4).LE.0.0)  Messwert(1,4) = Max_Wert
              end if
            end if

    4       if (i.EQ.-1) then
              if (Format.EQ.1) then
                call loesch_zeile(66,21,10)
                read(*,*,ERR=4) Messwert(1,2)
                call Schreibe_Wert(66,21,Messwert(1,2))
              else
                call loesch_zeile(66,21,10)
                read(*,*,ERR=4) Messwert(1,4)
                call Schreibe_Wert(66,21,Messwert(1,4))
              end if
            end if

            if (i.EQ.0) then
              do i=1,n_MW
                a(i) = 0.0
                b(i) = 0.0
              end do
              n_MW = 0
              z    = 0
              if (Format.EQ.1) then
                Messwert(1,2) = 0.0
              else
                Messwert(1,4) = 0.0
              end if
            end if
          end if
        end do

        if (Format.EQ.1) then
          Messwert(1,1) = FLOAT(n_MW)
          do i=1,n_MW
            Messwert(i+1,1) = a(i)
            Messwert(i+1,2) = b(i)
          end do
        else
          Messwert(1,3) = FLOAT(n_MW)
          do i=1,n_MW
            Messwert(i+1,3) = a(i)
            Messwert(i+1,4) = b(i)
          end do
        end if
      end if

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Menue_Saeule(Sf,Titel,Wert)

************************************************************************

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)       ! # der Eingabeparameter

      Integer*2      Sf                  ! Daten schon gespeichert ?
      Integer*2      Auswahl             ! Menauswahl
      Integer*2      IC                  ! Fehlerflag
      Real           Wert(Anzahl)        ! Datenvektor
      Character*37   Titel(2)            ! Datensatz-Titel

************************************************************************

      call Maske_m('vor_M3')

      call gotoxy(39,2)
      if (Wert(15).LT.1.) write(*,'(A)') 'Grundwasser'
      if (Wert(15).GE.1.) write(*,'(A)') 'marine Fragestellungen'
      call Schreibe_Wert(39,4,Wert(1))
      call Schreibe_Wert(39,5,Wert(2))
      call Schreibe_Wert(39,6,Wert(3))
      call Schreibe_Text(39,8,Titel(1))
      call Schreibe_Text(39,9,Titel(2))

      Auswahl = 1
      do while (Auswahl.GT.0)
        call Menue_o('Menue3',Auswahl)
* = 1
        if (Auswahl.EQ.1) then
          Sf = 0
          Wert(15) = Wert(15) + 1.
          if (Wert(15).GT.1.)  Wert(15) = 0.
          call loesch_zeile(39,2,22)
          if (Wert(15).LT.1.) write(*,'(A)') 'Grundwasser'
          if (Wert(15).GE.1.) write(*,'(A)') 'marine Fragestellungen'
        end if
* = 2
        if (Auswahl.EQ.2) then
          call Wert_einlesen(Sf,39,4,10,Wert(1))   ! Dichte
        end if
* = 3
        if (Auswahl.EQ.3) then
          call Wert_einlesen(Sf,39,5,10,Wert(2))   ! Porositt
        end if
* = 4
        if (Auswahl.EQ.4) then
          call Wert_einlesen(Sf,39,6,10,Wert(3))   ! Sulenlnge
        end if
* = 5
        if (Auswahl.EQ.5) then
          Sf = 0
          call Lies_Text(Titel(1),39,8,112,IC)
          if (IC.LT.0) Titel(1) = ' '
          call Schreibe_Text_unterlegt(Titel(1),112,39,8)
        end if
* = 6
        if (Auswahl.EQ.6) then
          Sf = 0
          call Lies_Text(Titel(2),39,9,112,IC)
          if (IC.LT.0) Titel(2) = ' '
          call Schreibe_Text_unterlegt(Titel(2),112,39,9)
        end if
      end do

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Menue_Hydrodynamik(Sf,Wert)

************************************************************************

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)       ! # der Eingabeparameter

      Integer*2      Sf                  ! Daten schon gespeichert ?
      Integer*2      Auswahl             ! Menauswahl
      Real           Wert(Anzahl)        ! Datenvektor

************************************************************************

      if (Wert(15).LT.1.) then
        call Maske_m('vor_M4')
        call Schreibe_Wert(56,2,Wert(4))
        call Schreibe_Wert(56,3,Wert(5))
        call Schreibe_Wert(56,4,Wert(6))
      else
        call Maske_m('vor_M4S')
        call Schreibe_Wert(54,2,Wert(4))
        call Schreibe_Wert(54,3,Wert(6))
      end if

      Auswahl = 1
      do while (Auswahl.GT.0)
        if (Wert(15).LT.1.) then
          call Schreibe_Wert(56,6,Wert(4)*Wert(5)+Wert(6))
          call Menue_o('Menue4',Auswahl)
        else
          call Menue_o('Menue4S',Auswahl)
        end if
* = 1
        if (Auswahl.EQ.1) then
          if (Wert(15).LT.1.) then
            call Wert_einlesen(Sf,56,2,10,Wert(4)) ! Va
          else
            call Wert_einlesen(Sf,54,2,10,Wert(4)) ! w
          end if
        end if
* = 2
        if (Auswahl.EQ.2) then
          if (Wert(15).LT.1.) then
            call Wert_einlesen(Sf,56,3,10,Wert(5)) ! Dispersivitt
            if (Wert(11).LE.0.D0)  Wert(11) = Wert(5)
          else
            call Wert_einlesen(Sf,54,3,10,Wert(6)) ! Diff.koeff.
          end if
        end if
* = 3
        if (Auswahl.EQ.3) then
          call Wert_einlesen(Sf,56,4,10,Wert(6)) ! Diffusionskoeff.
        end if
      end do

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Menue_Zeit(Sf,Wert,PRX_Pfad,PRX_File,LPR_Pfad,LPR_File)

************************************************************************

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)       ! # der Eingabeparameter

      Integer*2      Sf                  ! Daten schon gespeichert ?
      Integer*2      Auswahl             ! Menauswahl
      Integer*2      Format              ! Welches Dateiformat ?

      Real           Wert(Anzahl)        ! Datenvektor

      Character*12   PRX_File            ! Dateiname
      Character*12   LPR_File            ! Dateiname
      Character*30   PRX_Pfad            ! Pfad fr PRX-File
      Character*30   LPR_Pfad            ! Pfad fr LPR-File

************************************************************************

      Format = IFIX(Wert(9))
      call Maske_m('vor_M5')

      if (Wert(10).LE.0.)  Wert(10) = Wert(8)
      if (Wert(8).LT.Wert(10))  Wert(8) = Wert(10)
      call Schreibe_Wert(48,2,Wert(7))
      call Schreibe_Wert(48,3,Wert(8))
      call gotoxy(48,4)
      if (Format.EQ.0)  write(*,'(A,$)') 'nein        '
      if (Format.EQ.1)  write(*,'(A,$)') PRX_File(1:12)
      if (Format.EQ.2)  write(*,'(A,$)') LPR_File(1:12)

      Auswahl = 1
      do while (Auswahl.GT.0)
        call Menue_o('Menue5',Auswahl)
* = 1
        if (Auswahl.EQ.1) then
          call Wert_einlesen(Sf,48,2,10,Wert(7))   ! t_max
        end if
* = 2
        if (Auswahl.EQ.2) then
          call Wert_einlesen(Sf,48,3,10,Wert(8))   ! dt_Ausgabe
          if (Wert(10).LE.0.D0)  Wert(10) = Wert(8)
          call gotoxy(1,2)
          if (Wert(8).LT.Wert(10)) then
            Wert(8) = Wert(10)
            call Warnung('Warnung4',1,2,0)
          end if
          call Schreibe_Wert(48,3,Wert(8))
        end if
* = 3
        if (Auswahl.EQ.3) then
          if (Format.EQ.0) then
            call Save_Screen(2)
            call Menue_m('PRXORLPR',Format)
            if (Format.EQ.1) then
              call Maske_o('NoMenue')
              call PRX_Filename(PRX_Pfad,PRX_File)
              call Restore_Screen(2)
              call gotoxy(48,4)
            end if
            if (Format.EQ.2) then
              call Maske_o('NoMenue')
              call LPR_Filename(LPR_Pfad,LPR_File)
              call Restore_Screen(2)
              call gotoxy(48,4)
            end if
            if ((PRX_File.NE.'NONAME.PRX') .OR.
     *          (LPR_File.NE.'NONAME.LPR')) then
              Wert(9) = FLOAT(Format)
              if (Format.EQ.1) then
                write(*,'(A,$)') PRX_File(1:12)
              else
                write(*,'(A,$)') LPR_File(1:12)
              end if
            else
              Wert(9) = 0.
              write(*,'(A,$)') 'nein        '
            end if
          else
            Wert(9)  = 0.
            Format   = 0
            PRX_File = 'NONAME.PRX'
            LPR_File = 'NONAME.LPR'
            call gotoxy(48,4)
            write(*,'(A,$)') 'nein        '
          end if
        end if
      end do

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Menue_Numerik(Sf,SW,Wert)

************************************************************************

      Include 'nt.inc'
      Include 'nmax.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)       ! # der Eingabeparameter

      Integer*2      Sf                  ! Daten schon gespeichert ?
      Integer*2      Status              ! Daten korrekt ?
      Integer*2      Auswahl             ! Menauswahl
      Integer*2      n                   ! # der Zellen

      Real           Wert(Anzahl)        ! Datenvektor
      Real           SW(11,nT)           ! Sorptionsparameter

      Real           Peclet, Courant     ! Peclet-, Courantzahl
      Real           D                   ! Dispersionskoeffizient
      Real           Steps               ! # der Zeitschritte
      Real           AZ                  ! Anzahl der Zellen (Dummy)

************************************************************************

      call Daten_korrekt(5,Wert,SW,Status)
      if (Status.NE.-1) then
        call Maske_m('vor_M6')

        call Schreibe_Wert(59,2,Wert(10))  ! dt_num
        call Schreibe_Wert(59,3,Wert(11))  ! dx_num
        call Schreibe_Wert(59,4,Wert(12))  ! t_0
        call Schreibe_Wert(59,5,Wert(13))  ! Iter_max
        call Schreibe_Wert(59,6,Wert(14))  ! Epsilon

        Auswahl = 1
        do while (Auswahl.GT.0)
          AZ = Wert(3)/Wert(11)
          if (AZ.LT.32000) then
            n = NINT(AZ)
          else
            n = nmax+10
          end if
          D       = Wert(4)*Wert(5)+Wert(6)
          Peclet  = ABS(Wert(4)*Wert(11)/D)
          Courant = ABS(Wert(4)*Wert(10)/Wert(11))
          Steps   = Wert(7)/Wert(10)

          call Schreibe_Wert(59,8,Peclet)
          call Schreibe_Wert(59,9,Courant)
          call Schreibe_Wert(59,11,Steps)
          call Schreibe_Wert(59,12,FLOAT(n))

          call Menue_o('Menue6',Auswahl)
* = 1
          if (Auswahl.EQ.1) then
            call Wert_einlesen(Sf,59,2,10,Wert(10))    ! dt_num
            call gotoxy(1,2)
            if ((Wert(10).GT.Wert(8)) .AND. (Wert(8).GT.0.0)) then
              Wert(10) = Wert(8)  ! dt_num = dt_Ausgabe
              call Warnung('Warnung4',1,2,0)
              call Schreibe_Wert(59,2,Wert(10))
            end if
          end if
* = 2
          if (Auswahl.EQ.2) then
            call Wert_einlesen(Sf,59,3,10,Wert(11))   ! dz_num
            if (Wert(11).LE.0.0) then
              Wert(11) = Wert(5)   ! dz_num = Dispersivitt
              call Schreibe_Wert(59,3,Wert(11))
            end if
            AZ = Wert(3)/Wert(11)
            if (AZ.LT.32000) then
              n = NINT(AZ)
            else
              n = nmax
            end if
            if (n+2.GT.nmax) then
              Status = 1
              call Warnung('Warnung2',32,13,nmax-2)
            end if
          end if
* = 3
          if (Auswahl.EQ.3) then
            call Wert_einlesen(Sf,59,4,10,Wert(12))   ! t_0
          end if
* = 4
          if (Auswahl.EQ.4) then
            call Wert_einlesen(Sf,59,5,10,Wert(13))   ! Iter_max
          end if
* = 5
          if (Auswahl.EQ.5) then
            call Wert_einlesen(Sf,59,6,10,Wert(14))   ! Epsilon
            call Maschinengenauigkeit(Status,Wert(14))
            if (Status.LT.0) then
              call Schreibe_Wert(59,6,Wert(14))
            end if
          end if
        end do
      end if

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Menue_Tracerparameter(Sf,Wert,MS_Name,SW)

************************************************************************

      Include 'nt.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)      ! # der Eingabeparameter

      Integer*2      i, j               ! Laufvariable
      Integer*2      Aw                 ! Menauswahl
      Integer*2      Abbruch            ! Menauswahl abbrechen
      Integer*2      Sf                 ! Speicherflag
      Integer*2      Iso(nT)            ! Isotherme
      Integer*2      IC                 ! Fehlerflag

      Real           Wert(Anzahl)       ! Eingabeparameter
      Real           SW(11,nT)          ! Sorptionsparameter

      Character*10   MS_Name(nT)        ! Namen der Masterspezies

************************************************************************
*     Tracerstatusausgabe

      Abbruch = 1
      do while (Abbruch.GT.0)
        call Maske_m('vor_M7')
        do i=1,nT
          call Schreibe_MS_NAME(54,1+i,MS_Name(i))
          call gotoxy(65,1+i)
          if (SW(1,i).GE.1.) then
            write(*,'(A,$)') '     aktiv'
          else
            write(*,'(A,$)') '   inaktiv'
          end if
          if (SW(2,i).LE.0.)   SW(2,i)  = 3.0
          if (SW(10,i).LE.0.)  SW(10,i) = SW(3,i)
        end do

************************************************************************
*     Tracerparameterausgabe

        call Menue_o('Menue7',i)
        if (i.GT.0) then
          Abbruch = 2
        else
          Abbruch = 0
        end if

        do while (Abbruch.GT.1)
          Iso(i) = NINT(SW(2,i))
          if (Iso(i).EQ.1) then
            call Maske_o('Henry')
            call Maske_m('H_vor_M8')
          end if
          if (Iso(i).EQ.2) then
            call Maske_m('F_vor_M8')
          end if
          if (Iso(i).EQ.3) then
            call Maske_m('L_vor_M8')
          end if

          call gotoxy(28,3)
          if (SW(1,i).LE.0.0) then
            write(*,'(A,$)') '      nein'
          else
            write(*,'(A,$)') '        ja'
          end if
          call Schreibe_MS_NAME(28,6,MS_Name(i))   ! Name
          call Schreibe_Wert(28,7,SW(3,i))         ! C_in
* = 1
          if (Iso(i).GT.1) then
            call Schreibe_Wert(28,8,SW(4,i))     ! Rate 1
            call Schreibe_Wert(28,9,SW(5,i))     ! K oder P1
            call Schreibe_Wert(28,10,SW(6,i))    ! 1/n oder P2
            if (Iso(i).EQ.3) then
              call Schreibe_Wert(28,11,SW(7,i))  ! Rate 2
              call Schreibe_Wert(28,12,SW(8,i))  ! P3
              call Schreibe_Wert(28,13,SW(9,i))  ! P4
              call Schreibe_Wert(28,15,SW(10,i)) ! Normierungsfaktor
              call Schreibe_Wert(28,17,SW(11,i)) ! PHREEQE
            else
              call Schreibe_Wert(28,12,SW(10,i)) ! Normierungsfaktor
              call Schreibe_Wert(28,14,SW(11,i)) ! PHREEQE
            end if
          else
            call Schreibe_Wert(28,8,SW(5,i))     ! Kd
            call Schreibe_Wert(28,10,SW(10,i))   ! Normierungsfaktor
            call Schreibe_Wert(28,12,SW(11,i))   ! PHREEQE
          end if

************************************************************************
*     Men fr Parametereingabe

          Abbruch = 3
          do while (Abbruch.GT.2)
            if (Iso(i).EQ.1) then
              call Menue_o('H_Menue8',Aw)
            end if
            if (Iso(i).EQ.2) then
              call Menue_o('F_Menue8',Aw)
            end if
            if (Iso(i).EQ.3) then
              call Menue_o('L_Menue8',Aw)
            end if
* = 0
            if (Aw.EQ.0) Abbruch = 1 ! Ausstieg aus Parametermenue
* = 1
            if (Aw.EQ.1) then
              SW(1,i) = SW(1,i) + 1.
              if (SW(1,i).GT.1.)  SW(1,i) = 0.
              call gotoxy(28,3)
              if (SW(1,i).LE.0.0) then
                write(*,'(A,$)') '      nein'
              else
                write(*,'(A,$)') '        ja'
              end if
              Sf = 0
            end if
* = 2
            if (Aw.EQ.2) then
              Abbruch = 2
              SW(2,i) = SW(2,i) + 1.0
              if (SW(2,i).GT.3.0)  SW(2,i) = 1.0
              do j=4,9
                SW(j,i) = 0.0
              end do
              Sf = 0
            end if
* = 3
            if (Aw.EQ.3) then
              Sf = 0
              call Lies_Text(MS_Name(i),28,6,112,IC)
              if (IC.LT.0)  MS_Name(i) = ' '
              call Schreibe_Text_unterlegt(MS_Name(i),112,28,6)
            end if
* = 4
            if (Aw.EQ.4) then
              call Wert_einlesen(Sf,28,7,10,SW(3,i))
              if (SW(3,i).GT.0.0)  SW(10,i) = SW(3,i)
              if (SW(2,i).LE.1.0) then
                call Schreibe_Wert(28,10,SW(10,i))   ! Normierungsfaktor
              end if
              if ((SW(2,i).GE.2.0) .AND. (SW(2,i).LT.3.0)) then
                call Schreibe_Wert(28,12,SW(10,i))   ! Normierungsfaktor
              end if
              if (SW(2,i).GE.3.0) then
                call Schreibe_Wert(28,15,SW(10,i))   ! Normierungsfaktor
              end if
            end if
* = 5
            if (Aw.EQ.5) then
              if (SW(2,i).LE.1.0) then
                call Wert_einlesen(Sf,28,8,10,SW(5,i))
                SW(4,i) = 0.0  ! egal
              else
                call Wert_einlesen(Sf,28,8,10,SW(4,i))
              end if
            end if
* = 6
            if (Aw.EQ.6) then
              if (SW(2,i).LE.1.0) then
                call Wert_einlesen(Sf,28,10,10,SW(10,i)) ! Normierung
                SW(6,i) = 0.0  ! egal
              else
                call Wert_einlesen(Sf,28,9,10,SW(5,i))
              end if
            end if
* = 7
            if (Aw.EQ.7) then
              if (SW(2,i).LE.1.0) then
                call Wert_einlesen(Sf,28,12,10,SW(11,i)) ! PHREEQE
              else
                call Wert_einlesen(Sf,28,10,10,SW(6,i))
              end if
            end if
* = 8
            if (Aw.EQ.8) then
              if (SW(2,i).GE.3.0) then
                call Wert_einlesen(Sf,28,11,10,SW(7,i))
              else
                call Wert_einlesen(Sf,28,12,10,SW(10,i))
              end if
            end if
* = 9
            if (Aw.EQ.9) then
              if (SW(2,i).GE.3.0) then
                call Wert_einlesen(Sf,28,12,10,SW(8,i))
              else
                call Wert_einlesen(Sf,28,14,10,SW(11,i))
              end if
            end if
* = 10
            if (Aw.EQ.10) call Wert_einlesen(Sf,28,13,10,SW(9,i))
* = 11
            if (Aw.EQ.11) call Wert_einlesen(Sf,28,15,10,SW(10,i))
* = 12
            if (Aw.EQ.12) call Wert_einlesen(Sf,28,17,10,SW(11,i))
          end do
        end do
      end do

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Start_Simulation(Sf,Plot,O_set,Menue, ! Kontroll-Flags
     *                    Waits,Messwerte,             ! Messwerte
     *                    Titel,Wert,MS_Name,SW,       ! Daten
     *                    DAT_Pfad,DAT_File,           ! DAT
     *                    PAR_Pfad,PAR_File,           ! PAR
     *                    UMS_Pfad,UMS_File,           ! KIN
     *                    PHR_Pfad,PHR_File,           ! PHR
     *                    EXP_Pfad,EXP_File,           ! EXP
     *                    PRN_Pfad,PRN_File,           ! PRN
     *                    PRX_Pfad,PRX_File,           ! PRX
     *                    PRX_File_neu,                ! PRX
     *                    LPR_Pfad,LPR_File)           ! LPR

************************************************************************

      Include 'nt.inc'
      Include 'nmess.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)       ! # der Eingabeparameter

************************************************************************

      Integer*2      Auswahl1, Auswahl2  ! Menauswahl
      Integer*2      Sf                  ! Daten schon gespeichert ?
      Integer*2      Plot                ! Sollen geplottet werden ?
      Integer*2      Status              ! Daten korrekt ?
      Integer*2      Waits               ! Warteschleife

      Real           SW(11,nT)           ! Sorptionsparameter
      Real           Wert(Anzahl)        ! Datenvektor
      Real           Messwerte(nmess,4)  ! Messwerte

      Character*10   MS_Name(nT)         ! Namen der Masterspezies
      Character*37   Titel(2)            ! Datensatz-Titel

      Character*12   DAT_File            ! Dateiname
      Character*12   PAR_File            ! Dateiname
      Character*12   EXP_File            ! Dateiname
      Character*12   PRN_File            ! Dateiname
      Character*12   PRX_File            ! Dateiname
      Character*12   PRX_File_neu        ! Dateiname
      Character*12   UMS_File            ! Dateiname
      Character*12   PHR_File            ! Dateiname
      Character*12   LPR_File            ! Dateiname

      Character*30   DAT_Pfad            ! Pfad fr DAT-File
      Character*30   PAR_Pfad            ! Pfad fr PAR-File
      Character*30   EXP_Pfad            ! Pfad fr EXP-File
      Character*30   PRN_Pfad            ! Pfad fr PRN-File
      Character*30   PRX_Pfad            ! Pfad fr PRX-File
      Character*30   UMS_Pfad            ! Pfad fr KIN-File
      Character*30   PHR_Pfad            ! Pfad fr PHR-File
      Character*30   LPR_Pfad            ! Pfad fr LPR-File

      Logical        O_set               ! PRN_File gesetzt ?
      Logical        Menue               ! Menue gewnscht ?

************************************************************************

      call Daten_korrekt(2,Wert,SW,Status)
      if (Status.EQ.1) then
        call Menue_m('Simula',Auswahl1)
        if (Auswahl1.EQ.1) then
          call Menue_m('Plot',Auswahl2)
          Plot = Auswahl2 + 1  ! = 2-5:GW  = 6:marine
        end if
        if (Auswahl1.EQ.2)  Plot = 7  ! Text
        if (Auswahl1.EQ.3)  Plot = 8  ! analytisch
        if (Auswahl1.NE.0) then
          if (Sf.EQ.0) then
           call Maske_o('NoMenue')
           call Daten_speichern(Titel,Wert,MS_Name,SW,
     *                          DAT_Pfad,DAT_File)
           Sf = 1
          end if

          if (.NOT. O_set)  PRN_File = DAT_File
          PRX_File_neu = PRN_File
          call Setze_Extension(PRN_File,'.PRN')
          call Setze_Extension(PRX_File_neu,'.PRX')

          if (Plot.NE.8) then  ! nicht analytisch
            call Save_Workfile(Plot,Menue,Waits,       ! Kontroll-Flag
     *                         Messwerte,              ! Messwerte
     *                         Titel,Wert,MS_Name,SW,  ! Daten
     *                         DAT_Pfad,DAT_File,      ! DAT
     *                         PAR_Pfad,PAR_File,      ! PAR
     *                         UMS_Pfad,UMS_File,      ! UMS
     *                         PHR_Pfad,PHR_File,      ! PHR
     *                         EXP_Pfad,EXP_File,      ! EXP
     *                         PRN_Pfad,PRN_File,      ! PRN
     *                         PRX_Pfad,PRX_File,      ! PRX
     *                         PRX_File_neu,           ! PRX
     *                         LPR_Pfad,LPR_File)      ! LPR
            call Simulation
          else
            call Tracerauswertung(Menue,Waits,
     *                            Messwerte,Wert,MS_Name,SW,Titel,
     *                            DAT_Pfad,DAT_File,PRN_Pfad,PRN_File,
     *                            PRx_Pfad,PRX_File_neu)
          end if
        end if
      end if

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Programmende(Sf,Titel,Wert,MS_Name,SW,   ! Daten
     *                        DAT_Pfad,DAT_File,          ! DAT
     *                        PAR_Pfad,PAR_File,          ! PAR
     *                        UMS_Pfad,UMS_File,          ! KIN
     *                        PHR_Pfad,PHR_File,          ! PHR
     *                        EXP_Pfad,EXP_File,          ! EXP
     *                        PRN_Pfad,PRN_File,          ! PRN
     *                        PRX_Pfad,PRX_File,          ! PRX
     *                        LPR_Pfad,LPR_File)          ! LPR

************************************************************************

      Include 'nt.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)       ! # der Eingabeparameter

      Integer*2      Sf                  ! Speicherflag

      Real           Wert(Anzahl)        ! Datenvektor
      Real           SW(10,nT)           ! Datenvektor

      Character*10   MS_Name(nT)         ! Masterspeziesname
      Character*37   Titel(2)            ! Datensatz-Titel

      Character*12   DAT_File            ! Dateiname
      Character*12   PAR_File            ! Dateiname
      Character*12   EXP_File            ! Dateiname
      Character*12   PRN_File            ! Dateiname
      Character*12   PRX_File            ! Dateiname
      Character*12   UMS_File            ! Dateiname
      Character*12   PHR_File            ! Dateiname
      Character*12   LPR_File            ! Dateiname

      Character*30   DAT_Pfad            ! Pfad fr DAT-File
      Character*30   PAR_Pfad            ! Pfad fr PAR-File
      Character*30   EXP_Pfad            ! Pfad fr EXP-File
      Character*30   PRN_Pfad            ! Pfad fr PRN-File
      Character*30   PRX_Pfad            ! Pfad fr PRX-File
      Character*30   UMS_Pfad            ! Pfad fr KIN-File
      Character*30   PHR_Pfad            ! Pfad fr PHR-File
      Character*30   LPR_Pfad            ! Pfad fr PHR-File

************************************************************************

      if (Sf.EQ.0) then
        call Piep
        call Maske_o('NoMenue')
        call Daten_speichern(Titel,Wert,MS_Name,SW,DAT_Pfad,DAT_File)
      end if

************************************************************************
*     Initialisierungs-File schreiben

      call Schreibe_INI_File(0,                          ! wer ruft ?
     *                       DAT_Pfad,DAT_File,          ! DAT
     *                       PAR_Pfad,PAR_File,          ! PAR
     *                       UMS_Pfad,UMS_File,          ! KIN
     *                       PHR_Pfad,PHR_File,          ! PHR
     *                       EXP_Pfad,EXP_File,          ! EXP
     *                       PRN_Pfad,PRN_File,          ! PRN
     *                       PRX_Pfad,PRX_File,          ! PRX
     *                       LPR_Pfad,LPR_File)          ! LPR

************************************************************************

      call cls
      call gotoxy(0,1)
      write(*,'(A)') 'CoTAM, Rainer Sieger, AWI Bremerhaven'

      Stop
      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Daten_korrekt(Aufruf,Wert,SW,Status)

************************************************************************

      Include 'nt.inc'
      Include 'nmax.inc'

      Integer*2       Anzahl
      Parameter      (Anzahl = 15)    ! # der Eingabeparameter

      Integer*2      i                ! Laufvariable
      Integer*2      Status           ! Daten korrekt ?
      Integer*2      Anzahl_MS        ! # der aktiven Masterspezies
      Integer*2      Anzahl_MS_g      ! # der gesetzten Masterspezies
      Integer*2      MS(nT)           ! aktive Masterspezies
      Integer*2      Aufruf           ! von wo kam der Aufruf

      Real           Wert(Anzahl)     ! Datenvektor
      Real           SW(11,nT)        ! Sorptionsparameter

************************************************************************

      Status = 1
      call Aktive_Masterspezies(SW,MS,Anzahl_MS,Anzahl_MS_g)
      if ((Anzahl_MS.EQ.0) .AND. (Aufruf.LE.2))  Status = -1
      do i=1,Anzahl_MS
        if ((SW(1,i).GT.0.0) .AND. (SW(10,i).LE.0.0))  Status = -1
      end do
      do i=1,3
        if (Wert(i).LE.0.) Status = -1
      end do
      if ((Wert(4).LE.0.) .And. (Wert(6).LE.0.)) Status = -1
      if ((Wert(4).GT.0.).And.(Wert(5).LE.0.).AND.(Wert(6).LE.0.)) then
        Status = -1
      end if
      do i=7,8
        if (Wert(i).LE.0.) Status = -1
      end do
      if (Wert(8).LT.Wert(10)) Status = -1
      do i=10,11
        if (Wert(i).LE.0.) Wert(i) = 1.
      end do
      if (Wert(12).LT.0.) Wert(12) = Wert(10)/100.
      if (Wert(13).LE.0.) Wert(13) = 12.
      if (Wert(14).LE.0.) Wert(14) = 1E-10
      if (NINT(Wert(3)/Wert(11))+2.GT.nmax) Status = -2

      if (Status.LT.1) then
        if (Aufruf.EQ.1) then
          call gotoxy(2,2)
          write(*,'(A,$)') 'Parameterfehler. Bitte korrigieren Sie die '
          write(*,'(A)')   'entsprechenden Parameter.'
        else
          call Warnung('Fehler1',1,2,0)
        end if
      end if

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Del_Mess(Messwerte)

************************************************************************

      Include 'nmess.inc'
      Integer*2   i, j
      Real        Messwerte(nmess,4) ! Messwerte

************************************************************************

      do i=1,nmess        ! Lschen aller Messwerte
        do j=1,4
          Messwerte(i,j) = 0.
        end do
      end do

      END

************************************************************************
************************************************************************
************************************************************************
*                                                                      *
*       Ermittlung der Maschinengenauigkeit                            *
*       aus: Engeln-Mllges (1988): Formelsammlung zur numerischen     *
*                                   Mathematik ....                    *
*                                                                      *
************************************************************************

      Subroutine Maschinengenauigkeit(Status,Epsilon)

************************************************************************

      integer     MASCHD
      integer     Status

      real*8      FMASCHN
      real        Epsilon

************************************************************************

      FMASCHN = 1.D0
      do while(MASCHD(1.D0 + FMASCHN).EQ.1)
        FMASCHN = 0.5D0 * FMASCHN
      end do
      FMASCHN = 2.D0 * FMASCHN
      if (FMASCHN.GT.Epsilon) then
        Status  = -1
        Epsilon = SNGL(FMASCHN)
      else
        Status  = 1
      end if

      END

************************************************************************

      Integer Function MASCHD(X)

      real*8   X

      MASCHD = 0
      if (1.D0 .LT. X)  MASCHD = 1

      end
