************************************************************************
*                                                                      *
*    Datei                                                             *
*      Dateiverwaltung.for                                             *
*                                                                      *
*    Inhalt                                                            *
*      Dateiname. Einlesen eines Dateinamens, Kontrolle ob Datei       *
*      schon existiert.                                                *
*      Wird aufgerufen in:                                             *
*         Daten_laden                                                  *
*         Daten_speichen                                               *
*         UMS_File_erstellen                                           *
*         PAR_File_erstellen                                           *
*         Messwerte_laden                                              *
*         Messwerte_speichern                                          *
*         Setze_Pfade                                                  *
*         Schreibe_INI_File                                            *
*         LPR_Filename                                                 *
*         UMS_Filename                                                 *
*         PHR_Filename                                                 *
*         PAR_Filename                                                 *
*         PRX_Filename                                                 *
*         Export_PRX_to_LOTUS                                          *
*                                                                      *
*      Verbinde_Pfad_Filename. Verbindet Pfad und Name zum voll-       *
*      stndigen Dateinamen.                                           *
*      Wird aufgerufen in:                                             *
*         Dateiname                                                    *
*         Redox                                                        *
*         Save_Workfile                                                *
*                                                                      *
*      Zerlege_Pfad_Filename. Zerlegt einen Dateinamen in Pfad und     *
*      tatschlichen Namen.                                            *
*      Wird aufgerufen in:                                             *
*         Dateiname                                                    *
*         Dateipfad                                                    *
*         Setze_Pfade                                                  *
*         Schreibe_INI_File                                            *
*         Load_Workfile                                                *
*                                                                      *
*      Setze_Extension. Fgt einem Dateinamen eine Dateiextension zu.  *
*      Wird aufgerufen in:                                             *
*         Main                                                         *
*         Menue_Datei                                                  *
*         Start_Simulation                                             *
*         Dateiname                                                    *
*         UMS_File_erstellen                                           *
*         PAR_File_erstellen                                           *
*         UMS_Daten_laden                                              *
*         Redox                                                        *
*                                                                      *
*      Dateipfad. Ermittelt den aktuellen Dateipfad.                   *
*      Wird aufgerufen in:                                             *
*         Setze_Pfade                                                  *
*         Schreibe_INI_File                                            *
*                                                                      *
*      Lege_Verzeichnis_an. Legt ein neues Verzeichnis an.             *
*      Wird aufgerufen in:                                             *
*         Edit_Pfad                                                    *
*         Dateiname                                                    *
*         Setze_Pfade                                                  *
*                                                                      *
*      Schiebe_Zeichen. Verschiebt Text in einem String.               *
*      Wird aufgerufen in:                                             *
*         Edit_Pfad                                                    *
*         Lege_Verzeichnis_an                                          *
*                                                                      *
************************************************************************
*                                                                      *
*    Copyright                                                         *
*      Der in dieser Datei enthaltene Quellcode darf ohne Genehmigung  *
*      und weitere Vergtung weiterentwickelt werden. Diese Copyright- *
*      Erklrung darf um eigene Urherberrechtserklrungen erweitert    *
*      werden. Die Verwendung dieses Quelltextes fr Publikationen     *
*      ist, auch bei auszugsweiser Verwendung, grundstzlich Genehmi-  *
*      gungspflichtig (kostet nix, ich wrdes halt nur gerne wissen).  *
*                                                                      *
*      Der Programmautor weist darauf hin, da Software nicht fehler-  *
*      frei zu erstellen ist. Die Korrektheit des Quellcodes ist da-   *
*      her auf geeignete Weise zu berprfen.                          *
*                                                                      *
************************************************************************
*                                                                      *
*    Programmautor                                                     *
*      Dr. Rainer Sieger                                               *
*      Alfred-Wegener-Institut fr Meeres- und Polarforschung          *
*      Postfach 12 01 61                                               *
*      27515 Bremerhaven                                               *
*      e-mail: rsieger@AWI-Bremerhaven.de                              *
*                                                                      *
************************************************************************
*                                                                      *
*    letztes Editierdatum                                              *
*      16.3.94                                                         *
*                                                                      *
************************************************************************

************************************************************************

      Subroutine Dateiname(Spalte,Zeile,Status,Extension,Pfad,Name)

************************************************************************
*                                                                      *
*     mit Zeile     : Zeile in der der Text steht (1..25)              *
*         Spalte    : Spalte in der der Text steht (1..60)             *
*         Status    : 0=Nur Existenz berprfen, 1=Laden,              *
*                     2=Speichern, -1=Fehler (Rckgabe)                *
*         Extension : Erweiterung des Dateinamens                      *
*         Pfad      : Dateipfad                                        *
*         Name      : Dateiname                                        *
*                                                                      *
************************************************************************

      Integer*2      Zeile, Spalte    ! Zeile und Spalte der Meldung
      Integer*2      Status           ! Status des Dateinamens
      Integer*2      Auswahl          ! Menauswahl
      Integer*2      i                ! Positionszeiger
      Integer*2      IC               ! Fehlerflag

      Character*6    Extension        ! Erweiterung des Dateinamens
      Character*12   Name             ! Dateiname
      Character*30   Pfad             ! Dateipfad
      Character*30   Pfad_alt         ! Dateipfad (alt)
      Character*35   Pfad_Extension   ! Dateipfad + Extension
      Character*42   Filename         ! vollstndiger Dateiname
      Character*42   Filename_alt     ! vollstndiger Dateiname (alt)

      Logical        Existent         ! Existiert die Datei ?
      Logical        Fehler           ! Ist ein Fehler aufgetreten ?

************************************************************************

      call Gross(Pfad)
      call Gross(Name)
      call Setze_Extension(Name,Extension(3:6))
      call Verbinde_Pfad_Filename(Pfad,Name,Filename)

      Pfad_alt              = Pfad
      Filename_alt          = Filename

      Pfad_Extension(1:30)  = Pfad
      Pfad_Extension(31:35) = '     '

      Fehler = .true.
      do while (Fehler)
        if (Status.EQ.0) then
          inquire(File=Filename, Exist=Existent)
          if (.NOT.Existent) Status = -1
          Fehler = .false.
        end if

************************************************************************
*       evtl. Aufruf des Fileselectors

        if (Status.GE.1) then
          Pfad_Extension(1:30) = Pfad
          i = INDEX(Pfad_Extension,'\ ')
          Pfad_Extension(i:i+5) = Extension(1:6)
          i = i+6
          do while (i.LE.35)
            Pfad_Extension(i:i) = ' '
            i = i+1
          end do

          if (Name(1:6).EQ.'NONAME') then
            Filename(1:35)  = Pfad_Extension
            Filename(36:42) = '      '
          end if

          call Lies_Text(Filename,Spalte,Zeile,112,IC)

          if (IC.GE.0) then
            call Cursor_off
            call gotoxy(1,3)
            write(*,'(A,$)') '  '
            call Gross(Filename)
            if (Filename.EQ.'S') then
              call Fileselector(Pfad_Extension,Filename)
              call Links(Filename)
            else
              if (NONBLK(Filename).GE.1) then
                call Zerlege_Pfad_Filename(Filename,Pfad,Name)
                call Setze_Extension(Name,Extension(3:6))
                if (NONBLK(Pfad).LE.0)  Pfad = Pfad_alt
                call Verbinde_Pfad_Filename(Pfad,Name,Filename)
              end if
            end if
          else
            Filename = ' '
          end if

          call gotoxy(Spalte,Zeile)
          write(*,'(A41,$)') Filename
          call cursor_on

************************************************************************

          if (NONBLK(Filename).LE.0) then   ! Kein Dateiname eingegeben
            Status = -1
            Fehler = .false.
          else                              ! Dateiname wurde eingegeben
            inquire(File=Filename, Exist=Existent)
            Fehler = .false.

************************************************************************
*   Laden, aber Datei existiert nicht

            if (Status.EQ.1) then
              if (.NOT.Existent) then
                call Save_Screen(1)
                call Menue_m('L_false',Auswahl)
                call Restore_Screen(1)
                if (Auswahl.EQ.1) then  ! Neuer Versuch
                  Fehler = .true.
                  Pfad   = Pfad_alt
                end if
                if ((Auswahl.EQ.2) .OR. (Auswahl.EQ.0)) then  ! Abbruch
                  Fehler =  .false.
                  Status = -1
                end if
              end if
            end if

************************************************************************
*   Speichern, aber Datei existiert schon

            if (Status.EQ.2) then
              if (Existent) then
                call Save_Screen(1)
                call Menue_m('S_false1',Auswahl)
                call Restore_Screen(1)
                if (Auswahl.EQ.1) then   ! Neuer Versuch
                  Fehler = .true.
                  Pfad   = Pfad_alt
                end if
                if (Auswahl.EQ.2) Fehler = .false.  ! berschreiben
                if ((Auswahl.EQ.3) .OR. (Auswahl.EQ.0)) then ! Abbruch
                  Fehler =  .false.
                  Status = -1
                end if
              else
                i = INDEX(Pfad,' ') - 2
                call Lege_Verzeichnis_an(Pfad,Status)
                if (Status.EQ.3) then
                  call Save_Screen(1)
                  call Menue_m('S_false2',Auswahl)
                  call Restore_Screen(1)
                  if (Auswahl.EQ.1) then   ! Neuer Versuch
                    Fehler = .true.
                    Pfad   = Pfad_alt
                  end if
                  if ((Auswahl.EQ.2) .OR. (Auswahl.EQ.0)) then ! Abbruch
                    Fehler =  .false.
                    Status = -1
                  end if
                end if
              end if
            end if
          end if
        end if
      end do

      if (Status.NE.-1) then
        call Zerlege_Pfad_Filename(Filename,Pfad,Name)
      else
        call Zerlege_Pfad_Filename(Filename_alt,Pfad,Name)
      end if

      call Gross(Pfad)
      call Gross(Name)

      End

***********************************************************************
***********************************************************************
***********************************************************************

      Subroutine Verbinde_Pfad_Filename(Pfad,Name,Filename)

***********************************************************************

      Integer*2      i, j             ! Positionszeiger

      Character*12   Name             ! Dateiname
      Character*30   Pfad             ! Dateipfad
      Character*42   Filename         ! vollstndiger Dateiname

***********************************************************************

      Filename = ' '
      i = INDEX(Pfad,' ') - 1
      j = INDEX(Name,' ') - 1
      if (j.LE.0)  j = 12
      if (i.GE.1)  Filename(1:i)     = Pfad(1:i)
      if (j.GE.1)  Filename(i+1:i+j) = Name(1:j)

      END

************************************************************************
************************************************************************
************************************************************************

      Subroutine Zerlege_Pfad_Filename(Filename,Pfad,Name)

************************************************************************

      Integer*2      p, q             ! Positionszeiger

      Character*12   Name             ! Dateiname
      Character*30   Pfad             ! Dateipfad
      Character*42   Filename         ! Dateipfad + Dateiname
      Character*42   Dummy, Dummy_neu ! Dummys

************************************************************************

      call Gross(Filename)
      call Links(Filename)

      Dummy = Filename
      Name  = ' '
      Pfad  = ' '

      p = INDEX(Dummy,'\') + 1
      q = p - 1
      do while ((p.GT.1) .AND. (p.LE.42))
        Dummy_neu = Dummy(p:42)
        call Links(Dummy_neu)
        Dummy = Dummy_neu
        p     = INDEX(Dummy,'\') + 1
        q     = q + p -1
      end do

      if (q.GE.1) then
        Pfad(1:q)  = Filename(1:q)
        Name(1:12) = Filename(q+1:MIN(42,q+13))
      else
        Name(1:12) = Filename(1:12)
      end if
      call Links(Name)

      End

************************************************************************
************************************************************************
************************************************************************

      Subroutine Setze_Extension(Filename,Extension)

************************************************************************

      Integer*2      i, j             ! Positionszeiger

      Character*4    Extension        ! Erweiterung des Dateinamens
      Character*12   Filename         ! Dateiname

************************************************************************

      call Gross(Filename)
      call Links(Filename)
      Filename = Filename(1:8)
      i        = INDEX(Filename,' ')
      j        = INDEX(Filename,'.')
      if (((i-j).LE.4).AND.(i.GT.1).AND.(j.GT.0)) then
        Filename(j:j+3) = Extension(1:4)
      end if
      if ((j.EQ.0).AND.(i.GT.1)) then
        Filename(i:i+3) = Extension(1:4)
      end if

      End

************************************************************************
************************************************************************
************************************************************************

      Subroutine Dateipfad(Pfad,Name,Extension)

      Integer*2      p                ! Positionszeiger

      Character*6    Extension        ! Dateierweiterung
      Character*12   Name             ! Dateiname
      Character*30   Pfad             ! Dateipfad
      Character*42   Filename         ! vollstndiger Dateiname

************************************************************************

      call Aktuelles_Verzeichnis(Filename)

      call Gross(Filename)
      call Links(Filename)

      p = INDEX(Filename,' ')
      if ((p.GE.0) .AND. (p.LE.46))  Filename(p:p+5) = Extension
      call Zerlege_Pfad_Filename(Filename,Pfad,Name)

      End

************************************************************************
************************************************************************
************************************************************************

      Subroutine Lege_Verzeichnis_an(Pfad,IC)

************************************************************************

      Integer*2      IC, ICM(15)         ! Checkflag
      Integer*2      p                   ! Verzeichnis
      Integer*2      i                   ! Zhler

      Character*8    Verzeichnis         ! Verzeichniss
      Character*11   Laufwerk            ! Laufwerk
      Character*30   Pfad                ! Pfad
      Character*30   CoTAM_Pfad          ! Pfad
      Character*30   Dummy               ! Dummy

************************************************************************

      call Aktuelles_Verzeichnis(CoTAM_Pfad) ! aktueller CoTAM-Pfad
      Laufwerk      = ' '
      Laufwerk(1:3) = Pfad(1:3)
      Dummy         = Pfad
      do i=1,15
        ICM(i) = 0
      end do

      p  = 1
      i  = 1
      IC = 0
      do while ((p.GT.0) .AND. (IC.NE.3))
        p = INDEX(Dummy,'\')
        if (p.GT.1) then
          Verzeichnis        = ' '
          Verzeichnis(1:p-1) = Dummy(1:p-1)
          if (i.EQ.2) then
            Laufwerk(4:11) = Verzeichnis(1:8)
            call MakeDirectory(Laufwerk,ICM(i))
          end if
          if (i.GT.2) then
            call MakeDirectory(Verzeichnis,ICM(i))
          end if
          call Schiebe_Zeichen(Dummy,p)
          IC = ICM(i)
          i  = i + 1
        end if
      end do

      call ATTACH(CoTAM_Pfad)   ! zurcksetzen auf CoTAM-Pfad

      do i=1,15
        if (ICM(i).EQ.3) IC = 3
      end do

      End

************************************************************************

      Subroutine Schiebe_Zeichen(Text,Anzahl)

************************************************************************

      Integer*2      Anzahl

      Character*(*)  Text

************************************************************************

      do i=1,Anzahl
        Text(i:i) = ' '
      end do
      call Links(Text)

      End
