C
C          **********************************************
C
C                         PROGRAM PHREEQE
C
C          D.L. PARKHURST, D.C. THORSTENSON, L.N. PLUMMER
C
C                VERSION CURRENT - JULY 1, 1990
C
C          **********************************************
C                   IBM PC Version Created by:
C                      John Tisaranni, USGS
C                        August 6, 1990
C              With screen output modifications by
C                       Pierre Glynn, USGS
C                        August 14, 1990
C          **********************************************
C
C
      INCLUDE 'PHREEQE.CM'
      real*8 DSI_rs(MAXLK)
      CHARACTER*15 FNAME
      INTEGER*2 IYR,IMON,IDAY,IHR,IMIN,ISEC
C
C         Three files are required by the program:  (1) input file,
C         (2) output file, and (3) data base.  The FORTRAN unit
C         numbers for these files are set at compile time by a
C         PARAMETER statement in the COMMON.BLOCKS file.
C         The parameters names and default settings are:
C         IR = 5, input file; IW = 6, output file; and IDB = 11,
C         data base.
C
C         The three files are NOT opened within the FORTRAN code.
C         Either (1) the files can be opened externally to the program
C         or (2) the FORTRAN code can be modified to include OPEN
C         statements.
C

      CALL CLRSCR()
1     WRITE(*,2)
2     FORMAT(20X,'Enter the Name of the INPUT File : ',/,20X,'--> ',$)
      READ(*,7) FNAME
      OPEN(IR,FILE = FNAME,STATUS = 'OLD',ERR = 91)
      GOTO 3
91    WRITE(*,'(20X,''Your INPUT file is not in the current directory!''
     $)')
      GOTO 1
C
3     WRITE(*,4)
4     FORMAT(20X,'Enter the Name of the OUTPUT File : ',/,20X,'--> ',$)
      READ(*,7) FNAME
      OPEN(IW,FILE = FNAME,STATUS = 'UNKNOWN',ERR = 3)
CCCCC THE FOLLOWING 4 LINES ARE SPECIFIC TO MICROSOFT FORTRAN 5.0
      CALL DATE(IYR,IMON,IDAY,IHR,IMIN,ISEC)
      WRITE(IW,92) IYR,IMON,IDAY,IHR,IMIN,ISEC
92    FORMAT(' Date of Simulation Run:',2X,I4,'/',I2.2,'/',I2.2,/,
     $' Time of Simulation Run:',2X,I2.2,':',I2.2,':',I2.2,/)
C
      OPEN(IDB,FILE = 'PHREEQE.DAT',ERR = 6)
      GOTO 9
6     WRITE(*,*)' DATABASE is not in the current directory, please plac'
     +'e PHREEQE.DAT in current directory and restart PHREEQE!!!!!!!'
      STOP
7     FORMAT(A15)
9     CALL CLRSCR()
      WRITE(*,8)
8     FORMAT(23X,'**<<Loading Program>>**')
      DMAX=10.0
      DMIN=0.7
      FUDGE=1D0
      RMAX=20.0
      RMIN=0.9D0
      CNVG1=0.1
      CNVG2=1.0D4
      ITMAX=200
      CHKMU=1D3
      DO 10 I=1,MAXS
      NSP(I)=0
   10 CONTINUE
      CALL RDATA
      CLOSE (UNIT=IDB)
   20 CONTINUE
C          SINGLE SIMULATION LOOP
      CALL READ
      ISTEP=0
C          SOLVE INITIAL SOLUTIONS
      DO 40 ISOL=1,2
      IF (ISOLV(ISOL).EQ.0) GO TO 40
      CALL SOLN
      IESPEC=IOPT(2)
      IF (IOPT(2).GE.2) IESPEC=0
      CALL PICK1
      CALL PTOT
      CALL KTEMP
      CALL MODEL
      IF (IOPT(2).LT.2) GO TO 30
      IESPEC=LNEG
      IF (ELECT.LT.0D0) IESPEC=LPOS
      CALL PICK1
      CALL KTEMP
      CALL MODEL
      TOTAL(ISOL,IESPEC)=TOT(IESPEC)
   30 CONTINUE
      IF (IASPEC.GT.0) TOTAL(ISOL,IASPEC)=TOT(IASPEC)
      CALL THORIT(T)
      TH(ISOL)=T
      THOR=T
      DIFFZ(ISOL)=ELECT
      CALL PSPEC
      CALL PLOOK
   40 CONTINUE
      do j=1,nrmins
        if (simin(j).LE.-99.) then
          call CDSI(DSI_rs)
          do i=1,nlooks
            if (NAMELK(i).EQ.'PCO2') simin(j) = dsi_rs(i)
          end do
          write(*,'(I3,2X,F10.3,2X,F10.3)') i, simin(i)
        end if
      end do
      IF (IOPT(3).EQ.0) GO TO 20
C          TAKE REACTION STEPS
      DO 50 ISTEP=1,MAX0(1,NSTEPS)
      CALL STEP
      CALL PTOT
      CALL PICK2
      CALL KTEMP
      CALL KMIN
      CALL MODEL
      CALL PPHASE
      CALL PLOOK
      CALL PTOT
      CALL PSPEC
   50 CONTINUE
      CALL SAVE
      GO TO 20
      END
C
      SUBROUTINE MODEL
      INCLUDE 'PHREEQE.CM'
      CALL ZEROAR
      CALL SET
      ITER=0
      JTER=0
   10 CONTINUE
      ITER=ITER+1
      CALL GAMMA
      CALL ZEROAR
      CALL AQMOD
      CALL CHECK(*30,*40,*10)
      CALL SOLVE
      CALL RESET
      GO TO 10
   40 CONTINUE
      JTER=JTER+1
      CALL SOLVE2
      GO TO 10
   30 CONTINUE
      RETURN
      END
C
      SUBROUTINE SET
      INCLUDE 'PHREEQE.CM'
      LA(1)=DLOG10(TOT(1))
      LA(2)=DLOG10(TOT(2))
      LA(3)=0.0D0
      PH=-LA(1)
      PE=-LA(2)
      M(1)=1D1**(LA(1))
      DO 10 I=4,LASTT
      IF (IIN(I).LE.0) GO TO 10
      IF (TOT(I).LE.0.0D0) TOT(I)=1D-10
      M(I)=0.1D0*TOT(I)
      LA(I)=DLOG10(M(I))
   10 CONTINUE
      DO 20 I=MAXT1,LASTS
      M(I)=0.0D0
   20 CONTINUE
      OLDC=CNVG1
      CNVG1=1D3
      ITER=0
      JTER=0
      CALL GAMMA
   30 CONTINUE
      JTER=JTER+1
      IF(JTER.LT.5) GO TO 35
      IF(IOPT(8).GT.0) WRITE(IW,45)
   45 FORMAT(1X,80('*')/1X,'DID NOT CONVERGE IN SET.')
      GO TO 50
   35 CONTINUE
      CALL AQMOD
      CALL SOLVE2
      CALL CHECK(*50,*60,*60)
   60 CONTINUE
      CALL ZEROAR
      IF(JCHECK.EQ.0) GO TO 50
      GO TO 30
   50 CONTINUE
      CNVG1=OLDC
      RETURN
      END
C
      SUBROUTINE GAMMA
      INCLUDE 'PHREEQE.CM'
      DOUBLE PRECISION MUHALF
      SAVE DSUM,OLDMU
C          CALCULATE IONIC STRENGTH
      OLDMU=MU
      SUM=M(1)
      MU=M(1)
      DO 10 I=4,LASTS
      IF (SFLAG(I).EQ.0) GO TO 10
      SUM=SUM+M(I)
      MU=MU+M(I)*ZSP(I)*ZSP(I)
   10 CONTINUE
      IF (ITER.LE.1) GO TO 20
      IF (SUM-DSUM.LT.1D0) GO TO 20
      SUM=DSUM+1D0
   20 CONTINUE
      DSUM=SUM
      MU=MU*0.5D0
      IF(ITER.LE.1) GO TO 30
C
C                  SLOW DOWN CHANGES IN MU AT HIGH IONIC STRENGTH
C
      FACTOR=1.0D0
      IF(MU.GT.1D0) FACTOR=0.3D0
      FUDGE=1.0D0
      IF(MU.GT.1D0) FUDGE=0.3D0
      MU=OLDMU+(MU-OLDMU)*FACTOR
   30 CONTINUE
      IF(MU.GT.1D2) MU=1D2
      MUHALF=DSQRT(MU)
C          ACTIVITY OF WATER
      AH2O=1.0-SUM*0.017
      IF (SUM.GT.40.0D0) AH2O=0.32
      LA(3)=DLOG10(AH2O)
      TOT(3)=AH2O
C          CALCULATE ACTIVITY COEFFICIENTS
      AMU=-A*MUHALF
      BMU=B*MUHALF
      CMU=-A*(MUHALF/(1.0+MUHALF)-0.3*MU)
      ZCHRG=0.1*MU
      LG(1)=AMU/(1.0+DHA(1)*BMU)
      IF (IOPT(6).EQ.1) LG(1)=CMU
      LG(2)=0.0D0
      LG(3)=0.0D0
      DO 70 I=4,LASTS
      IF (SFLAG(I).EQ.0) GO TO 70
      IF (DABS(ZSP(I)).LT.1.0D-40) GO TO 40
      IF (GFLAG(I).EQ.1) GO TO 50
      IF (DHA(I).LE.0D0) GOTO 60
      IF (IOPT(6).EQ.1) GO TO 60
C                  EXTENDED DEBYE-HUCKEL WITH ION SIZE PARAMETER
      LG(I)=AMU*ZSP(I)*ZSP(I)/(1.0+DHA(I)*BMU)
      GO TO 65
C                  GAMMA FOR UNCHARGED SPECIES
   40 LG(I)=ZCHRG
      GO TO 65
C                  WATEQ DEBYE-HUCKEL
   50 LG(I)=AMU*ZSP(I)*ZSP(I)/(1.0+ADHSP(I,1)*BMU)+ADHSP(I,2)*MU
      GO TO 65
C                  DAVIES GAMMA
   60 LG(I)=CMU*ZSP(I)*ZSP(I)
   65 CONTINUE
      IF(LG(I).LT.-1D1) LG(I)=-1D1
      IF(LG(I).GT.1D1) LG(I)=1D1
   70 CONTINUE
      RETURN
      END
      FUNCTION PTZGAM(Z,B0,B1,C,MU)
C
C                  FUNCTION USES PIZTER PARAMETERS TO CALCULATE FREE ION
C                  ACTIVITY COEFFICIENTS BY THE METHOD OF MILLERO AND THE
C                  MCGINNIS ASSUMPTION.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION MU,MUHALF,LGAMMA
      MUHALF=DSQRT(MU)
      F1=1.0-DEXP(-2.0*MUHALF)*(1+2.0*MUHALF-2.0*MU)
      FG=-0.392*(MUHALF/(1.0+1.2*MUHALF)+2.0/1.2*DLOG(1.0+1.2*MUHALF))
      LGAMMA=Z*Z*FG + MU*B0 + F1*B1 + MU*MU*C
      PTZGAM=LGAMMA/2.303D0
      RETURN
      END
      SUBROUTINE AQMOD
      INCLUDE 'PHREEQE.CM'
      ELECT=0D0
      THSOLN=0D0
      DALKS=0D0
C
C                  CALCULATE JACOBIAN
C
      ZSP(2)=0D0
      DO 20 I=1,LASTS
      IF(SFLAG(I).EQ.0) GO TO 20
      DM=LKSP(I)-LG(I)
      DO 60 J=1,NSP(I)
      DM=DM+LA(LSP(I,J))*CSP(I,J)
   60 CONTINUE
      LM(I)=DM
      M(I)= UNDER(LM(I))
      IF(M(I).GT.1D1.AND.I.NE.2.AND.IOPT(8).GT.0)
     1     WRITE(IW,80) I,SNAME(I),M(I)
   80 FORMAT(1X,I3,2X,A10,2X,1PD10.2,' = MOLALITY')
C
C                  SUM MOLALITIES INTO PROPER ROWS AND COLUMNS
C
      DO 100 I1=1,NSP(I)
      DM=M(I)*CSP(I,I1)
      K2=LSP(I,I1)
      IF(K2.GE.4) CALCT(K2)=CALCT(K2)+DM
C
C                  MASS BALANCES
C
      DO 120 J1=1,NSP(I)
      K1=LSP(I,J1)
      IF(K1.LT.4) GO TO 120
      AR(K1,K2)=AR(K1,K2)+DM*CSP(I,J1)
  120 CONTINUE
C                  ELECTRICAL BALANCE
      AR(1,K2)=AR(1,K2)+DM*ZSP(I)
C                  THOR BALANCE
      AR(2,K2)=AR(2,K2)+DM*THSP(I)
C                  ALKALINITY EQUATION
      AR(3,K2)=AR(3,K2)+DM*ALKSP(I)
  100 CONTINUE
C                  SUM TOTAL ELECT, THOR, ALK
      THSOLN=THSOLN+M(I)*THSP(I)
      ELECT=ELECT+M(I)*ZSP(I)
      DALKS=DALKS+M(I)*ALKSP(I)
   20 CONTINUE
      ZSP(2)=-1D0
C     *****
      ENTRY SI
C     *****
      IF (NMINS.EQ.0) RETURN
      DO 140 I=1,NMINS
      J=MAXT+I
      K=NMIN(I)
C                  CALCULATE INVERSE SATURATION INDEX
      DSI=LKMIN(I)
      DO 130 I1=1,K
      DSI=DSI-LA(LMIN(I,I1))*CMIN(I,I1)
  130 CONTINUE
      CR(J)=DSI*DLOG(1D1)
  140 CONTINUE
      RETURN
      END
      SUBROUTINE CHECK(*,*,*)
      INCLUDE 'PHREEQE.CM'
      DOUBLE PRECISION MCLOSE
      SAVE OLDMU, OLDH2O
      DATA ECLOSE,TCLOSE,THCLOS,MCLOSE /1D-10,1D-7,1D-7,1D-5/
      ICHECK=0
      LCHECK=0
      JCHECK=0
      MCHECK=0
      IF(ITER.LE.1) GO TO 20
C
C                  CHECK CHANGE IN AH20 AND MU
C
      MCHECK=0
      IF(DABS(MU-OLDMU).GT.CHKMU) MCHECK=1
   20 CONTINUE
      OLDH2O=TOT(3)
      OLDMU=MU
C
C                  CALCULATE FUNCTION RESIDUALS
C
      CR(1)=DZOFF-ELECT
      CR(2)=THOR-THSOLN
      CR(3)=DALKT-DALKS
      DO 30 I=4,LASTT
      IF(IIN(I).LE.0) GO TO 30
      CR(I)=TOT(I)-CALCT(I)
   30 CONTINUE
C                  CHECK FOR CONVERGENCE
C
C                  ELECTRICAL BALANCE
      DCHECK=MU*ECLOSE
      IF(IESPEC.GT.0.AND.DABS(CR(1)).GT.DCHECK) ICHECK=1
C                  THOR
      IF(IIN(2).GT.0.AND.DABS(CR(2)).GT.MU*THCLOS) ICHECK=1
C                  ALKALINITY
      IF(IASPEC.GT.0.AND.DABS(CR(3)).GT.TCLOSE*DALKT) ICHECK=1
C                  MINERALS
      IF(NMINS.EQ.0) GO TO 40
      DO 60 I=1,NMINS
      K=MAXT+I
      IF(DABS(CR(K)).GT.MCLOSE) ICHECK=1
   60 CONTINUE
   40 CONTINUE
C                  MASS BALANCES
      DO 80 I=4,LASTT
      IF(IIN(I).LE.0) GO TO 80
      IF(I.EQ.IESPEC.OR.I.EQ.IASPEC) GO TO 80
      IF(DABS(CR(I)).GT.TCLOSE*TOT(I)) ICHECK=1
      DT=DABS(1D0-CALCT(I)/TOT(I))
      IF(DT.GT.CNVG1) JCHECK=1
      IF(DT.GT.CNVG2) LCHECK=1
   80 CONTINUE
C
C                  RETURNS
C
      IF(ITER.GT.ITMAX) GO TO 100
      IF(ITER.LT.5) ICHECK=1
C                                            /* MU CHANGE TOO LARGE
      IF(MCHECK.EQ.1) RETURN 3
C                                            /* VERY POOR MASS BALANCE
      IF(LCHECK.EQ.1) RETURN 2
C                                            /* POOR MASS BALANCE
      IF(JCHECK.EQ.1) RETURN
C                                            /* CONVERGED
      IF(ICHECK.EQ.0) RETURN 1
C                                            /* NEW ITER WITH ALL EQNS.
      RETURN
  100 CONTINUE
      DT=99.0
      WRITE(IW,120) ITER
  120 FORMAT(1H1,80('*')//'CALCULATIONS TERMINATED AT ',
     1     I5,' ITERATIONS.')
      CALL PBUG(DT,DT)
      CALL PTOT
      CALL PSPEC
      CALL PPHASE
      CALL PLOOK
      ENDFILE (UNIT=IW)
      STOP
      END
      SUBROUTINE SOLVE
      INCLUDE 'PHREEQE.CM'
C                  COPY ROWS OF JACOBIAN AR INTO ARRAY AS
C                  WHICH IS SOLVED BY SLNQ
C
C                  PUT ELECTRICAL BALANCE EQUATION IN ROW IESPEC
      IF (NEQ.EQ.0) RETURN
      IF (IESPEC.LT.2) GO TO 20
      TOT(IESPEC)=CALCT(IESPEC)
      CR(IESPEC)=-ELECT
      DO 40 I=1,LASTT
      AR(IESPEC,I)=AR(1,I)
   40 CONTINUE
   20 CONTINUE
C          PUT ALKALINITY EQUATION IN PLACE OF MASS BALANCE
      IF (IASPEC.EQ.0) GO TO 60
      TOT(IASPEC)=CALCT(IASPEC)
      CR(IASPEC)=CR(3)
      DO 80 I=1,LASTT
      AR(IASPEC,I)=AR(3,I)
   80 CONTINUE
   60 CONTINUE
C                  DECIDE WHICH EQUATIONS ARE INCLUDED
C
C                  GENERATE INDICES TO COPY INTO ARRAY AS (IRS)
C                  AND TRANSFER DELTAS BACK TO ARRAY AR NUMBERING (ISR)
C
C                  INCLUDE ONLY MASS BALANCE EQUATIONS
      IF(JCHECK.EQ.0) GO TO 100
      ICOUNT=0
      DO 120 I=1,3
      IRS(I)=0
  120 CONTINUE
      DO 140 I=4,MAXT
      IRS(I)=0
      IF(IIN(I).EQ.0) GO TO 140
      ICOUNT=ICOUNT+1
      IRS(I)=ICOUNT
      ISR(ICOUNT)=I
  140 CONTINUE
      NFT=1
      NLT=ICOUNT
      IMINS=0
      NSR=ICOUNT
      NRS=LASTT
      GO TO 200
  100 CONTINUE
C                  INCLUDE ALL EQUATIONS
      DO 220 I=1,MAXT
      IRS(I)=IIN(I)
      IF(IIN(I).GT.0) THEN
         ISR(IIN(I))=I
      END IF
  220 CONTINUE
      NFT=IFT
      NLT=ILT
      IMINS=NMINS
      IF(NMINS.EQ.0) GO TO 240
      DO 260 I=1,NMINS
      J=MAXT+I
      K=ILT+I
      IRS(J)=K
      ISR(K)=J
  260 CONTINUE
  240 CONTINUE
      NRS=MAXT+NMINS
      NSR=NEQ
  200 CONTINUE
C
C                  COPY TO ARRAY AS
C
      NSR1=NSR+1
      DO 300 I=1,NRS
      IF(IRS(I).EQ.0) GO TO 300
      K1=IRS(I)
      DO 310 J=1,NRS
      IF(IRS(J).EQ.0) GO TO 310
      K2=IRS(J)
      AS(K1,K2)=AR(I,J)
  310 CONTINUE
      AS(K1,NSR1)=CR(I)
  300 CONTINUE
C
C                  SOLVE FOR DA/A
C
      CALL SLNQ (NSR,AS,AS,DELTA,IOPT9,MAXEQ,IW)
      RETURN
      END
      SUBROUTINE SOLVE2
      INCLUDE 'PHREEQE.CM'
      IF(IOPT(8).GT.0) WRITE(IW,80) ITER,JTER
   80 FORMAT(1X,'SOLVE2.  ITER =',I4,'   JTER =',I4)
      DO 40 I=4,LASTT
      IF(IIN(I).LE.0) GO TO 40
      IF(CALCT(I).LE.0D0) CALCT(I)=1D-30
      TLA=LA(I)+(DLOG10(TOT(I))-DLOG10(CALCT(I)))
      IF(IOPT(8).GT.0) WRITE(IW,60) SNAME(I),LA(I),TLA,CALCT(I)
   60 FORMAT(1X,A12,2F12.3,1PD12.2)
      LA(I)=TLA
   40 CONTINUE
      RETURN
      END
      SUBROUTINE SLNQ (N,AS,AS1,DELTA,IOPT9,MAXEQ,IW)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z),INTEGER(I-N)
      DIMENSION AS(MAXEQ,MAXEQ),DELTA(MAXEQ),AS1(MAXEQ*MAXEQ)
C
C     SOLUTION OF N LINEAR EQUATIONS IN N UNKNOWNS BY GAUSSIAN
C     ELIMINATION.
C
C     N      INDICATES THE ORDER OF THE MATRIX,
C     AS     CONTAINS THE MATRIX OF THE COEFFICIENTS,
C     AS1    IS A ONE-DIMENSIONAL ARRAY EQUIVALENCED TO AS,
C     DELTA  CONTAINS THE N VALUES OF THE UNKNOWNS,
C     IOPT9  EQUAL TO 1, PRINTS AS AND DELTA,
C     MAXEQ  IS THE LEADING DIMENSION OF AS.
C
C                                   initialize
      IF (N.EQ.0) RETURN
      NP1=N+1
      NM1=N-1
C                                   print array if iopt(9)=1
      IF (IOPT9.EQ.1) THEN
         DO 10 II=1,N
         WRITE(IW,240) (AS(II,JJ),JJ=1,NP1)
   10    CONTINUE
      END IF
C                                   trivial case
      IF (N.EQ.1) THEN
         IF (DABS(AS(1,1)).LT.1.0D-40) GO TO 160
         DELTA(1)=AS(1,2)/AS(1,1)
         GO TO 180
      END IF
C                                   reduction loop
      DO 120 I=1,NM1
      K=I+1
      M=I
      B=DABS(AS(I,I))
      LL=MAXEQ*(I-1)
C                                   find largest element in column
      DO 40 L=LL+K,LL+N
      BB=DABS(AS1(L))
      IF (B.LT.BB) THEN
         M=L-LL
         B=BB
      END IF
   40 CONTINUE
      IF ((B.LE.0D0) .AND. (B.GE.0D0)) GO TO 160
C                                   exchange rows if necessary
      IF (I.NE.M) THEN
         DO 70 L=I,NP1
         B=AS(I,L)
         AS(I,L)=AS(M,L)
   70    AS(M,L)=B
      END IF
C                                   reduction step
      CC=1D0/AS1(LL+I)
      DO 115 M=K,N
      B=-AS1(LL+M)
      IF ((B.LE.0D0) .AND. (B.GE.0D0)) GO TO 115
      B=B*CC
      DO 110 L=K,NP1
  110 AS(M,L)=AS(M,L)+B*AS(I,L)
  115 CONTINUE
  120 CONTINUE
C                                   calculation of delta(n)
      IF(DABS(AS(N,N)).GT.1.0D-40) THEN
         DELTA(N)=AS(N,NP1)/AS(N,N)
      ELSE
         WRITE(IW,320) N
  320    FORMAT(1X,'AS(N,N)=0D0.  N=',I3)
         DELTA(N)=0D0
      END IF
C                                   back substitution for other rows
      LL=MAXEQ*N
      DO 400 K=NM1,1,-1
      B=-AS1(LL+K)
      DO 410 L=K+1,N
  410 B=B+AS(K,L)*DELTA(L)
      DELTA(K)=-B/AS(K,K)
  400 CONTINUE
C                                   print results if iopt9.eq.1
  180 CONTINUE
      IF (IOPT9.EQ.1) THEN
         WRITE(IW,220)
         WRITE(IW,230) (DELTA(I),I=1,N)
         WRITE(IW,250)
      END IF
      RETURN
C                                   singular matrix
  160 WRITE(IW,260)
      ENDFILE (UNIT=IW)
      STOP
C
C
  220 FORMAT (1X,'DELTA VALUES')
  230 FORMAT (3X,1P6D12.3)
  240 FORMAT (/(3X,1P6D12.3))
  250 FORMAT (1X)
  260 FORMAT (1H1,'THE PHASE RULE HAS BEEN VIOLATED')
      END
      SUBROUTINE STEP
      INCLUDE 'PHREEQE.CM'
      IF (IOPT(3).EQ.0) GO TO 120
      I=IOPT(3)
      WRITE(IW,140) ISTEP
      GO TO (10,30,50,60,100,100), I
      GO TO 100
C          MIX SOLUTION 1 WITH SOLUTION 2
   10 CONTINUE
      X1=XSTEP(ISTEP)
      X2=1.0-X1
      IF(X1.LT.0.0) X1=0.0
      IF(X2.LT.0.0) X2=0.0
      DO 20 I=1,MAXT
      TOT(I)=X1*TOTAL(1,I)+X2*TOTAL(2,I)
   20 CONTINUE
      THOR=TH(1)*X1+TH(2)*X2
      TC=X1*TEMP(1)+X2*TEMP(2)
      IF(X1.GT.1.0) TC=TEMP(1)
      IF(X2.GT.1.0) TC=TEMP(2)
      DZOFF=X1*DIFFZ(1)+X2*DIFFZ(2)
      WRITE(IW,150) X1,X2
      GO TO 120
C          TITRATE
   30 CONTINUE
      X1=XSTEP(ISTEP)
      VTOT=V0+X1
      TOT(1)=1D1**((DLOG10(TOTAL(1,1))*V0+DLOG10(TOTAL(2,1))*X1)/VTOT )
      TOT(2)=1D1**((DLOG10(TOTAL(1,2))*V0+DLOG10(TOTAL(2,2))*X1)/VTOT )
      DO 40 I=3,MAXT
      TOT(I)=(TOTAL(1,I)*V0+TOTAL(2,I)*X1)/VTOT
   40 CONTINUE
      TC=(TEMP(1)*V0+TEMP(2)*X1)/VTOT
      THOR=(TH(1)*V0+TH(2)*X1)/VTOT
      DZOFF=(DIFFZ(1)*V0+DIFFZ(2)*X1)/VTOT
      WRITE(IW,160) X1
      GO TO 120
C          ADD REACTION IN INCREMENTS
   50 CONTINUE
      X1=XSTEP(ISTEP)
      GO TO 70
C            ADD REACTION LINEARLY
   60 CONTINUE
      X1=(ISTEP*XSTEP(1))/NSTEPS
   70 CONTINUE
      DZOFF=DIFFZ(1)
      DO 80 I=1,MAXT
      TOT(I)=TOTAL(1,I)
   80 CONTINUE
      DO 90 I=1,NCOMPS
      K=LREAC(I)
      IF (K.EQ.0) DZOFF=DIFFZ(1)+X1*CREAC(I)
      IF (K.LT.4.OR.K.GT.MAXT) GO TO 90
      TOT(K)=TOT(K)+X1*CREAC(I)
   90 CONTINUE
      THOR=TH(1)+THREAC*X1
      TC=TEMP(1)
      IF (ISTEP.GT.1) TOT(1)=1D1**LA(1)
      WRITE(IW,170) X1
      CALL PREAC
      GO TO 120
C          FOLLOW PHASE BOUNDARIES ONLY
  100 CONTINUE
      DO 110 I=1,MAXT
      TOT(I)=TOTAL(1,I)
  110 CONTINUE
      THOR=TH(1)
      TC=TEMP(1)
      DZOFF=DIFFZ(1)
      WRITE(IW,180)
  120 CONTINUE
C          TEMPERATURE
      IF (IOPT(4).EQ.0) GO TO 130
      IF (IOPT(4).EQ.1) TC=TSTEP(1)
      IF (IOPT(4).EQ.2) TC=(ISTEP*(TSTEP(2)-TSTEP(1)))/NSTEPS+TSTEP(1)
      IF (IOPT(4).EQ.3) TC=TSTEP(ISTEP)
      WRITE(IW,190) TC
  130 CONTINUE
      TK=TC+273.15
      RETURN
C
  140 FORMAT (1H1,'STEP NUMBER',I3,/1H0,14('-'))
  150 FORMAT (1H0,F10.3,' = FRACTION OF SOLUTION 1.',3X,F10.3,' = FR',
     1'ACTION OF SOLUTION 2.'//)
  160 FORMAT (1H0,F10.3,' VOLUME UNITS OF SOLUTION 2 HAVE BEEN ',
     1'ADDED.'//)
  170 FORMAT (1H0,1PD10.3,' MOLES OF REACTION HAVE BEEN ADDED.'//)
  180 FORMAT (//)
  190 FORMAT (23X,F10.2,' = NEW TEMPERATURE (C).'//)
      END
      FUNCTION UNDER(D)
      DOUBLE PRECISION D,UNDER
      UNDER=0D0
      IF (D.LT.-33.0D0) GO TO 10
      UNDER=1D5
      IF (D.GT.5D0) GO TO 10
      UNDER=1D1**D
   10 CONTINUE
      RETURN
      END
      SUBROUTINE RESET
      INCLUDE 'PHREEQE.CM'
C
C                  CALCULATE CHANGE IN TOTALS DUE TO
C                  MINERAL SOLUTION/PRECIPITATION
C
      F=1D0
      FPHPE=1D0
      IF(IMINS.EQ.0) GO TO 40
      DO 60 I=IFT,ILT
      DT=0D0
      DO 80 J=IFM,ILM
      K=MAXT+(J-ILT)
      DT=DT-DELTA(J)*AR(ISR(I),K)
   80 CONTINUE
      DELTOT(I)=DT
C
C                  MAKE SURE NO NEGATIVE TOTALS OCCUR
C
      IF(TOT(IOUT(I))+DT.GT.0D0) GO TO 60
      DF=-RMIN*TOT(IOUT(I))/DT
      IF(DF.LT.F) F=DF
   60 CONTINUE
C
C                  MAKE SURE NO LARGE CHANGES IN MINERALS
C
      DO 70 I=IFM,ILM
      IF(DABS(DELTA(I)).LT.1D0) GO TO 70
      DF=DABS(1D0/DELTA(I))
      IF (DF.LT.F) F=DF
   70 CONTINUE
   40 CONTINUE
C
C                  ENSURE PH CHANGE IS SMALL
      DF=1D0
      IF(IRS(1).EQ.0) GO TO 120
      IF(DELTA(1).LT.-DMIN) DF=-DMIN/DELTA(1)
      IF(DELTA(1).GT.DMAX)  DF=DMAX/DELTA(1)
      FPHPE=DF
  120 CONTINUE
C
C                  ENSURE PE CHANGE IS SMALL
C
      IF(IRS(2).EQ.0) GO TO 140
      IF(DELTA(IRS(2)).LT.-DMIN) DF=-DMIN/DELTA(IRS(2))
      IF(DELTA(IRS(2)).GT.DMAX)  DF=DMAX/DELTA(IRS(2))
      IF(DF.LT.FPHPE) FPHPE=DF
  140 CONTINUE
C
C                  SCALE DELTAS
C
      IF(IRS(1).GT.0) DELTA(1)=DELTA(1)*FPHPE
      IF(IRS(2).GT.0) DELTA(2)=DELTA(2)*FPHPE
C     IF(FPHPE.LT.1D-5.AND.DELTA(1).LT.1D-4)
C    1      DELTA(1=DELTA(1)*DABS(DELTA(2)/(DELTA(1)*1D1)
C
C                  MAKE SURE NO NEGATIVE ACTIVITIES ARE CALCULATED
C
      DF=1D0
      DO 160 I=NFT,NLT
      IF(DELTA(I).LT.-RMIN) DF=-RMIN/DELTA(I)
      IF(DELTA(I).GT.RMAX) DF=RMAX/DELTA(I)
      IF(DF.LT.F) F=DF
  160 CONTINUE
C
C                  SCALE DELTAS
C
      DO 180 I=NFT,NSR
      DELTA(I)=DELTA(I)*F
  180 CONTINUE
      IF(IMINS.EQ.0) GO TO 200
      DO 220 I=NFT,NLT
      DELTOT(I)=DELTOT(I)*F
  220 CONTINUE
  200 CONTINUE
C
      IF(IOPT(8).EQ.1) CALL PBUG(F,FPHPE)
C
C                  RESET ACTIVITIES
C
      DO 300 I=1,NLT
      K=ISR(I)
      LA(K)=LA(K)+DLOG10(1D0+FUDGE*DELTA(I))
  300 CONTINUE
      TOT(1)=1D1**LA(1)
      PH=-LA(1)
      TOT(2)=1D1**LA(2)
      PE=-LA(2)
C                  RESET TOTAL MOLALITIES
      IF(IMINS.EQ.0) GO TO 320
      DO 340 I=IFT,ILT
      K=IOUT(I)
      TOT(K)=TOT(K)+DELTOT(I)
  340 CONTINUE
C                  TOTAL MINERALS AND THOR
      DO 360 I=IFM,ILM
      K=MAXT+I-ILT
      TOT(K)=TOT(K)+DELTA(I)
      IF(IOPT(3).EQ.6.AND.I.EQ.IFM) THEN
             THOR=THOR+DELTA(I)*THREAC
          ELSE
             THOR=THOR+THMIN(I-ILT)*DELTA(I)
      END IF
  360 CONTINUE
  320 CONTINUE
      RETURN
      END
      SUBROUTINE PTOT
      INCLUDE 'PHREEQE.CM'
      CHARACTER *12 DALK,DN,DN1,DN2,DN3,DNAME
      CHARACTER *80 CARD
      CHARACTER*8 NAMEF(8)
      DATA NAMEF /'OH-', 'O2 AQ', 'H2 AQ', 'HCO3-', 'S-2', 'HS-',
     1    'FE+3', 'Fe+3'/
      DATA NF /8/
      DATA IDATA /0/, DALK/'TOT ALK'/
      DATA DN1/'O2'/,DN2/'H2'/,DN3/'CHARGE'/
      WRITE(IW,220)
      WRITE(IW,230)
      KK=0
      DO 10 I=4,MAXT
      IF (DABS(TOT(I)).LT.1.0D-40) GO TO 10
      KK=1
      DLT=DLOG10(TOT(I))
      DNAME=TNAME(I)
      IF (IASPEC.EQ.I) DNAME=DALK
      WRITE(IW,240) DNAME,TOT(I),DLT
   10 CONTINUE
      IF (KK.EQ.0) WRITE(IW,250)
      WRITE(IW,260)
      RETURN
C     *****
      ENTRY PSPEC
C     *****
      WRITE(IW,270)
      WRITE(IW,280) PH,PE,TOT(3),MU,TC,ELECT,THSOLN,DALKS,ITER
      IF (IASPEC.LE.0) GO TO 20
      WRITE(IW,290) TOTAL(ISOL,IASPEC)
   20 CONTINUE
      IF (IESPEC.LE.1) GO TO 30
      DD=TOT(IESPEC)-DNEUT
      WRITE(IW,300) TNAME(IESPEC),DD
   30 CONTINUE
      WRITE(IW,310)
      LM(1)=LA(1)-LG(1)
      LG(2)=0.0D0
      LM(2)=LA(2)
      LG(3)=0.0D0
      LM(3)=LA(3)
      DO 40 I=1,LASTS
      IF (SFLAG(I).EQ.0) GO TO 40
      DA=0D0
      DM=0D0
      IF (LM(I).LT.-30D0.AND.I.GT.MAXT) GO TO 40
      IF (LM(I).GE.-60D0) DM=1D1**LM(I)
      DLA=LM(I)+LG(I)
      IF (DLA.GE.-60D0) DA=1D1**DLA
      DG=1D1**LG(I)
      IF(I.LE.MAXT) THEN
         GO TO 37
      ELSE
         DO 43 J=1,NF
         IF (SNAME(I).EQ.NAMEF(J)) GOTO 37
   43    CONTINUE
      END IF
C                                   check that molality > 0.01 of some total
      K=NSP(I)
      DO 35 J=1,K
      IF(LSP(I,J).LT.4) GO TO 35
      IF(CSP(I,J)*DM.GT.0.01*TOT(LSP(I,J))) GO TO 37
   35 CONTINUE
      GO TO 40
   37 CONTINUE
      WRITE(IW,320) I,SNAME(I),ZSP(I),DM,LM(I),DA,DLA,DG,LG(I)
   40 CONTINUE
C     *****
      ENTRY PSUM
C     *****
      IF (NSUMS.EQ.0) GO TO 80
      KK=0
      DO 70 I=1,NSUMS
      LL=0
      DSUM=0D0
      K=NSUM(I)
      DO 50 J=1,K
      IF (SFLAG(LSUM(I,J)).LE.0) GO TO 50
      LL=1
      DSUM=DSUM+M(LSUM(I,J))
   50 CONTINUE
      IF (LL.EQ.0) GO TO 70
      IF (LL.EQ.0.OR.KK.NE.0) GO TO 60
      WRITE(IW,330)
      KK=1
   60 CONTINUE
      WRITE(IW,340) SUNAME(I),DSUM
   70 CONTINUE
   80 CONTINUE
      RETURN
C     *****
      ENTRY PBUG(D,DPHPE)
C     *****
      WRITE(IW,345) ITER,MU
  345 FORMAT(1X,'ITER =',I4,5X,'MU = ',F8.5)
      WRITE(IW,350) D,CR(1),DPHPE
C          PRINT CHANGES IN PH AND PE
      IF (IRS(1).LE.0) GO TO 90
      DPH=-DLOG10(1D0+DELTA(1))
      WRITE(IW,360) PH,DPH
   90 CONTINUE
      IF (IRS(2).LE.0) GO TO 100
      DPE=-DLOG10(1D0+DELTA(IRS(2)))
      WRITE(IW,370) PE,DPE,CR(2)
  100 CONTINUE
C          PRINT TOTALS AND ACTIVITIES
      DO 110 K=4,LASTT
      I=IRS(K)
      IF (I.LE.0) GO TO 110
      AOLD=1D1**LA(K)
      AFACT=1D0+DELTA(I)
      ANEW=AOLD*AFACT
      TOLD=TOT(K)
      TNEW=TOLD+DELTOT(I)
      WRITE(IW,385) CR(K),TNAME(K),TOLD,TNEW,DELTOT(I),
     1     SNAME(K),AOLD,ANEW,AFACT
  385 FORMAT(1X,1PD8.1,2X,A3,3D9.1,2X,A5,3D9.1)
  110 CONTINUE
C          PRINT MINERAL TOTALS AND DELTAS
      IF (IMINS.LE.0) GO TO 130
      DO 120 I=1,NMINS
      K=MAXT+I
      J=ILT+I
      TNEW=TOT(K)+DELTA(J)
      WRITE(IW,385) CR(K),MNAME(I),TOT(K),TNEW,DELTA(J)
  120 CONTINUE
  130 CONTINUE
      RETURN
C     *****
      ENTRY PPHASE
C     *****
      IF (NMINS.EQ.0) RETURN
      WRITE(IW,400)
      DO 150 I=1,NMINS
      K=NMIN0(I)
      DIAP=0.0D0
      DO 140 J=1,K
      DIAP=DIAP+(LG(LMIN0(I,J))+LM(LMIN0(I,J)))*CMIN0(I,J)
  140 CONTINUE
      DSI=DIAP-LKMIN0(I)
      K=MAXT+I
      D1=TOT(K)
      IF (IOPT(3).EQ.6.AND.I.EQ.1) D1=0D0
      WRITE(IW,410) MNAME(I),D1,DIAP,LKMIN0(I),DSI
      IF (IOPT(3).EQ.6.AND.I.EQ.1) WRITE(IW,420)
  150 CONTINUE
      WRITE(IW,430)
      IF (IOPT(3).EQ.6) WRITE(IW,440) TOT(MAXT+1),MNAME(1)
      IF (IOPT(3).NE.6) RETURN
C     *****
      ENTRY PREAC
C     *****
      WRITE(IW,450)
      DO 160 I=1,NCOMPS
      L=LREAC(I)
      IF (L.EQ.0) DN=DN3
      IF (L.LT.MAXT1) DN=TNAME(L)
      IF (L.GT.MAXT) DN=DN1
      IF (L.GT.MAXT.AND.THMEAN(I).LT.0) DN=DN2
      WRITE(IW,460) CREAC(I),DN,THMEAN(I)
  160 CONTINUE
      RETURN
C     *****
      ENTRY PLOOK
C     *****
      IF (NLOOKS.EQ.0) RETURN
      KK=0
      DO 190 I=1,NLOOKS
      K=NLOOK(I)
      DIAP=0D0
      DO 170 J=1,K
      LL=LLOOK(I,J)
      IF (SFLAG(LL).LE.0) GO TO 190
      DIAP=DIAP+(LG(LL)+LM(LL))*CLOOK(I,J)
  170 CONTINUE
      IF (KK.NE.0) GO TO 180
      KK=1
      WRITE(IW,470)
  180 CONTINUE
      DSI=DIAP-LKLOOK(I)
      WRITE(IW,480) NAMELK(I),DIAP,LKLOOK(I),DSI
  190 CONTINUE
      RETURN
C     *****
      ENTRY PDATA
C     *****
      IF (IOPT(1).NE.1) RETURN
      IF (IDATA.GT.0) RETURN
      IDATA=1
      REWIND IDB
      WRITE(IW,490)
  200 CONTINUE
      READ(IDB,500,END=210) CARD
      WRITE(IW,510) CARD
      GO TO 200
  210 CONTINUE
      RETURN
C
  220 FORMAT (///24X,'TOTAL MOLALITIES OF ELEMENTS'/,24X,'----- --------
     1-- -- --------')
  230 FORMAT (/16X,'ELEMENT',10X,'MOLALITY',9X,'LOG MOLALITY'/)
  240 FORMAT (16X,A8,6X,1PD13.6,8X,0PF9.4)
  250 FORMAT (16X,'PURE WATER')
  260 FORMAT (//)
  270 FORMAT (//,24X,'----DESCRIPTION OF SOLUTION----')
  280 FORMAT (/,39X,'PH = ',F8.4/39X,'PE = ',F8.4/29X,'ACTIVITY H2O = ',
     1F8.4/27X,'IONIC STRENGTH = ',F8.4/30X,'TEMPERATURE = ',F8.4/23X,'E
     2LECTRICAL BALANCE = ',1PD12.4/37X,'THOR = ',D12.4/25X,'TOTAL ALKAL
     3INITY = ',D12.4/31X,'ITERATIONS = ',I3)
  290 FORMAT (29X,'TOTAL CARBON = ',1PD12.4)
  300 FORMAT (20X,'MOLES OF ',A8,' ADDED = ',D12.4)
  310 FORMAT (///,26X,23('-')/26X,'DISTRIBUTION OF SPECIES'/26X,23('-')/
     1/2X,'I',2X,'SPECIES',4X,'Z',3X,'MOLALITY',2X,'LOG MOLAL',3X,'ACTIV
     2ITY',2X,'LOG ACT',4X,'GAMMA',3X,'LOG GAM'/)
  320 FORMAT (1X,I3,1X,A8,1X,F4.1,1X,1PE10.3,2X,0PF7.3,2X,2(1PE10.3,1X,
     10PF7.3,1X))
  330 FORMAT (///25X,'SUMS OF SPECIES'/)
  340 FORMAT (22X,A8,' = ',1PD13.6)
  350 FORMAT (/1X,'REDUCTION FACTOR: ',1PD12.5,3X,'ELECT: ',D12.5,3X,
     1'DPHPE: ',D12.5)
  360 FORMAT (1X,'PH = ',F8.4,5X,'DPH = ',F8.4)
  370 FORMAT (1X,'PE = ',F8.4,5X,'DPE = ',F8.4,5X,'DTHOR = ',1PD12.5)
  400 FORMAT (27X,'----PHASE BOUNDARIES----'//,9X,'PHASE',5X,'DELTA PHAS
     1E*',6X,'LOG IAP',6X,'LOG KT',6X,'LOG IAP/KT'/)
  410 FORMAT (8X,A8,2X,1PD13.6,3(4X,0PF9.4))
  420 FORMAT (1H+,5X,'**')
  430 FORMAT (/,1X,'* NEGATIVE DELTA PHASE INDICATES PRECIPITATION',/,3X
     1,'AND POSITIVE DELTA PHASE INDICATES DISSOLUTION.')
  440 FORMAT (/,1X,'** ',1PD12.6,' MOLES OF REACTION',' HAVE BEEN ADDED
     1TO THE SOLUTION',/,4X,'TO REACH THE ',A8,' PHASE BOUNDARY.')
  450 FORMAT (/,6X,'REACTION IS:')
  460 FORMAT (20X,F6.2,' MOLES OF ',A8,'  VALENCE =  ',F6.3)
  470 FORMAT (//28X,'---- LOOK MIN IAP ----'//15X,'PHASE',8X,'LOG IAP',6
     1X,'LOG KT',6X,'LOG IAP/KT'/)
  480 FORMAT (14X,A8,3(4X,F9.4))
  490 FORMAT (1H1,25X,'DATA:  CARD IMAGES FROM DISK'/)
  500 FORMAT (A80)
  510 FORMAT (1X,A80)
      END
      SUBROUTINE READ
      INCLUDE 'PHREEQE.CM'
      CHARACTER *12 SUBS,SUB,TNAM,DELETE
      CHARACTER *64 REMRK
      CHARACTER *72 CARD
      DIMENSION ISUB(14),SUBS(14),LT(MAXT),DTOT(MAXT)
      DATA SUBS /'TEMP     ','MINERALS ','SOLUTION ','REACTION ',
     1           'STEPS    ','ELEMENTS ','SPECIES  ','END      ',
     2           'LOOK MIN ','SUMS     ','NEUTRAL  ','KNOBS    ',
     3           'SOLNSAS  ','         '/
      DATA NLKS,NSMS /0,0/
      DATA DELETE /'DELETE   '/
   10 CONTINUE
      IERR=0
      ISOLV(1)=0
      ISOLV(2)=0
      NRMINS=0
      NLOOKS=NLKS
      NSUMS=NSMS
      DO 20 I=1,11
      ISUB(I)=0
   20 CONTINUE
C          READ TITLE CARD
      READ(IR,420,END=410) (TITLE(I),I=1,20)
      call clrscr()
      write(*,8)
8     format(23x,'**<<Please be patient>>**')
      WRITE(*,'(//,'' Current Problem Set Being Solved:'',/,1X,20A4)')
     $(TITLE(I),I=1,20)
C          READ OPTION CARD
      READ(IR,430) (IOPT(I),I=1,10),NSTEPS,NCOMPS,V0
      IF (IOPT(1).EQ.1) CALL PDATA
      WRITE(IW,440) (TITLE(I),I=1,20)
      WRITE(IW,450) (IOPT(I),I=1,10),NSTEPS,NCOMPS,V0
      IREAD=0
      IFILE=IR
      GO TO 30
C     *****
      ENTRY RDATA
C     *****
      WRITE(IW,460)
      IREAD=1
      IFILE=IDB
   30 CONTINUE
C          READ SUBROUTINE CARD AND BRANCH
   40 CONTINUE
      READ(IFILE,470) SUB,ISOLN
      DO 50 I=1,13
      IF (SUB.NE.SUBS(I)) GO TO 50
      GO TO (60,70,110,150,170,180,220,400,260,350,390,1010,1100), I
   50 CONTINUE
      WRITE(IW,480) SUB
      GO TO 40
C
C          READ TEMP DATA
C
   60 CONTINUE
      WRITE(IW,490)
      IF (IOPT(4).EQ.0) GO TO 40
      NTEMP=IOPT(4)
      IF (NTEMP.EQ.3) NTEMP=NSTEPS
      READ(IFILE,500) (TSTEP(I),I=1,NTEMP)
      WRITE(IW,510) (TSTEP(I),I=1,NTEMP)
      ISUB(1)=1
      GO TO 40
C
C          READ MINERAL DATA
C
   70 CONTINUE
      WRITE(IW,520)
      I=0
   80 CONTINUE
      I=I+1
C          READ NAME ETC. FOR MINERAL
      READ(IFILE,530) MNAME(I),NMIN0(I),THMIN(I),LKT0M(I),DHMIN(I),
     1MFLAG(I),SIMIN(I)
      WRITE(IW,540) MNAME(I),NMIN0(I),THMIN(I),LKT0M(I),DHMIN(I),
     1MFLAG(I),SIMIN(I)
      IF (NMIN0(I).EQ.0) GO TO 100
      NRMINS=I
C          READ COEFFICIENTS FOR MINERAL
      K=NMIN0(I)
      READ(IFILE,550) (LMIN0(I,J),CMIN0(I,J),J=1,K)
      WRITE(IW,560) (LMIN0(I,J),CMIN0(I,J),J=1,K)
C          READ ANALYTIC EXPRESSION COEFFICIENTS
      IF (MFLAG(I).EQ.0) GO TO 90
      READ(IFILE,570) (AMIN(I,J),J=1,5)
      WRITE(IW,580) (AMIN(I,J),J=1,5)
   90 CONTINUE
      GO TO 80
  100 CONTINUE
      CALL MINCON
      CALL CHKMIN(IERR)
      ISUB(2)=1
      GO TO 40
C
C          READ A SOLUTION
C
  110 CONTINUE
      WRITE(IW,590) ISOLN
C          READ SOLUTION TITLE
      READ(IFILE,600) (HEAD(ISOLN,J),J=1,20)
      WRITE(IW,610) (HEAD(ISOLN,J),J=1,20)
C          READ NTOTS,PH,EH
      READ(IFILE,620) NTOTS,IALK(ISOLN),IUNITS(ISOLN),PH,PE,TEMP(ISOLN),
     1SDENS(ISOLN)
      IF (DABS(SDENS(ISOLN)).LT.1.0D-40) SDENS(ISOLN)=1.0
      WRITE(IW,630) NTOTS,IALK(ISOLN),IUNITS(ISOLN),PH,PE,TEMP(ISOLN),
     1SDENS(ISOLN)
C          READ TOTALS
      DO 120 I=1,MAXT
      TOTAL(ISOLN,I)=0D0
  120 CONTINUE
      IF (NTOTS.EQ.0) GO TO 140
      READ(IFILE,640) (LT(J),DTOT(J),J=1,NTOTS)
      WRITE(IW,650) (LT(J),DTOT(J),J=1,NTOTS)
C          ZERO TOTAL AND INSERT VALUES
      DO 130 I=1,NTOTS
      TOTAL(ISOLN,LT(I))=DTOT(I)
  130 CONTINUE
      CALL UNITS(ISOLN)
  140 CONTINUE
      TOTAL(ISOLN,1)=1D1**(-PH)
      TOTAL(ISOLN,2)=1D1**(-PE)
      ISOLV(ISOLN)=1
      ISUB(3)=1
      GO TO 40
C
C          READ REACTION DATA
C
  150 CONTINUE
      IF (NCOMPS.EQ.0) GO TO 40
      WRITE(IW,660)
C          READ COEFFICIENTS OF REACTION
      READ(IFILE,670) (LREAC(I),CREAC(I),THMEAN(I),I=1,NCOMPS)
      WRITE(IW,680) (LREAC(I),CREAC(I),THMEAN(I),I=1,NCOMPS)
      THREAC=0D0
      DO 160 I=1,NCOMPS
      THREAC=THREAC+THMEAN(I)*CREAC(I)
  160 CONTINUE
      ISUB(4)=1
      GO TO 40
C
C          READ STEPS DATA
C
  170 CONTINUE
      IF (NSTEPS.EQ.0.OR.IOPT(3).EQ.5) GO TO 40
      WRITE(IW,690)
      K=NSTEPS
      IF (IOPT(3).EQ.4) K=1
      READ(IFILE,700) (XSTEP(I),I=1,K)
      WRITE(IW,710) (XSTEP(I),I=1,K)
      ISUB(5)=1
      GO TO 40
C
C          READ ELEMENT CARDS
C
  180 CONTINUE
      WRITE(IW,720)
C          READ ELEMENTS UNTIL BLANK CARD
  190 CONTINUE
      READ(IFILE,730) TNAM,NELT,TGFW
      IF (IREAD.EQ.0) WRITE(IW,740) TNAM,NELT,TGFW
      IF (NELT.EQ.0) GO TO 210
      IF (NELT.GT.3.AND.NELT.LE.MAXT) GO TO 200
      WRITE(IW,750) NELT,TNAM,SUBS(6)
      ENDFILE (UNIT=IW)
      STOP
  200 CONTINUE
      TNAME(NELT)=TNAM
      GFW(NELT)=TGFW
      GO TO 190
  210 CONTINUE
      ISUB(6)=1
      GO TO 40
C
C          READ SPECIES CARDS
C
  220 CONTINUE
      WRITE(IW,760)
C          READ SPECIES CARDS UNTIL BLANK CARD
  230 CONTINUE
      READ(IFILE,770) I
      IF (IREAD.EQ.0) WRITE(IW,780) I
C          READ SPECIES NAME ETC.
      IF (I.EQ.0) GO TO 250
      IF (I.GT.0.AND.I.LE.MAXS) GO TO 240
      READ(IFILE,790) TNAM
      WRITE(IW,750) I,TNAM,SUBS(7)
      ENDFILE (UNIT=IW)
      STOP
  240 CONTINUE
      READ(IFILE,790) SNAME(I),NSP(I),KFLAG(I),GFLAG(I),ZSP(I),THSP(I),
     1DHA(I),(ADHSP(I,J),J=1,2),ALKSP(I)
      IF (IREAD.EQ.0) WRITE(IW,800)SNAME(I),NSP(I),KFLAG(I),GFLAG(I)
     1,ZSP(I),THSP(I),DHA(I),(ADHSP(I,J),J=1,2),ALKSP(I)
      IF (NSP(I).EQ.0) GO TO 230
C          READ LOG K DATA FOR SPECIES
      READ(IFILE,810) LKT0SP(I),DHSP(I),(ASP(I,J),J=1,5)
      IF (IREAD.EQ.0) WRITE(IW,820) LKT0SP(I),DHSP(I),(ASP(I,J),J=1,5)
C          READ COEFFICIENTS
      K=NSP(I)
      READ(IFILE,830) (LSP(I,J),CSP(I,J),J=1,K)
      IF (IREAD.EQ.0) WRITE(IW,840) (LSP(I,J),CSP(I,J),J=1,K)
      GO TO 230
  250 CONTINUE
      ISUB(7)=1
      CALL CHKSPE(IERR)
      GO TO 40
C
C          READ MINERALS TO LOOK AT
C
  260 CONTINUE
      WRITE(IW,850)
      I=NLKS
  270 CONTINUE
      I=I+1
      IF (I.LE.MAXLK) GO TO 280
      WRITE(IW,860) MAXLK
      I=MAXLK
  280 CONTINUE
C          READ NAME ETC.
      READ(IFILE,870) NAMELK(I),NLOOK(I),LK0LK(I),DHLOOK(I),LOOKFL(I)
      IF (IREAD.EQ.0) WRITE(IW,880) NAMELK(I),NLOOK(I),LK0LK(I),DHLOOK
     1(I),LOOKFL(I)
      IF (NAMELK(I).NE.DELETE) GO TO 290
      I=0
      NLOOKS=I
      GO TO 270
  290 CONTINUE
      IF (NLOOK(I).EQ.0) GO TO 340
C          CHECK TO SEE IF MINERAL IS ALREADY IN THE LIST
      IF (I.LE.1) GO TO 310
      L=I-1
      DO 300 N=1,L
      IF (NAMELK(I).NE.NAMELK(N)) GO TO 300
      NLOOK(N)=NLOOK(I)
      LK0LK(N)=LK0LK(I)
      DHLOOK(N)=DHLOOK(I)
      LOOKFL(N)=LOOKFL(I)
      I=I-1
      GO TO 320
  300 CONTINUE
  310 CONTINUE
      N=I
      NLOOKS=I
C          N IS THE NUMBER FOR THE MINERAL BEING READ.
  320 CONTINUE
C          READ COEFFICIENTS
      K=NLOOK(N)
      READ(IFILE,550) (LLOOK(N,J),CLOOK(N,J),J=1,K)
      IF (IREAD.EQ.0) WRITE(IW,560) (LLOOK(N,J),CLOOK(N,J),J=1,K)
C          READ ANALYTIC EXPRESSION
      IF (LOOKFL(N).EQ.0) GO TO 330
      READ(IFILE,570) (ALOOK(N,J),J=1,5)
      IF (IREAD.EQ.0) WRITE(IW,580) (ALOOK(N,J),J=1,5)
  330 CONTINUE
      GO TO 270
  340 CONTINUE
      NLKS=NLOOKS
      CALL CHKLK
      ISUB(9)=1
      GO TO 40
C
C          READ LISTS FOR SUMS OF SPECIES
C
  350 CONTINUE
      WRITE(IW,890)
      I=NSMS
  360 CONTINUE
      I=I+1
      IF(I.GT.MAXSUM) THEN
         WRITE(IW,365) MAXSUM
  365    FORMAT(' ***** MAXIMUM NUMBER OF SUMS,',I4,', EXCEEDED.  ',
     1   'RECOMPILE WITH LARGER MAXSUM. *****')
         I=MAXSUM
      END IF
      READ(IFILE,900) SUNAME(I),K
      IF (IREAD.EQ.0) WRITE(IW,910) SUNAME(I),K
      IF (SUNAME(I).EQ.DELETE) THEN
         I=0
         NSUMS=0
         GO TO 360
      END IF
      IF (K.GT.0) THEN
         NSUM(I)=K
         NSUMS=I
         READ(IFILE,920) (LSUM(I,J),J=1,K)
         IF (IREAD.EQ.0) WRITE(IW,930) (LSUM(I,J),J=1,K)
         GO TO 360
      END IF
      NSMS=NSUMS
      ISUB(10)=1
      GO TO 40
C
C          READ SPECIES TO ADJUST FOR ELECTRICAL NEUTRALITY
C
  390 CONTINUE
      WRITE(IW,940)
      READ(IFILE,950) LPOS,LNEG
      WRITE(IW,960) LPOS,LNEG
      ISUB(11)=1
      GO TO 40
C
C                  READ CONVERGENCE PARAMETERS
C
 1010 CONTINUE
      WRITE(IW,1020)
 1020 FORMAT(' KNOBS')
      READ(IFILE,1050) CARD
 1050 FORMAT(A72)
      WRITE(IW,1030) CARD
 1030 FORMAT(1X,A72)
      READ(CARD,1031) DMAX,DMIN,FUDGE,RMAX,RMIN,CNVG1,CNVG2,ITMAX,CHKMU
 1031 format(9g12.6)
      GO TO 40
 1100 CONTINUE
C
C                  READ SOLUTION DATA GENERATED BY SAS
C
      WRITE(IW,1110) ISOLN
 1110 FORMAT(1X,'SOLNSAS ',I1)
C                  READ SOLUTION TITLE
      READ(IFILE,600) (HEAD(ISOLN,J),J=1,20)
      WRITE(IW,610) (HEAD(ISOLN,J),J=1,20)
C                  READ NTOTS,PH,EH
      READ(IFILE,620) NTOTS,IALK(ISOLN),IUNITS(ISOLN),PH,PE,TEMP(ISOLN),
     1SDENS(ISOLN)
      IF(DABS(SDENS(ISOLN)).LT.1.0D-40) SDENS(ISOLN)=1.0
      WRITE(IW,630) NTOTS,IALK(ISOLN),IUNITS(ISOLN),PH,PE,TEMP(ISOLN),
     1SDENS(ISOLN)
C                  READ TOTALS
      DO 1130 I=1,MAXT
      TOTAL(ISOLN,I)=0D0
 1130 CONTINUE
      NTOTS=0
 1140 CONTINUE
      READ(IFILE,1150) LTT,DTOTT,REMRK
 1150 FORMAT(I4,D11.3,1X,A64)
      WRITE(IW,1160) LTT,DTOTT,REMRK
 1160 FORMAT(1X,I4,1PD11.3,1X,A64)
      IF(LTT.EQ.0) GO TO 1170
      TOTAL(ISOLN,LTT)=DTOTT
      NTOTS=NTOTS+1
      GO TO 1140
 1170 CONTINUE
      CALL UNITS(ISOLN)
      TOTAL(ISOLN,1)=1D1**(-PH)
      TOTAL(ISOLN,2)=1D1**(-PE)
      ISOLV(ISOLN)=1
      ISUB(3)=1
      GO TO 40
C
C          END DATA ENTRY FOR THIS SIMULATION
C
  400 CONTINUE
      IF (IREAD.EQ.1) RETURN
      IF (IERR.LE.0) GO TO 405
      ENDFILE (UNIT=IW)
      STOP
  405 IF (IOPT(4).GT.0.AND.ISUB(1).EQ.0) IERR=1
      IF (IOPT(3).GT.0.AND.IOPT(3).LT.5.AND.ISUB(5).EQ.0) IERR=5
      IF (IOPT(3).GE.3.AND.IOPT(3).LT.5.AND.ISUB(4).EQ.0) IERR=4
      IF (IOPT(3).EQ.5.AND.ISUB(2).EQ.0) IERR=2
      IF (IOPT(3).EQ.6.AND.ISUB(2).EQ.0) IERR=2
      IF (IOPT(3).EQ.6.AND.ISUB(4).EQ.0) IERR=4
      IF (IOPT(2).EQ.2.AND.ISUB(11).EQ.0) IERR=11
      IF (IERR.EQ.0) RETURN
      WRITE(IW,970) SUBS(IERR)
      IF (IOPT(7).EQ.0) GO TO 10
  410 CONTINUE
      ENDFILE (UNIT=IW)
      CALL TYPOUT
      CALL CLRSCR()
      STOP '                   <<NORMAL TERMINATION OF PHREEQE>>'
C
  420 FORMAT (20A4)
  430 FORMAT (10I1,I2,I2,6X,F10.5)
  440 FORMAT (1H1,20A4)
  450 FORMAT (1X,10I1,I2,I2,6X,F10.5)
  460 FORMAT (10X,'DATA READ FROM DISK'/)
  470 FORMAT (A8,1X,I1)
  480 FORMAT (1X,'** ',A8,' **  INPUT UNKNOWN')
  490 FORMAT (1X,'TEMP')
  500 FORMAT (8F10.1)
  510 FORMAT (1X,8G10.3)
  520 FORMAT (1X,'MINERALS')
  530 FORMAT (A8,2X,I2,3X,3F10.2,5X,I1,9X,F10.3)
  540 FORMAT (1X,A8,2X,I2,3X,3G10.2,5X,I1,9X,F10.3)
  550 FORMAT ((5(I4,F11.3)))
  560 FORMAT ((1X,5(I4,G11.3)))
  570 FORMAT (5E12.5)
  580 FORMAT (1X,1P5E12.4)
  590 FORMAT (1X,'SOLUTION ',I1)
  600 FORMAT (20A4)
  610 FORMAT (1X,20A4)
  620 FORMAT (I2,I3,I2,3X,4F10.0)
  630 FORMAT (1X,I2,I3,I2,3X,4G10.3)
  640 FORMAT ((5(I4,D11.3)))
  650 FORMAT ((1X,5(I4,1PD11.3)))
  660 FORMAT (1X,'REACTION')
  670 FORMAT ((4(I4,2F8.3)))
  680 FORMAT ((1X,4(I4,2F8.3)))
  690 FORMAT (1X,'STEPS')
  700 FORMAT (8F10.3)
  710 FORMAT (1X,8G10.3)
  720 FORMAT (1X,'ELEMENTS')
  730 FORMAT (A9,1X,I2,3X,F10.0)
  740 FORMAT (1X,A9,2X,I2,3X,E16.5)
  750 FORMAT (1X,I4,2X,A8,5X,A8,' INDEX NUMBER IS OUT OF RANGE.'//1X,'CA
     1LCULATION TERMINATED.')
  760 FORMAT (1X,'SPECIES')
  770 FORMAT (I3)
  780 FORMAT (1X,I3)
  790 FORMAT (A8,2X,I3,I1,I1,6F10.3)
  800 FORMAT (1X,A8,2X,I3,I1,I1,6F10.3)
  810 FORMAT (2F10.3,5E12.5)
  820 FORMAT (1X,2F10.3,5G12.5)
  830 FORMAT (6(I3,F7.3))
  840 FORMAT ((1X,6(I3,F7.3)))
  850 FORMAT (1X,'LOOK MIN')
  860 FORMAT (1X,'***** LOOK MIN ARRAY ALREADY HAS',I5,' MINERALS.',
     1    'RECOMPILE WITH LARGER MAXLK.  *****')
  870 FORMAT (A8,2X,I2,13X,2F10.2,5X,I1)
  880 FORMAT (1X,A8,2X,I2,13X,2G10.3,5X,I1)
  890 FORMAT (1X,'SUMS')
  900 FORMAT (A8,2X,I2)
  910 FORMAT (1X,A8,2X,I2)
  920 FORMAT (20I4)
  930 FORMAT (1X,20I4)
  940 FORMAT (1X,'NEUTRAL')
  950 FORMAT (2I5)
  960 FORMAT (1X,2I5)
  970 FORMAT (//1X,14('*')/1X,'TERMINAL ERROR  INPUT LACKED ',A8,' CARDS
     1'/1X,14('*'))
      END
C
      SUBROUTINE TYPOUT
C     ----------
      INTEGER TFILE
      CHARACTER*80 LINE
      PARAMETER(TFILE=1)
      PARAMETER(IW=6)
    1 REWIND (UNIT=IW)
      WRITE(TFILE,2) char(27)
    2 FORMAT(1x,A,'[J',/,25X,'-- PHREEQE OUTPUT --',/)
      J=3
    5 I=J
   10 READ(IW,'(A80)',ERR=15,END=15) LINE
      I=I+1
      WRITE(TFILE,'(A80)') LINE
      IF (I .LT. 22) GOTO 10
      WRITE (TFILE,*) '- HIT ENTER TO CONTINUE, T TO GO TO THE TOP, Q TO
     $ QUIT, OR A PAGE INCREMENT -'
      READ(TFILE,'(A80)') LINE
      IF (LINE .EQ. 'T' .OR. LINE .EQ. 't') GOTO 1
      IF (LINE .EQ. 'Q' .OR. LINE .EQ. 'q') GOTO 16
   17 IF (LINE .NE. ' ' .AND. LINE .NE. '0') THEN
        IF (LINE(1:1) .EQ. '-') THEN
          READ(LINE(2:5),'(I4)',ERR=14) NP
          NL=22*NP
          DO 12 K=1,NL+22
   12     BACKSPACE (UNIT=IW)
        ELSE
          READ(LINE(1:4),'(I4)',ERR=14) NP
          NL=22*NP
          DO 13 K=1,NL-22
   13     READ(IW,*,ERR=14,END=14)
        ENDIF
      ENDIF
   14 WRITE(TFILE,11) Char(27)
   11 FORMAT(1X,A,'[J')
      J=0
      GOTO 5
   15 WRITE (TFILE,*) '-- EOF -- (HIT ENTER TO QUIT, T TO GO TO THE TOP,
     $ OR A NEGATIVE PAGE INCREMENT)'
      READ(TFILE,'(A80)') LINE
      IF (LINE .EQ. 'T' .OR. LINE .EQ. 't') GOTO 1
      IF (LINE .NE. ' ' .AND. LINE .NE. '0') GOTO 17
   16 CONTINUE
      END
C
      SUBROUTINE INOUT
      INCLUDE 'PHREEQE.CM'
C
C          DETERMINE TOTALS TO BE INCLUDED AS EQUATIONS IN MATRIX.
C
      DO 10 I=4,MAXT
      IIN(I)=0
      IF (TOT(I).LE.0.0D0) GO TO 10
      IIN(I)=1
   10 CONTINUE
      LAST=0
      LASTT=0
      DO 20 I=1,MAXT
      IF (IIN(I).EQ.0) GO TO 20
      LAST=LAST+1
      IIN(I)=LAST
      LASTT=I
      IOUT(LAST)=I
   20 CONTINUE
      ILT=LAST
C          PICK SPECIES TO BE INCLUDED
      IF (LASTT.LT.4) LASTT=4
      SFLAG(1)=1
      SFLAG(2)=1
      SFLAG(3)=1
      DO 30 I=4,MAXT
      SFLAG(I)=0
      IF (IIN(I).GT.0) SFLAG(I)=1
   30 CONTINUE
      DO 50 I=MAXT1,MAXS
      SFLAG(I)=0
      K=NSP(I)
      IF (K.EQ.0) GO TO 50
      DO 40 J=1,K
      IF (SFLAG(LSP(I,J)).LE.0) GO TO 50
   40 CONTINUE
      SFLAG(I)=1
      LASTS=I
   50 CONTINUE
C          ZERO ARRAY AR
      DO 70 I=1,MAXEQ
      DO 60 J=1,MAXEQ
      AR(I,J)=0D0
   60 CONTINUE
   70 CONTINUE
C          PUT MINERAL COEFFICIENTS INTO FULL ARRAY
      IF (NMINS.LE.0) GO TO 120
      DO 90 I=1,NMINS
      K=NMIN(I)
      L=MAXT+I
      DO 80 J=1,K
      K1=LMIN(I,J)
      AR(K1,L)=-CMIN(I,J)
      AR(L,K1)=CMIN(I,J)
   80 CONTINUE
      AR(1,L)=0D0
      AR(2,L)=-THMIN(I)
   90 CONTINUE
      IF (IOPT(3).NE.6) GO TO 120
C          ADD REACTION TO EQUILBRATE WITH MINERAL # 1.
      L=MAXT+1
      DO 100 I=1,MAXT
      AR(I,L)=0D0
  100 CONTINUE
      DO 110 I=1,NCOMPS
      J=LREAC(I)
      AR(J,L)=AR(J,L)-CREAC(I)
      AR(2,L)=AR(2,L)-CREAC(I)*THMEAN(I)
  110 CONTINUE
  120 CONTINUE
      RETURN
      END
      SUBROUTINE KTEMP
      INCLUDE 'PHREEQE.CM'
      DATA C/2.302585092/,R/1.98719D-3/
C
C          COMPUTE TEMPERATURE DEPENDENCE OF A AND B FOR DEBYE-HUCKEL
C
      S1=374.11-TC
      S2=S1**0.33333333
      S3=1.0+0.1342489*S2-3.946263E-03*S1
      S3=S3/(3.1975-0.3151548*S2-1.203374E-03*S1+7.48908E-13*S1**4.0)
      S3=DSQRT(S3)
      IF (TK.LT.373.15) GO TO 10
      C1=5321.0/TK+233.76-TK*(TK*(8.292E-07*TK-1.417E-03)+0.9297)
      GO TO 20
   10 C1=87.74-TC*(TC*(1.41E-06*TC-9.398E-04)+0.4008)
   20 CONTINUE
      C1=DSQRT(C1*TK)
      A=1824600.0*S3/C1**3.0
      B=50.29*S3/C1
C
C          COMPUTE VANT HOFF CONSTANTS
C
      C1=(298.15-TK)/(298.15*TK*C*R)
      DO 30 I=1,LASTS
      IF (SFLAG(I).EQ.0) GO TO 30
      IF (KFLAG(I).EQ.1) LKSP(I)=ASP(I,1)+ASP(I,2)*TK+ASP(I,3)/TK+ASP(I,
     14)*DLOG10(TK)+ASP(I,5)/TK**2D0
      IF (KFLAG(I).EQ.0) LKSP(I)=LKT0SP(I)-DHSP(I)*C1
   30 CONTINUE
      IF (NLOOKS.EQ.0) GO TO 50
      DO 40 I=1,NLOOKS
      IF (LOOKFL(I).EQ.0) LKLOOK(I)=LK0LK(I)-DHLOOK(I)*C1
      IF (LOOKFL(I).EQ.1) LKLOOK(I)=ALOOK(I,1)+ALOOK(I,2)*TK+ALOOK(I,3)/
     1TK+ALOOK(I,4)*DLOG10(TK)+ALOOK(I,5)/TK**2D0
   40 CONTINUE
   50 CONTINUE
      RETURN
C     *****
      ENTRY KMIN
C     *****
      IF (NMINS.EQ.0) GO TO 80
      DO 70 I=1,NMINS
      IF (MFLAG(I).EQ.0) LKMIN0(I)=LKT0M(I)-DHMIN(I)*C1
      IF (MFLAG(I).EQ.1) LKMIN0(I)=AMIN(I,1)+AMIN(I,2)*TK+AMIN(I,3)/TK+A
     1MIN(I,4)*DLOG10(TK)+AMIN(I,5)/TK**2D0
C          CONVERT K TO MASTER SPECIES
      LKMIN(I)=LKMIN0(I)+SIMIN(I)
      IF (NMCON(I).EQ.0) GO TO 70
      K=NMCON(I)
      DO 60 J=1,K
      LKMIN(I)=CMCON(I,J)*LKSP(LMCON(I,J))+LKMIN(I)
   60 CONTINUE
   70 CONTINUE
   80 CONTINUE
      RETURN
      END
      SUBROUTINE MINCON
      INCLUDE 'PHREEQE.CM'
C          LOOP ON NUMBER OF MINERALS
      DO 100 I=1,NRMINS
      K=NMIN0(I)
      ICOMP=0
      NONMAS=0
C          LOOP ON INDIVIDUAL MINERAL
      DO 90 J=1,K
      IF (LMIN0(I,J).GT.MAXT) GO TO 40
      IF (ICOMP.EQ.0) GO TO 20
C          CHECK TO SEE IF COMPONENT IS ALREADY IN LIST
      DO 10 I1=1,ICOMP
      IF (LMIN(I,I1).EQ.LMIN0(I,J)) GO TO 30
   10 CONTINUE
   20 CONTINUE
C          COMPONENT NOT IN LIST
      ICOMP=ICOMP+1
      LMIN(I,ICOMP)=LMIN0(I,J)
      CMIN(I,ICOMP)=CMIN0(I,J)
      GO TO 90
C         COMPONENT ALREADY IN LIST
   30 CONTINUE
      CMIN(I,I1)=CMIN(I,I1)+CMIN0(I,J)
      GO TO 90
C          COMPONENT MUST BE REDUCED TO MASTER SPECIES
   40 CONTINUE
      J1=LMIN0(I,J)
      K1=NSP(J1)
      NONMAS=NONMAS+1
      LMCON(I,NONMAS)=J1
      CMCON(I,NONMAS)=-CMIN0(I,J)
C          LOOP THROUGH MASTER SPECIES OF NON-MASTER SPECIES COMPONENT
      DO 80 I1=1,K1
      IF (ICOMP.EQ.0) GO TO 60
      DO 50 L1=1,ICOMP
      IF (LSP(J1,I1).EQ.LMIN(I,L1)) GO TO 70
   50 CONTINUE
C          MASTER SPECIES NOT IN LIST
   60 CONTINUE
      ICOMP=ICOMP+1
      LMIN(I,ICOMP)=LSP(J1,I1)
      CMIN(I,ICOMP)=CMIN0(I,J)*CSP(J1,I1)
      GO TO 80
C          MASTER SPECIES IN LIST
   70 CONTINUE
      CMIN(I,L1)=CMIN(I,L1)+CMIN0(I,J)*CSP(J1,I1)
   80 CONTINUE
C          END LOOP MASTER SPECIES OF NON MASTER SPECIES COMPONENT
   90 CONTINUE
      NMIN(I)=ICOMP
      NMCON(I)=NONMAS
C          END LOOP ON SINGLE MINERAL
  100 CONTINUE
C          END ALL MINERALS
      RETURN
      END
      SUBROUTINE PICK1
      INCLUDE 'PHREEQE.CM'
C
C          THIS SUBROUTINE CHOOSES THE MODEL FOR THE INITIAL SOLUTIONS
C
      DZOFF=0D0
      IIN(1)=1
      IIN(2)=0
      IIN(3)=0
      NMINS=0
      IFE=1
      ILE=1
      IF (IESPEC.EQ.1) GO TO 10
      IIN(1)=0
      IFE=0
      ILE=0
   10 CONTINUE
C          CHECK ALKALINITY TOTAL
      DALKT=0D0
      IASPEC=IALK(ISOL)
      IF (IASPEC.EQ.0) GO TO 30
      IF (TOTAL(ISOL,IASPEC).GT.0D0) GO TO 20
      WRITE(IW,140)
      ENDFILE (UNIT=IW)
      STOP
   20 CONTINUE
      DALKT=TOTAL(ISOL,IASPEC)
      IF (IESPEC.EQ.0.OR.IESPEC.NE.IASPEC) GO TO 30
      WRITE(IW,150)
      ENDFILE (UNIT=IW)
      STOP
   30 CONTINUE
      DNEUT=0.0D0
      IF (IESPEC.LT.4) GO TO 40
C          MAKE SURE NEUTRAL SPECIES .GT. 0
      DNEUT=TOT(IESPEC)
      IF (TOT(IESPEC).LE.0D0) TOT(IESPEC)=1D-3
   40 CONTINUE
      CALL INOUT
C          SET COUNTERS ON THE ARRAY
      IFTH=0
      ILTH=0
      IFT=ILE+1
      ILT=ILT
      IFM=0
      ILM=0
      NEQ=ILT
      NEQ1=NEQ+1
      RETURN
C     *****
      ENTRY PICK2
C     *****
C
C          THIS SUBROUTINE CHOOSES THE MODEL FOR THE REACTION SOLUTIONS
C
      IIN(1)=1
      IIN(2)=0
      IF (IOPT(5).GT.0) IIN(2)=1
      IIN(3)=0
      IESPEC=1
      IASPEC=0
      NMINS=NRMINS
C          ADD IN ANY MINERALS NOT INCLUDED IN TOTALS
      IF (NMINS.EQ.0) GO TO 110
      TOT(3)=1D0
      ICK=0
      DO 50 I=1,NMINS
      TOT(MAXT+I)=0D0
   50 CONTINUE
   55 CONTINUE
C          CHECK TO MAKE SURE NECESSARY TOTALS > 0.
      JCK=0
      ICK=ICK+1
      DO 70 I=1,NMINS
      IF (IOPT(3).EQ.6.AND.I.EQ.1) GO TO 70
      K=NMIN(I)
C          IF TOTALS > 0 NEXT MINERAL
      DO 60 J=1,K
      IF (LMIN(I,J).LT.4) GO TO 60
      IF(TOT(LMIN(I,J)).GT.0D0) GO TO 60
      GO TO 65
   60 CONTINUE
      GO TO 70
   65 CONTINUE
C          SOME TOTAL <= 0.  IF ALL CMIN > 0 ADD MINERAL.
      DO 75 J=1,K
      IF (LMIN(I,J).LT.4) GO TO 75
      IF (CMIN(I,J).GT.0) GO TO 75
      GO TO 85
   75 CONTINUE
      D=1D-6
C          ADD D OF MINERAL # I.
   95 CONTINUE
      TOT(MAXT+I)=D
      THOR=THOR+THMIN(I)*D
      DO 105 J=1,K
      K1=LMIN(I,J)
      IF(K1.LT.4)GO TO 105
      TOT(K1)=TOT(K1)+D*CMIN(I,J)
  105 CONTINUE
      GO TO 70
C          SOME TOTAL <= 0.  CHECK IF TOTALS <= 0 HAVE SAME SIGN FOR CMI
   85 CONTINUE
      NCNEG=0
      NCPOS=0
      D=1D1
      DO 115 J=1,K
      K1=LMIN(I,J)
      D1=TOT(K1)
      IF (D1.LE.0D0) GO TO 125
      IF (D1.LT.D) D=D1
      GO TO 115
  125 CONTINUE
      IF(CMIN(I,J).LE.0D0) NCNEG=1
      IF(CMIN(I,J).GT.0D0) NCPOS=1
  115 CONTINUE
      IF(NCNEG.GT.0.AND.NCPOS.GT.0) GO TO 135
      D=D/5D1
      IF(NCNEG.EQ.1) D=-D
      GO TO 95
  135 CONTINUE
      JCK=1
   70 CONTINUE
      IF(JCK.EQ.0) GO TO 145
      IF(ICK.LE.NMINS+1) GO TO 55
      WRITE(IW,155)
  155 FORMAT(1H1,90('*')/'I HAD TROUBLE ADDING MINERALS SO THAT',
     1      ' ALL THE NECESSARY ELEMENTS HAD POSITIVE CONCENTRATIONS.'/
     2      'PLEASE ADJUST INITIAL CONCENTRATIONS TO SOME SMALL ',
     3      'POSITIVE QUANTITY.'/90('*'))
      ENDFILE (UNIT=IW)
      STOP
  145 CONTINUE
C          ADD ANY REACTION ELEMENTS IF IOPT(3)=6.
      IF (IOPT(3).NE.6) GO TO 100
      DO 90 I=1,NCOMPS
      IF (TOT(LREAC(I)).GT.0D0) GO TO 90
      D=DSIGN(1D-6,CREAC(I))
      TOT(MAXT1)=D
      DO 80 J=1,NCOMPS
      THOR=THOR+CREAC(J)*THMEAN(J)*D
      TOT(LREAC(J))=TOT(LREAC(J))+CREAC(J)*D
   80 CONTINUE
      GO TO 100
   90 CONTINUE
  100 CONTINUE
      TOT(1)=1D1**(-PH)
      TOT(2)=1D1**(-PE)
      TOT(3)=1D0
  110 CONTINUE
      CALL INOUT
C          SET COUNTERS FOR ARRAY
      IFE=1
      ILE=1
      LAST=1
      IFTH=0
      ILTH=0
      IF (IIN(2).LE.0) GO TO 120
      IFTH=2
      ILTH=2
      LAST=2
  120 CONTINUE
      IFT=LAST+1
      ILT=ILT
      IFM=0
      ILM=0
      NEQ=ILT
      IF (NMINS.EQ.0) GO TO 130
      IFM=ILT+1
      ILM=ILT+NMINS
      NEQ=ILM
  130 CONTINUE
      NEQ1=NEQ+1
      RETURN
C
  140 FORMAT (1X,'CARBON WAS SPECIFIED AS ALKALINITY BUT WAS LESS ','THA
     1N OR EQUAL 0.0.'/1X,'CALCULATIONS TERMINATED')
  150 FORMAT (1X,'ALKALINITY SPECIES CAN NOT BE THE SAME AS THE ','NEUTR
     1AL SPECIES'/1X,'CALCULATIONS TERMINATED')
      END
      SUBROUTINE THORIT(T)
      INCLUDE 'PHREEQE.CM'
      T=0.0D0
      DALKS=0D0
      DO 10 I=1,LASTS
      IF (SFLAG(I).EQ.0) GO TO 10
      DALKS=DALKS+M(I)*ALKSP(I)
      T=T+M(I)*THSP(I)
   10 CONTINUE
      RETURN
C     *****
      ENTRY SOLN
C     *****
      WRITE(IW,260) ISOL,(HEAD(ISOL,I),I=1,20)
      DO 20 I=1,MAXT
      TOT(I)=TOTAL(ISOL,I)
   20 CONTINUE
      THOR=0.0D0
      TC=TEMP(ISOL)
      TK=TC+273.15
      PH=-DLOG10(TOT(1))
      PE=-DLOG10(TOT(2))
      RETURN
C     *****
      ENTRY SAVE
C     *****
      IF (IOPT(7).EQ.0) RETURN
      K=IOPT(7)
      DO 30 I=1,MAXT
      TOTAL(K,I)=TOT(I)
   30 CONTINUE
      TEMP(K)=TC
      TH(K)=THOR
      DIFFZ(K)=DZOFF
      RETURN
C     *****
      ENTRY CHKSPE (IERR1)
C     *****
C          CHECK MASTER SPECIES IN AQUEOUS SPECIES
      DO 80 I=1,MAXS
      IF (NSP(I).LE.0) GO TO 80
      K=NSP(I)
      DO 70 J=1,K
      L=LSP(I,J)
      IF (L.GE.1.AND.L.LE.MAXT) GO TO 70
      WRITE(IW,270) I,SNAME(I)
      IERR1=1
   70 CONTINUE
   80 CONTINUE
C          CHECK SPECIES
      DO 100 I=MAXT1,MAXS
      K=NSP(I)
      IF (K.EQ.0) GO TO 100
      Z=0.0D0
      DO 90 J=1,K
      Z=Z+ZSP(LSP(I,J))*CSP(I,J)
   90 CONTINUE
      IF (DABS(ZSP(I)-Z).LT.1D-5) GO TO 100
      IERR1=1
      WRITE(IW,280) I,SNAME(I)
  100 CONTINUE
      RETURN
C     *****
      ENTRY CHKMIN (IERR2)
C     *****
C          CHECK MINERALS FOR CHARGE AND VALENCE
      IF (NRMINS.EQ.0) GO TO 140
      THSP(2)=-1D0
      DO 130 I=1,NRMINS
      K=NMIN0(I)
      Z=0.0D0
      THR=0.0D0
      DO 110 J=1,K
      Z=Z+ZSP(LMIN0(I,J))*CMIN0(I,J)
      THR=THR+THSP(LMIN0(I,J))*CMIN0(I,J)
  110 CONTINUE
      IF (DABS(Z).LT.1D-5) GO TO 120
      IERR2=2
      WRITE(IW,290) I,MNAME(I)
  120 CONTINUE
      IF (DABS(THR-THMIN(I)).LT.1D-5) GO TO 130
      IERR2=3
      WRITE(IW,300) I,MNAME(I)
  130 CONTINUE
      THSP(2)=0D0
  140 CONTINUE
      RETURN
C     *****
      ENTRY CHKLK
C     *****
C          CHECK LOOK MINERALS
      IF (NLOOKS.EQ.0) GO TO 170
      DO 160 I=1,NLOOKS
      K=NLOOK(I)
      Z=0.0D0
      DO 150 J=1,K
      Z=Z+ZSP(LLOOK(I,J))*CLOOK(I,J)
  150 CONTINUE
      IF (DABS(Z).LT.1D-5) GO TO 160
      WRITE(IW,310) I,NAMELK(I)
  160 CONTINUE
  170 CONTINUE
      RETURN
C     *****
      ENTRY UNITS(ISOLN)
C     *****
      IASPEC=IALK(ISOLN)
      IF (IUNITS(ISOLN).EQ.0) GO TO 250
      IF (IUNITS(ISOLN).NE.1) GO TO 190
C          MMOLES/L
      DO 180 I=4,MAXT
      TOTAL(ISOLN,I)=TOTAL(ISOLN,I)*GFW(I)
  180 CONTINUE
      IUNITS(ISOLN)=2
  190 CONTINUE
      IF (IUNITS(ISOLN).NE.2) GO TO 210
C          MG/L
      DO 200 I=4,MAXT
      TOTAL(ISOLN,I)=TOTAL(ISOLN,I)/SDENS(ISOLN)
  200 CONTINUE
      IUNITS(ISOLN)=3
  210 CONTINUE
      IF (IUNITS(ISOLN).NE.3) GO TO 256
C          PPM
      TOTMG=0.0D0
      DO 220 I=4,MAXT
      TOTMG=TOTMG+TOTAL(ISOLN,I)
  220 CONTINUE
      C=1.0-TOTMG*1E-06
      IF (C.GT.0.0) GO TO 230
      WRITE(IW,320)
      ENDFILE (UNIT=IW)
      STOP
  230 CONTINUE
      C=1.0/(C*1E+03)
      DO 240 I=4,MAXT
      IF (TOTAL(ISOLN,I).LE.0.0D0) GO TO 240
      TOTAL(ISOLN,I)=C*TOTAL(ISOLN,I)/GFW(I)
  240 CONTINUE
      GO TO 250
  256 CONTINUE
      IF(IUNITS(ISOLN).NE.4) GO TO 400
C     MMOL/KG SOLN
      DO 257 I=4,MAXT
      IF(TOTAL(ISOLN,I).LE.0.0D0) GO TO 257
      TOTAL(ISOLN,I) = TOTAL(ISOLN,I)*GFW(I)
  257 CONTINUE
C     NOW IN PPM
      IUNITS(ISOLN)=3
      GO TO 210
  400 WRITE(IW,410)
      ENDFILE (UNIT=IW)
      STOP
  250 CONTINUE
C          UNITS ARE NOW MOLALITY
      RETURN
C
  260 FORMAT (1H1,'SOLUTION NUMBER ',I1,/,1X,20A4/)
  270 FORMAT (1X,I4,2X,A8,5X,'SPECIES HAS A MASTER SPECIES NUMBER OUT OF
     1        RANGE')
  280 FORMAT (1H ,'***** ERROR IN SPECIES NUMBER',I4,'  ',A8,'REACTION D
     1OES NOT CHARGE BALANCE.')
  290 FORMAT (1H ,'***** ERROR IN MINERAL NUMBER',I4,2X,A8,' REACTION DO
     1ES NOT CHARGE BALANCE.')
  300 FORMAT (1H ,'***** ERROR IN MINERAL NUMBER',I4,2X,A8,' REACTION',
     1/,7X,'DOES NOT BALANCE THE SPECIFIED VALENCE.')
  310 FORMAT (1H ,'***** WARNING:  LOOK MINERAL NUMBER',I4,2X,A8,' REACT
     1ION',/,7X,'DOES NOT CHARGE BALANCE.')
  320 FORMAT (1H1,80('*')//'TERMINAL ERROR'/'TOTAL SALT PPM GREATER ','T
     1HAN 1 MILLION.'/'CHECK CONCENTRATION UNITS AND ELEMENT',' GRAM FOR
     2MULA WEIGHT INPUT',//,1X,80('*'))
  410 FORMAT(///,10X,'*** TERMINAL ERROR **** UNITS OF CONCENTRATION UNK
     1NOWN',///)
      END
      SUBROUTINE ZEROAR
      INCLUDE 'PHREEQE.CM'
      IF (IESPEC.GE.2) IIN(1)=1
      IIN(3)=1
      DO 60 I=1,LASTT
      CALCT(I)=0D0
      IF (IIN(I).EQ.0.AND.ITER.GT.1) GO TO 50
      DO 40 J=1,LASTT
      AR(I,J)=0.0D0
   40 CONTINUE
   50 CONTINUE
   60 CONTINUE
      IF (IESPEC.GE.2) IIN(1)=0
      IIN(3)=0
      RETURN
      END
*
      SUBROUTINE CDSI(DSI_rs)
      INCLUDE 'PHREEQE.CM'
      real*8 DSI_rs(MAXLK)
      if (NLOOKS.EQ.0) RETURN
      kk=0
      do i=1,NLOOKS
        k    = NLOOK(I)
        diap = 0D0
        do j=1,k
          ll = LLOOK(I,J)
          IF (SFLAG(LL).LE.0) GO TO 190
          DIAP = DIAP+(LG(LL)+LM(LL))*CLOOK(I,J)
        end do
        IF (kk.EQ.0) kk = 1
        DSI_rs(i) = DIAP-LKLOOK(I)
  190 end do
      END
C
C  CLRSCR - This subroutine will clear the screen
       SUBROUTINE CLRSCR()
       WRITE(*,10) CHAR(27) !CHAR(27) IS ASCII FOR ESCAPE
10     FORMAT(1X,A,'[2J')    !'ESC[J' IS THE SCREEN CLEARING CODE
       END
C
CCCCC THE FOLLOWING SUBROUTINE IS SPECIFIC TO MICROSOFT FORTRAN 5.0
      SUBROUTINE DATE(IYR,IMON,IDAY,IHR,IMIN,ISEC)
      INTEGER*2 IYR,IMON,IDAY,IHR,IMIN,ISEC,I100TH
*     CALL GETTIM(IHR,IMIN,ISEC,I100TH)
*     CALL GETDAT(IYR,IMON,IDAY)
*     Zeit und Datum werden einfach gesetzt.
      IHR    = 21
      IMIN   = 35
      ISEC   = 0
      I100TH = 0
      IYR    = 1993
      IMON   = 3
      IDAY   = 16
      RETURN
      END





