************************************************************************
*                                                                      *
*    Datei                                                             *
*      Plotter.for                                                     *
*                                                                      *
*    Inhalt                                                            *
*      Subroutinen zum Plotten von Kurven. Diese Subroutine machen zum *
*      Teil ausfhrlich gebrauchen von FTN77-Spezialroutinen.          *
*                                                                      *
************************************************************************
*                                                                      *
*    Copyright                                                         *
*      Der in dieser Datei enthaltene Quellcode darf ohne Genehmigung  *
*      und weitere Vergtung weiterentwickelt werden. Diese Copyright  *
*      Erklrung darf um eigene Urherberrechtserklrungen erweitert    *
*      werden. Die Verwendung dieses Quelltextes fr Publikationen     *
*      ist, auch bei auszugsweiser Verwendung, grundstzlich Genehmi-  *
*      gungspflichtig (kostet nix, ich wrdes halt nur gerne wissen).  *
*                                                                      *
*      Der Programmautor weist darauf hin, da Software nicht fehler-  *
*      frei zu erstellen ist. Die Korrektheit des Quellcodes ist da-   *
*      her auf geeignete Weise zu berprfen.                          *
*                                                                      *
************************************************************************
*                                                                      *
*    Programmautor                                                     *
*      Dr. Rainer Sieger                                               *
*      Alfred-Wegener-Institut fr Meeres- und Polarforschung          *
*      Postfach 12 01 61                                               *
*      27515 Bremerhaven                                               *
*      e-mail: rsieger@AWI-Bremerhaven.de                              *
*                                                                      *
************************************************************************
*                                                                      *
*    letztes Editierdatum                                              *
*      16.3.94                                                         *
*                                                                      *
************************************************************************

************************************************************************

      Subroutine Plotter(Aufruf,Darstellung,Waits,
     *                   Anzahl_MS,MS,PN,
     *                   Messwerte,
     *                   t,t_max,dx,MS_Name,
     *                   n,Site,
     *                   C_nf,C_in,C,S_nf,S)

************************************************************************

      Include 'nT.inc'
      Include 'nmax.inc'
      Include 'nmess.inc'

      Integer*2  n_site
      Parameter (n_site = 2)         ! Two-Site-Isotherme

************************************************************************

      Integer*2  Taste               ! Taste
      Integer*2  Anzahl_MS           ! # Tracer
      Integer*2  MS(nT)              ! Traceraktiv ?
      Integer*2  PN(nT)              ! Phreeqe-Nr.
      Integer*2  n                   ! # der REV
      Integer*2  Site(nT)            ! Isotherme
      Integer*2  max_Site            ! max. vorkommende Site
      Integer*2  pk(2,nT)            ! alte Pixel-Koordinaten
      Integer*2  Aufruf              ! 1=ini, 2=plott, 3=Texmodus
      Integer*2  Darstellung         ! Konz, Sule, Sediment
      Integer*2  Waits               ! Warteschleife

      Real       Messwerte(nmess,4)  ! Messwerte

      Real*8     t                   ! Zeit seit Beginn der Simulation
      Real*8     t_max               ! max. Zeit
      Real*8     dx(nmax)            ! Zellenweite
      Real*8     W(nmax,nT)          ! Wert-bergabe
      Real*8     C(nmax,nT)          ! Konzentrationen
      Real*8     C_in(nT)            ! Input-Konzentration
      Real*8     C_nf(nT)            ! Inputkonzentrationen
      Real*8     S(nmax,n_site,nT)   ! sorbierte Stoffmenge
      Real*8     S_nf(n_site,nT)     ! Normierungsfaktor fr S

      Integer*2  pos(8)              ! Positionen der Fenster
      Integer*2  offset(2)           ! Offset fr Markerbox

      Real*8     K(12)               ! Umrechnungskonstanten
      Real*8     defbe(4)            ! Definitionsbereich
      Real*8     X                   ! Sulenende

      Character*10  MS_Name(nT)      ! Namen der Masterspezies

************************************************************************

      SAVE       pk, pos, offset, K, defbe, max_Site

************************************************************************

      if (Aufruf.EQ.1) then
        call VGA@
        if (Darstellung.EQ.1) then
          max_Site = 0
          call set_pos(60,50,0,0,0,0,500,380,pos)
          call set_offset(510,-140,offset)
          call set_defbe(0.D0,t_max,-3.D-2,1.07D0,defbe)
          call Umrechnungskonstanten(pos,defbe,K)
          call Plot_DGK(1,n,Anzahl_MS,MS,PN,t,K,pk,C_nf,C)
        else
          call calc_X(n,dx,X)
        end if

        if ((Darstellung.GT.1) .AND. (Darstellung.LT.8)) then
          max_Site = 0
          call set_pos(60,50,0,0,0,0,500,380,pos)
          call set_offset(510,-140,offset)
          call set_defbe(0.D0,X,-3.D-2,1.07D0,defbe)
          call Umrechnungskonstanten(pos,defbe,K)
        end if

        if ((Darstellung.GT.7) . AND. (Darstellung.LT.10)) then
          call calc_max_Site(Anzahl_MS,MS,Site,max_Site)
          if (max_Site.EQ.0) then
            call set_pos(60,50,0,0,0,0,500,380,pos)
          end if
          if (max_Site.EQ.1) then
            call set_pos(60,50,60,245,0,0,500,185,pos)
          end if
          if (max_Site.EQ.2) then
            call set_pos(60,50,60,180,60,310,500,120,pos)
          end if
          call set_offset(510,-140,offset)
          call set_defbe(0.D0,X,-3D-2,1.07D0,defbe)
          call Umrechnungskonstanten(pos,defbe,K)
        end if

        if (Darstellung.GT.9) then  ! Sediment
          max_Site = 0
          call set_pos(60,50,0,0,0,0,230,380,pos)
          call set_offset(250,-250,offset)
          call set_defbe(0.D0,1.07D0,-X,0.D0,defbe)
          call Umrechnungskonstanten(pos,defbe,K)
        end if

        call Koordinatensystem(Darstellung,Messwerte,Anzahl_MS,MS,
     *                         MS_Name,max_Site,pos,K,offset,defbe)
      endif

      if (Aufruf.GT.1) then
        call Loesche_Fenster(Darstellung,pos,max_Site)
        if (Darstellung.LT.10) then
          call SET_CURSOR_POS@(4,28)
          write(*,'(A,F10.3)') 'Zeit : ', t
        else
          call SET_CURSOR_POS@(40,4)
          write(*,'(A,F10.3)') 'Zeit : ', t
        end if
      end if

      if (Aufruf.GT.0) then  ! also immer
        if (Darstellung.EQ.1)  then
          call Plot_DGK(2,n,Anzahl_MS,MS,PN,t,K,pk,C_nf,C)
        end if

        if ((Darstellung.EQ.2) .OR. (Darstellung.EQ.5)) then
          do l=1,Anzahl_MS
            if (MS(l).EQ.1) then
              W(n+2,l) = C_in(l)/C_nf(l)
              do i=1,n+1
                W(i,l) = C(i,l)/C_nf(l)
              end do
            end if
          end do
          call Plot_Messwerte(1,Messwerte,defbe(1),defbe(2),K)
          call Plot_Saeule(Darstellung,n,Anzahl_MS,MS,
     *                     k(1),k(2),k(3),k(4),dx,W)
        end if

        if ((Darstellung.EQ.3) .OR. (Darstellung.EQ.6)) then
          do l=1,Anzahl_MS
            if (MS(l).EQ.1) then
              W(n+2,l) = S(1,1,l)/S_nf(1,l)
              do i=1,n+1
                W(i,l) = S(i,1,l)/S_nf(1,l)
              end do
            end if
          end do
          call Plot_Messwerte(1,Messwerte,defbe(1),defbe(2),K)
          call Plot_Saeule(Darstellung,n,Anzahl_MS,MS,
     *                     k(1),k(2),k(3),k(4),dx,W)
        end if

        if ((Darstellung.EQ.4) .OR. (Darstellung.EQ.7)) then
          do l=1,Anzahl_MS
            if (MS(l).EQ.1) then
              W(n+2,l) = S(1,2,l)/S_nf(2,l)
              do i=1,n+1
                W(i,l) = S(i,2,l)/S_nf(2,l)
              end do
            end if
          end do
          call Plot_Messwerte(1,Messwerte,defbe(1),defbe(2),K)
          call Plot_Saeule(Darstellung,n,Anzahl_MS,MS,
     *                     k(1),k(2),k(3),k(4),dx,W)
        end if

        if ((Darstellung.EQ.8) .OR. (Darstellung.EQ.9)) then
          do l=1,Anzahl_MS
            if (MS(l).EQ.1) then
              W(n+2,l) = C_in(l)/C_nf(l)
              do i=1,n+1
                W(i,l) = C(i,l)/C_nf(l)
              end do
            end if
          end do
          call Plot_Messwerte(1,Messwerte,defbe(1),defbe(2),K)
          call Plot_Saeule(Darstellung,n,Anzahl_MS,MS,
     *                     k(1),k(2),k(3),k(4),dx,W)

          if (max_Site.GE.1) then
            do l=1,Anzahl_MS
              if (MS(l).EQ.1) then
                W(n+2,l) = S(1,1,l)/S_nf(1,l)
                do i=1,n+1
                  W(i,l) = S(i,1,l)/S_nf(1,l)
                end do
              end if
            end do
            call Plot_Messwerte(1,Messwerte,defbe(1),defbe(2),K)
            call Plot_Saeule(Darstellung,n,Anzahl_MS,MS,
     *                       k(5),k(6),k(7),k(8),dx,W)
          end if

          if (max_Site.EQ.2) then
            do l=1,Anzahl_MS
              if (MS(l).EQ.1) then
                W(n+2,l) = S(1,2,l)/S_nf(2,l)
                do i=1,n+1
                  W(i,l) = S(i,2,l)/S_nf(2,l)
                end do
              end if
            end do
            call Plot_Messwerte(1,Messwerte,defbe(1),defbe(2),K)
            call Plot_Saeule(Darstellung,n,Anzahl_MS,MS,
     *                       k(9),k(10),k(11),k(12),dx,W)
          end if
        end if

        if (Darstellung.GT.9) then
          do l=1,Anzahl_MS
            if (MS(l).GT.0) then
              do i=1,n+1
                if ((PN(l).EQ.1) .AND. (C_nf(l).GT.1)
     *                           .AND. (C(i,l).GT.1E-20)) then
                  W(i,l) = -DLOG10(C(i,l))/C_nf(l)
                else
                  W(i,l) = C(i,l)/C_nf(l)
                end if
              end do
              if ((PN(l).EQ.1) .AND. (C_nf(l).GT.1)) then
                W(n+2,l) = -DLOG10(C_in(l))/C_nf(l)
              else
                W(n+2,l) = C_in(l)/C_nf(l)
              end if
            end if
          end do
          call Plot_Messwerte(2,Messwerte,defbe(1),defbe(2),K)
          call Plot_Sediment(Darstellung,n,Anzahl_MS,MS,
     *                       k(1),k(2),k(3),k(4),dx,W)
        end if
      end if

      if (Aufruf.EQ.3) then
        call CLEAR_SCREEN_AREA@(390,457,630,475,1)
        call DRAW_TEXT@('Weiter mit <ESC> - Taste ...',400,460,14)
        Taste = 0
        do while(Taste.NE.27)
          call get_key1@(Taste)
        end do
        call text_mode@
      end if

      if (Aufruf.EQ.4) then
        call Pause(waits)
        call text_mode@
      end if

      End

************************************************************************

      Subroutine set_pos(a,b,c,d,e,f,g,h,pos)

      Integer*2  a, b, c, d, e, f, g, h, pos(8)

      pos(1) = a
      pos(2) = b
      pos(3) = c
      pos(4) = d
      pos(5) = e
      pos(6) = f
      pos(7) = g
      pos(8) = h

      End

************************************************************************

      Subroutine set_offset(a,b,offset)

      Integer*2  a, b, offset(2)

      offset(1) = a
      offset(2) = b

      End

************************************************************************

      Subroutine set_defbe(a,b,c,d,defbe)

      real*8    a, b, c, d, defbe(4)

      defbe(1)  = a
      defbe(2)  = b
      defbe(3)  = c
      defbe(4)  = d

      End

************************************************************************

      Subroutine calc_X(n,dx,X)

      Include 'nmax.inc'

      Integer*2  i, n

      Real*8     dx(nmax), X

      X = dx(1)/2.D0
      do i=2,n+1
        X = X + dx(i-1)/2.D0 + dx(i)/2.D0
      end do

      End

************************************************************************

      Subroutine calc_max_Site(Anzahl_MS,MS,Site,max_Site)

      Include    'nT.inc'

      Integer*2  l                   ! Laufvariable
      Integer*2  Anzahl_MS           ! # Tracer
      Integer*2  MS(nT)              ! Traceraktiv ?
      Integer*2  Site(nT)            ! Isotherme
      Integer*2  max_Site            ! max vorkommende Site

      max_Site = 0
      do l=1, Anzahl_MS
        if (MS(l).GT.0) then
          if (Site(l).GT.max_Site)  max_Site = Site(l)
        end if
      end do

      End

************************************************************************

      Subroutine Umrechnungskonstanten(pos,defbe,K)

      Integer*2  pos(8)              ! Positionen der Fenster
      Integer*2  i                   ! Laufvariable

      Real*8     K(12)               ! Umrechnungskonstanten
      Real*8     defbe(4)            ! Definitionsbereich

************************************************************************

      do i=1,12
        k(i) = 0.D0
      end do

      if (((defbe(2)-defbe(1)).GT.0.D0) .AND.
     *    ((defbe(4)-defbe(3)).GT.0.D0)) then
        k(1) = pos(7)/(defbe(2)-defbe(1))
        k(2) = k(1)*defbe(1) - pos(1)
        k(3) = pos(8)/(defbe(4)-defbe(3))
        k(4) = k(3)*defbe(3) + pos(2) + pos(8)

        k(5) = pos(7)/(defbe(2)-defbe(1))
        k(6) = k(5)*defbe(1) - pos(3)
        k(7) = pos(8)/(defbe(4) - defbe(3))
        k(8) = k(7)*defbe(3) + pos(4) + pos(8)

        k(9)  = pos(7)/(defbe(2) - defbe(1))
        k(10) = k(9)*defbe(1) - pos(5)
        k(11) = pos(8)/(defbe(4)-defbe(3))
        k(12) = k(11)*defbe(3) + pos(6) + pos(8)
      end if

      End

************************************************************************

      Subroutine Koordinatensystem(Darstellung,
     *                             Messwerte,
     *                             Anzahl_MS,MS,MS_Name,max_Site,
     *                             pos,K,offset,defbe)

************************************************************************

      Include 'nT.inc'
      Include 'nmess.inc'

      Integer*2     Darstellung         ! DGK, Sule, Sediment
      Integer*2     Anzahl_MS           ! # Tracer
      Integer*2     MS(nT)              ! Traceraktiv ?
      Integer*2     max_Site            ! max. vorkommende Site

      Real          Messwerte(nmess,4)  ! Messwerte

      Integer*2     pos(8)              ! Fensterpositionen
      Integer*2     offset(2)           ! Markerbox
      Integer*2     px, py              ! Pixel-Koordinaten

      Real*8        defbe(4)            ! Definitionsbereich
      Real*8        K(12)               ! Umrechnungskonstanten

      Character*10  MS_Name(nT)         ! Namen der Masterspezies

************************************************************************
*     Koordinatenkreuz zeichnen und beschriften

      if (max_Site.EQ.0) then
        call rectangle@(pos(1),pos(2),pos(1)+pos(7),pos(2)+pos(8),7)
      end if
      if (max_Site.EQ.1) then
        call rectangle@(pos(1),pos(2),pos(1)+pos(7),pos(2)+pos(8),7)
        call rectangle@(pos(3),pos(4),pos(3)+pos(7),pos(4)+pos(8),7)
      end if
      if (max_Site.EQ.2) then
        call rectangle@(pos(1),pos(2),pos(1)+pos(7),pos(2)+pos(8),7)
        call rectangle@(pos(3),pos(4),pos(3)+pos(7),pos(4)+pos(8),7)
        call rectangle@(pos(5),pos(6),pos(5)+pos(7),pos(6)+pos(8),7)
      end if

      if (Darstellung.EQ.1) then
        call X_Skalierung(Darstellung,max_Site,pos,K,defbe)
        call Y_Skalierung(Darstellung,max_Site,pos,K,defbe)
        call Plot_Messwerte(0,Messwerte,defbe(1),defbe(2),K)
        call SET_TEXT_ATTRIBUTE@(3,2.,0.,0.,0.)
        call DRAW_TEXT@('Durchgangskurve',200,40,7)
      end if

      if ((Darstellung.GT.1) .AND. (Darstellung.LT.10)) then
        call X_Skalierung(Darstellung,max_Site,pos,K,defbe)
        call Y_Skalierung(Darstellung,max_Site,pos,K,defbe)
        call Plot_Messwerte(1,Messwerte,defbe(1),defbe(2),K)
        call SET_TEXT_ATTRIBUTE@(3,2.,0.,0.,0.)
        if (max_Site.EQ.0) then
          call DRAW_TEXT@('Sulenverteilung',200,40,7)
        else
          call DRAW_TEXT@('Sulenverteilungen',200,40,7)
        end if
      end if

      if (Darstellung.GT.9) then
        call X_Skalierung(Darstellung,max_Site,pos,K,defbe)
        call Y_Skalierung(Darstellung,max_Site,pos,K,defbe)
        call Plot_Messwerte(2,Messwerte,defbe(1),defbe(2),K)
        call SET_TEXT_ATTRIBUTE@(3,1.5,0.,0.,0.)
        call DRAW_TEXT@('Sulenverteilung',80,40,7)
      end if
      call SET_TEXT_ATTRIBUTE@(1,0.,0.,0.,0.)

      if (Darstellung.LT.10) then
        call Tracer_Legende(pos(1),pos(2),offset(1),offset(2),
     *                      Anzahl_MS,MS)
      else
        call Tracer_Legende(pos(2),pos(2),offset(1),offset(2),
     *                      Anzahl_MS,MS)
        call DRAW_LINE@(360,430,360,158,0)
        call rectangle@(460,430,300,160,7)
        px = pos(1)+pos(7)+65
        py = pos(2)+pos(8)-278
        do l=1,Anzahl_MS
          if (MS(l).GT.0) then
            call DRAW_TEXT@(MS_Name(l),px,py+l*13,7)
          end if
        end do
      end if

      call CLEAR_SCREEN_AREA@(480,457,630,475,4)
      call DRAW_TEXT@('Abbruch mit <ESC>',490,460,14)

      End

************************************************************************
************************************************************************
************************************************************************

      Subroutine X_Skalierung(Darstellung,max_Site,pos,K,defbe)

************************************************************************

      External    x_in_px             ! Funktionen

      Integer*2   Darstellung         ! DGK, Sule, Sediment
      Integer*2   i                   ! Laufvariable
      Integer*2   x_in_px             ! Funktionen
      Integer*2   px, py              ! Pixel-Koordinaten
      Integer*2   max_Site            ! max. vorkommende Sites
      Integer*2   pos(8)              ! Fensterpositionen

      Real*8      K(12)               ! Umrechnungskonstanten
      Real*8      defbe(4)            ! Definitionsbereich

************************************************************************

      if (Darstellung.LT.8) then
        py = pos(2)+pos(8)
        do i=0,10
          px = x_in_px(k(1),k(2),DFLOAT(i)/10.D0*defbe(2))
          call DRAW_LINE@(px,py,px,py+5,7)
        end do
      end if

      if ((Darstellung.GT.7) .AND. (Darstellung.LT.10)) then
        if (max_Site.EQ.0)  py = pos(2)+pos(8)
        if (max_Site.EQ.1)  py = pos(4)+pos(8)
        if (max_Site.EQ.2)  py = pos(6)+pos(8)
        do i=0,10
          px = x_in_px(k(1),k(2),DFLOAT(i)/10.D0*defbe(2))
          call DRAW_LINE@(px,py,px,py+5,7)
        end do
      end if

      if (Darstellung.EQ.1) then
        call DRAW_TEXT@('t_max',pos(1)+pos(7)-20,pos(2)+pos(8)+5,7)
      end if

      if ((Darstellung.GT.1) .AND. (Darstellung.LT.10)) then
        call DRAW_TEXT@('X',pos(1)+pos(7)-6,438,7)
      end if

      if (Darstellung.GT.9) then
        py = pos(2)+pos(8)
        do i=0,10
          px = x_in_px(k(1),k(2),DFLOAT(i)/10.D0)
          call DRAW_LINE@(px,py,px,py+5,7)
        end do
        px = x_in_px(k(1),k(2),0.D0)
        py = pos(2)+pos(8)+10
        call DRAW_TEXT@('0 %',px-5,py,7)
        px = x_in_px(k(1),k(2),0.5D0)
        call DRAW_TEXT@('50 %',px-7,py,7)
        px = x_in_px(k(1),k(2),1.D0)
        call DRAW_TEXT@('100 %',px-10,py,7)
        call DRAW_TEXT@('C/C_0',180,458,7)
      end if

      End

************************************************************************
************************************************************************
************************************************************************

      Subroutine Y_Skalierung(Darstellung,max_Site,pos,K,defbe)

************************************************************************

      External    y_in_py             ! Funktionen

      Integer*2   Darstellung         ! DGK, Sule, Sediment
      Integer*2   i                   ! Laufvariable
      Integer*2   y_in_py             ! Funktionen
      Integer*2   py                  ! Pixel-Koordinaten
      Integer*2   max_Site            ! max. vorkommende Sites
      Integer*2   pos(8)              ! Fensterpositionen

      Real*8      y                   ! Dummy
      Real*8      K(12)               ! Umrechnungskonstanten
      Real*8      defbe(4)            ! Definitionsbereich

************************************************************************

      if (Darstellung.LT.10) then
        do i=0,10
          py = y_in_py(k(3),k(4),DFLOAT(i)/10.D0)
          call DRAW_LINE@(pos(1)-5,py,pos(1),py,7)
        end do

        call DRAW_TEXT@('100 %',10,y_in_py(k(3),k(4),1.D0)-8,7)
        call DRAW_TEXT@('50 %',18,y_in_py(k(3),k(4),0.5D0)-8,7)
        call DRAW_TEXT@('0 %',26,y_in_py(k(3),k(4),0.D0)-8,7)
      end if

      if ((Darstellung.LE.2) .OR. (Darstellung.EQ.5)) then
        call DRAW_TEXT@('C/C_0',10,45,7)
      end if
      if ((Darstellung.EQ.3) .OR. (Darstellung.EQ.6)) then
        call DRAW_TEXT@('S1/S1_max',10,32,7)
      end if
      if ((Darstellung.EQ.4) .OR. (Darstellung.EQ.7)) then
        call DRAW_TEXT@('S2/S2_max',10,32,7)
      end if

      if ((Darstellung.GT.7) .AND. (Darstellung.LT.10)) then
        if (max_Site.EQ.0) then
          call DRAW_TEXT@('C/C_0',10,45,7)
        end if
        if (max_Site.GE.1) then
          do i=0,10
            py = y_in_py(k(7),k(8),DFLOAT(i)/10.D0)
            call DRAW_LINE@(pos(1)-5,py,pos(1),py,7)
            call DRAW_TEXT@('100 %',10,y_in_py(k(7),k(8),1.D0)-8,7)
            call DRAW_TEXT@('50 %',18,y_in_py(k(7),k(8),0.5D0)-8,7)
            call DRAW_TEXT@('0 %',26,y_in_py(k(7),k(8),0.D0)-8,7)
          end do
        end if
        if (max_Site.EQ.2) then
          do i=0,10
            py = y_in_py(k(11),k(12),DFLOAT(i)/10.D0)
            call DRAW_LINE@(pos(1)-5,py,pos(1),py,7)
            call DRAW_TEXT@('100 %',10,y_in_py(k(11),k(12),1.D0)-8,7)
            call DRAW_TEXT@('50 %',18,y_in_py(k(11),k(12),0.5D0)-8,7)
            call DRAW_TEXT@('0 %',26,y_in_py(k(11),k(12),0.D0)-8,7)
          end do
        end if
      end if

      if (Darstellung.GT.9) then
        do i=0,10
          y  = defbe(3)+DFLOAT(i)/10.D0*(defbe(4)-defbe(3))
          py = y_in_py(k(3),k(4),y)
          call DRAW_LINE@(pos(1)-5,py,pos(1),py,7)
        end do
        call DRAW_TEXT@('Tiefe',10,45,7)
        call DRAW_TEXT@('X',26,y_in_py(k(3),k(4),defbe(3))-8,7)
      end if

      End

************************************************************************
************************************************************************
************************************************************************

      Subroutine Tracer_Legende(oben_x,unten_y,offset_x,offset_y,
     *                          Anzahl_MS,MS)

************************************************************************

      Include 'nT.inc'

      Integer*2           l                   ! Laufvariablen
      Integer*2           Anzahl_MS           ! # Tracer
      Integer*2           MS(nT)              ! Traceraktiv ?

      Integer*2           Offset_x, Offset_y  !  Markerbox
      Integer*2           oben_x              !    "
      Integer*2           unten_y             !    "

************************************************************************

      call rectangle@(oben_x+offset_x+60,unten_y-offset_y-140,
     *                oben_x+offset_x,unten_y-offset_y+130,7)
      do l=1,Anzahl_MS
        if (MS(l).GT.0) then
          call fill_rectangle@(oben_x+offset_x+30,
     *                         unten_y-offset_y-145+l*13,
     *                         oben_x+offset_x+50,
     *                         unten_y-offset_y-139+l*13,
     *                         mod(l,15)+1)
        end if
      end do
      call DRAW_TEXT@('a.',oben_x+offset_x+10,unten_y-offset_y-135,7)
      call DRAW_TEXT@('b.',oben_x+offset_x+10,unten_y-offset_y-122,7)
      call DRAW_TEXT@('c.',oben_x+offset_x+10,unten_y-offset_y-109,7)
      call DRAW_TEXT@('d.',oben_x+offset_x+10,unten_y-offset_y-96,7)
      call DRAW_TEXT@('e.',oben_x+offset_x+10,unten_y-offset_y-83,7)
      call DRAW_TEXT@('f.',oben_x+offset_x+10,unten_y-offset_y-70,7)
      call DRAW_TEXT@('g.',oben_x+offset_x+10,unten_y-offset_y-57,7)
      call DRAW_TEXT@('h.',oben_x+offset_x+10,unten_y-offset_y-44,7)
      call DRAW_TEXT@('i.',oben_x+offset_x+10,unten_y-offset_y-31,7)
      call DRAW_TEXT@('j.',oben_x+offset_x+10,unten_y-offset_y-18,7)
      call DRAW_TEXT@('k.',oben_x+offset_x+10,unten_y-offset_y-5,7)
      call DRAW_TEXT@('l.',oben_x+offset_x+10,unten_y-offset_y+8,7)
      call DRAW_TEXT@('m.',oben_x+offset_x+10,unten_y-offset_y+21,7)
      call DRAW_TEXT@('n.',oben_x+offset_x+10,unten_y-offset_y+34,7)
      call DRAW_TEXT@('o.',oben_x+offset_x+10,unten_y-offset_y+47,7)
      call DRAW_TEXT@('p.',oben_x+offset_x+10,unten_y-offset_y+60,7)
      call DRAW_TEXT@('q.',oben_x+offset_x+10,unten_y-offset_y+73,7)
      call DRAW_TEXT@('r.',oben_x+offset_x+10,unten_y-offset_y+86,7)
      call DRAW_TEXT@('s.',oben_x+offset_x+10,unten_y-offset_y+99,7)
      call DRAW_TEXT@('t.',oben_x+offset_x+10,unten_y-offset_y+112,7)

      End

************************************************************************
************************************************************************
************************************************************************

      Subroutine Plot_Messwerte(Format,Messwerte,x_min,x_max,K)

************************************************************************

      Include 'nmess.inc'

      Integer*2    Format                   ! Ort oder Zeit
      Integer*2    i                        ! Laufvariable

      Real         Messwerte(nmess,4)       ! Messwerte

      Real*8       x_min, x_max             ! Bildschirmkoordinaten
      Real*8       K(12)                    ! Umrechnungskonstanten

************************************************************************

      if (Format.EQ.0) then
        do i=2, IFIX(Messwerte(1,1))+1
          if ((Messwerte(i,1).GE.x_min) .AND.
     *        (Messwerte(i,1).LE.x_max)) then
            call marker(K,Messwerte(i,1),Messwerte(i,2))
          end if
        end do
      end if

      if (Format.EQ.1) then
        do i=2, IFIX(Messwerte(1,3))+1
          if ((Messwerte(i,3).GE.x_min) .AND.
     *        (Messwerte(i,3).LE.x_max)) then
            call marker(K,Messwerte(i,3),Messwerte(i,4))
          end if
        end do
      end if

      if (Format.EQ.2) then
        do i=2, IFIX(Messwerte(1,3))+1
          if ((Messwerte(i,4).GE.x_min) .AND.
     *        (Messwerte(i,4).LE.x_max)) then
            call marker(K,Messwerte(i,4),-Messwerte(i,3))
          end if
        end do
      end if

      End

************************************************************************
************************************************************************
************************************************************************

      Subroutine marker(K,x,y)

      External   x_in_px, y_in_py

      Integer*2  Farbe
      Integer*2  x_in_px, y_in_py
      Integer*2  px, py
      Real       x, y
      Real*8     K(12)

      Farbe = 15  ! wei
      px = x_in_px(k(1),k(2),DBLE(x))
      py = y_in_py(k(3),k(4),DBLE(y))

      call draw_line@(px-3,py,px,py-3,Farbe)
      call draw_line@(px,py-3,px+3,py,Farbe)
      call draw_line@(px+3,py,px,py+3,Farbe)
      call draw_line@(px,py+3,px-3,py,Farbe)

      end

************************************************************************
************************* Funktionen ***********************************
************************************************************************

      Integer*2 Function x_in_px(k1,k2,x)

      Real*8       x, k1, k2

      x_in_px = NINT(x*k1-k2)

      End

************************************************************************

      Integer*2 Function y_in_py(k3,k4,y)

      Real*8       y, k3, k4

      y_in_py = NINT(k4-y*k3)

      End

************************************************************************

      Subroutine Plot_DGK(Aufruf,n,Anzahl_MS,MS,PN,t,K,pk,C_nf,C)

      Include 'nT.inc'
      Include 'nmax.inc'

      External    x_in_px, y_in_py   ! Funktionen

      Integer*2   x_in_px, y_in_py   ! Funktionen
      Integer*2   px, py             ! Pixel-Koordinaten
      Integer*2   pk(2,nT)           ! alte Pixel-Koordinaten

      Integer*2  l                   ! Laufvariable
      Integer*2  Anzahl_MS           ! # Tracer
      Integer*2  MS(nT)              ! Traceraktiv ?
      Integer*2  PN(nT)              ! Phreeqe-Nr.
      Integer*2  n                   ! # der REV
      Integer*2  Aufruf              ! Aufruf

      Real*8     t                   ! Zeit seit Beginn der Simulation
      Real*8     C(nmax,nT)          ! Konzentrationen
      Real*8     C_nf(nT)            ! Normierung
      Real*8     C_rel(nT)           ! Normierte Konzentrationen
      Real*8     K(12)               ! Umrechnungskonstanten

************************************************************************

      do l=1,Anzahl_MS
        if (MS(l).GT.0) then
          C_rel(l) = C(n+1,l)/C_nf(l)
          if (C_rel(l).GT.1.07D0) C_rel(l) = 1.07D0
          if (C_rel(l).LT.-3.D-2) C_rel(l) = -3.D-2
        end if
      end do

      if (Aufruf.EQ.1) then
        do l=1,Anzahl_MS
          if (MS(l).GT.0) then
            pk(1,l) = x_in_px(k(1),k(2),t)
            pk(2,l) = y_in_py(k(3),k(4),C_rel(l))
          end if
        end do
      else
        px = x_in_px(k(1),k(2),t)
        do l=1,Anzahl_MS
          if (MS(l).GT.0) then
            py = y_in_py(k(3),k(4),C_rel(l))
            call DRAW_LINE@(pk(1,l),pk(2,l),px,py,mod(l,15)+1)
            pk(2,l) = py
          end if
          pk(1,l) = px
        end do
      end if

      End

************************************************************************

      Subroutine Loesche_Fenster(Darstellung,pos,max_Site)

************************************************************************

      Integer*2   Darstellung        ! Darstellung
      Integer*2   max_Site           ! max. vorkommende Site
      Integer*2   pos(8)             ! Positionen der Fenster

************************************************************************

      if ((Darstellung.GT.4) .AND. (Darstellung.LT.8)) then
        call CLEAR_SCREEN_AREA@(pos(1)+1,pos(2)+1,pos(1)+pos(7)-1,
     *                          pos(2)+pos(8)-1,0)
        call RECTANGLE@(pos(1),pos(2),pos(1)+pos(7),pos(2)+pos(8),7)
      end if

      if (Darstellung.EQ.9) then
        call CLEAR_SCREEN_AREA@(pos(1)+1,pos(2)+1,pos(1)+pos(7)-1,
     *                          pos(2)+pos(8)-1,0)
        call RECTANGLE@(pos(1),pos(2),pos(1)+pos(7),pos(2)+pos(8),7)
        if (max_Site.GE.1) then
          call CLEAR_SCREEN_AREA@(pos(3)+1,pos(4)+1,pos(3)+pos(7)-1,
     *                            pos(4)+pos(8)-1,0)
          call RECTANGLE@(pos(3),pos(4),pos(3)+pos(7),pos(4)+pos(8),7)
        end if
        if (max_Site.EQ.2) then
          call CLEAR_SCREEN_AREA@(pos(5)+1,pos(6)+1,pos(5)+pos(7)-1,
     *                            pos(6)+pos(8)-1,0)
          call RECTANGLE@(pos(5),pos(6),pos(5)+pos(7),pos(6)+pos(8),7)
        end if
      end if

      if (Darstellung.GE.11) then
        call CLEAR_SCREEN_AREA@(pos(1)+1,pos(2)+1,pos(1)+pos(7)-1,
     *                          pos(2)+pos(8)-1,0)
        call RECTANGLE@(pos(1),pos(2),pos(1)+pos(7),pos(2)+pos(8),7)
      end if

      End

************************************************************************

      Subroutine Plot_Saeule(Darstellung,n,Anzahl_MS,MS,
     *                       k1,k2,k3,k4,dx,W)

************************************************************************

      Include 'nT.inc'
      Include 'nmax.inc'

      External    x_in_px, y_in_py   ! Funktionen

      Integer*2   x_in_px, y_in_py   ! Funktionen
      Integer*2   px, py             ! Pixel-Koordinaten

      Integer*2   l                  ! Laufvariable
      Integer*2   Darstellung        ! Darstellung
      Integer*2   Anzahl_MS          ! # Tracer
      Integer*2   MS(nT)             ! Traceraktiv ?
      Integer*2   n                  ! # der REV
      Integer*2   pk(2,nT)           ! alte Pixel-Koordinaten

      Real*8      x, y               ! Dummy
      Real*8      dx(nmax)           ! Zellenweite
      Real*8      W(nmax,nT)         ! Konzentrationen

      Real*8      k1, k2, k3, k4     ! Umrechnungskonstanten

************************************************************************

      pk(1,1) = x_in_px(k1,k2,0.D0)
      do l=1,Anzahl_MS
        if (MS(l).GT.0) then
          y = W(n+2,l)  ! C_in(l)
          if (y.GT.1.07D0)  y = 1.07D0
          if (y.LT.-3.D-2)  y = -3.D-2
          pk(2,l) = y_in_py(k3,k4,y)
        end if
      end do

      x = 0.D0
      do i=1,n+1
        if (i.EQ.1) then
          X = dx(1)/2.D0
        else
          X = X + dx(i-1)/2.D0 + dx(i)/2.D0
        end if
        px = x_in_px(k1,k2,x)
        do l=1,Anzahl_MS
          if (MS(l).GT.0) then
            y  = W(i,l)
            if (y.GT.1.07D0)  y = 1.07D0
            if (y.LT.-3.D-2)  y = -3.D-2
            py = y_in_py(k3,k4,y)
            call DRAW_LINE@(pk(1,1),pk(2,l),px,py,mod(l,15)+1)
            pk(2,l) = py
          end if
        end do
        pk(1,1) = px
      end do

      End

************************************************************************

      Subroutine Plot_Sediment(Darstellung,n,Anzahl_MS,MS,
     *                         k1,k2,k3,k4,dx,W)

************************************************************************

      Include 'nT.inc'
      Include 'nmax.inc'

      External    x_in_px, y_in_py   ! Funktionen

      Integer*2   x_in_px, y_in_py   ! Funktionen
      Integer*2   px, py             ! Pixel-Koordinaten

      Integer*2   i, l               ! Laufvariable
      Integer*2   Darstellung        ! Darstellung
      Integer*2   Anzahl_MS          ! # Tracer
      Integer*2   MS(nT)             ! Traceraktiv ?
      Integer*2   n                  ! # der REV
      Integer*2   pk(2,nT)           ! alte Pixel-Koordinaten

      Real*8      x, y               ! Dummy
      Real*8      dx(nmax)           ! Zellenweite
      Real*8      W(nmax,nT)         ! Konzentrationen

      Real*8      k1, k2, k3, k4     ! Umrechnungskonstanten

************************************************************************

      pk(2,1) = y_in_py(k3,k4,0.D0)
      do l=1,Anzahl_MS
        if (MS(l).GT.0) then
          x = W(n+2,l)  ! C_in(l)
          if (x.GT.1.07D0)  x = 1.07D0
          if (x.LT.-3.D-2)  x = -3.D-2
          pk(1,l) = x_in_px(k1,k2,x)
        end if
      end do

      Y = 0.D0
      do i=1,n+1
        if (i.EQ.1) then
          Y = -dx(1)/2.D0
        else
          Y = Y - dx(i-1)/2.D0 - dx(i)/2.D0
        end if
        py = y_in_py(k3,k4,y)
        do l=1,Anzahl_MS
          if (MS(l).GT.0) then
            x  = W(i,l)
            if (x.GT.1.07D0)  x = 1.07D0
            if (x.LT.-3.D-2)  x = -3.D-2
            px = x_in_px(k1,k2,x)
            call DRAW_LINE@(pk(1,l),pk(2,1),px,py,mod(l,15)+1)
            pk(1,l) = px
          end if
        end do
        pk(2,1) = py
      end do

      End
