************************************************************************
*                                                                      *
*    Datei                                                             *
*      Screen.for                                                      *
*                                                                      *
*    Inhalt                                                            *
*      Sammlung kleiner Routinen zur Steuerung der Ausgabe. Alle       *
*      Subroutinen die mit einem @ gekennzeichnet sind, sind           *
*      Spezialaufruf des FTN77/486 Compilers von Salford. Sie mssen   *
*      fr andere Compiler angepat werden.                            *
*                                                                      *
************************************************************************
*                                                                      *
*    Copyright                                                         *
*      Der in dieser Datei enthaltene Quellcode darf ohne Genehmigung  *
*      und weitere Vergtung weiterentwickelt werden. Diese Copyright  *
*      Erklrung darf um eigene Urherberrechtserklrungen erweitert    *
*      werden. Die Verwendung dieses Quelltextes fr Publikationen     *
*      ist, auch bei auszugsweiser Verwendung, grundstzlich Genehmi-  *
*      gungspflichtig (kostet nix, ich wrdes halt nur gerne wissen).  *
*                                                                      *
*      Der Programmautor weist darauf hin, da Software nicht fehler-  *
*      frei zu erstellen ist. Die Korrektheit des Quellcodes ist da-   *
*      her auf geeignete Weise zu berprfen.                          *
*                                                                      *
************************************************************************
*                                                                      *
*    Programmautor                                                     *
*      Dr. Rainer Sieger                                               *
*      Alfred-Wegener-Institut fr Meeres- und Polarforschung          *
*      Postfach 12 01 61                                               *
*      27515 Bremerhaven                                               *
*      e-mail: rsieger@AWI-Bremerhaven.de                              *
*                                                                      *
************************************************************************
*                                                                      *
*    letztes Editierdatum                                              *
*      16.3.94                                                         *
*                                                                      *
************************************************************************

************************************************************************
*     Pause. Wartet eine in Sekunden angegebene Zeit.
*     Wird aufgerufen in:
*        Simulation
*        Plotter
************************************************************************

      Subroutine Pause(Sekunden)
      Integer*2  Sekunden
      call SLEEP@(Float(Sekunden))
      END

************************************************************************
************************************************************************
*     Set_Text_mode. Setzt den Text-Modus.
*     Wird aufgerufen in:
*        Main
************************************************************************

      Subroutine Set_Text_mode
      call TEXT_MODE@
      END

************************************************************************
************************************************************************
*     Installiere_Bibliothek. Installiert die Masken-Bibliothek
*     Wird aufgerufen in:
*        Main
************************************************************************

      Subroutine Installiere_Bibliothek(Farbe)
      Integer*2    p
      Character*2  C255
      Character*42 Maske
      Character*64 Vidpop_Kommando
      Logical      Farbe
      call CLEAR_SCREEN@
      Maske = ' '
      call DOSPARAM@('COTAMMASKE',Maske)
      if (NONBLK(Maske).EQ.0)  Maske = 'MASKEN.SWL'
      p = INDEX(Maske,' ') - 1
      C255 = char(255) // char(255)
      Vidpop_Kommando = C255 // 'SET LIBRARY TO ' // Maske(1:p) // '/'
      write(*,'(A,$)') Vidpop_Kommando
      if (Farbe) then
        write(*,'(3A,$)') char(255), char(255), 'SET BW OFF/'
      else
        write(*,'(3A,$)') char(255), char(255), 'SET BW ON/'
      end if
      write(*,'(3A,$)') char(255), char(255), 'SET MENU ESCAPE ON/'
      END

*************************************************************************
************************************************************************
*     Darstellung. Masken-Ausgabe in Abhngigkeit vom Betriebszustand.
*
*     Plot = -1  Testbildschirm, undokumentiert !               (/t)
*     Plot =  1  Durchgangskurve                                (/g)
*     Plot =  2  Durchgangskurve, Sulenverteilungen            (/gg)
*     Plot =  3  Durchgangskurve, Sulenverteilungen, bersicht (/g)
*     Plot =  4  Konzentrationsverteilung, animiert             (/ga)
*     Plot =  5  Verteilungen, animiert                         (/ga)
*     Plot =  6  Sedimentverteilung, animiert                   (/gs)
*     Plot =  7  Textdarstellung                                (/text)
*     Plot =  8  CoTAM im Batch-Modus                           (/batch)
*
*     Wird aufgerufen in:
*        Simulation
************************************************************************

      Subroutine Darstellung(Plot)
      Integer*2    Plot     ! Kontrollflag
      if (Plot.EQ.-1) then
        call CLEAR_SCREEN@
        write(*,'(A)') 'CoTAM Testbildschirm'
      end if
      if (Plot.EQ.7) then  !  Textdarstellung
        call Maske_o('NoMenue')
        call Maske_m('Ausgabe')
      end if
      if (Plot.GE.8) then  ! CoTAM im Batch-Betrieb
        write(*,'(A)') 'CoTAM im Batch-Modus'
        call SET_CURSOR_POS@(0,8)
        write(*,'(A)') 'Vorzeitiger Abbruch mit <ESC>'
      end if
      END

************************************************************************
************************************************************************
*     Sekunden_lang. Die bergebene Variable erhlt die Anzahl der
*     Sekunden seit 1.1.1980
*     Wird aufgerufen in:
*        Simulation
*        Ergebnisausgabe
************************************************************************

      Subroutine Sekunden_lang(Zeit)
      Real*8  Zeit
      call Seconds_since_1980@(Zeit)
      end

************************************************************************
************************************************************************
*     Sekunden_kurz. Die bergebene Variable erhlt die Anzahl der
*     Sekunden 0 h
*     Wird aufgerufen in:
*        Simulation
************************************************************************

      Subroutine Sekunden_kurz(Zeit)
      Real  Zeit
      call CLOCK@(Zeit)
      end

************************************************************************
************************************************************************
*     cls. Lscht den Bildschirm im Textmodus.
*     Wird aufgerufen in:
*        Main
*        Programmende
*        Simulation
*        Setze_Pfade
************************************************************************

      Subroutine cls
      call CLEAR_SCREEN@
      END

************************************************************************
************************************************************************
*     Cursor_on. Stellt den Cursor im Textmodus an.
*     Wird aufgerufen in:
*        Simulation
*        Dateiname
************************************************************************

      Subroutine Cursor_on
      call RESTORE_CURSOR@
      END

************************************************************************
************************************************************************
*     Cursor_off. Stellt den Cursor im Textmodus aus.
*     Wird aufgerufen in:
*        Dateiname
************************************************************************

      Subroutine Cursor_off
      call HIDE_CURSOR@
      END

************************************************************************
************************************************************************
*     Fileselector. Stellt die FTN77/486 Fileselectbox zur Verfgung.
*     Wird aufgerufen in:
*        Dateiname
************************************************************************

      Subroutine Fileselector(Pfad_Extension,Filename)
      Character*(*) Pfad_Extension, Filename
      call SELECT_FILE@(Pfad_Extension,Filename,*1)
    1 continue
      END

************************************************************************
************************************************************************
*     Piep. Gibt den System-Beep aus
*     Wird aufgerufen in:
*        Main
************************************************************************

      Subroutine Piep
      call BEEP@
      END

************************************************************************
************************************************************************
*     Tastaturabfrage. Liest den Tastaturbuffer aus und ermglicht
*     so einen vorzeitigen Abbruch der laufenden Simulation.
*     Wird aufgerufen in:
*        Simulation
************************************************************************

      Subroutine Tastaturabfrage(Zeichen)
      Integer*2  Zeichen
      call GET_KEY1@(Zeichen)
      END

************************************************************************
************************************************************************
*     gotoxy. Setzt den Cursor auf eine durch die bergebenen
*     Parameter spezifizierte Position.
*     Wird aufgerufen in:
*        Messwerte_editieren
*        Menue_Saeule
*        Menue_Zeit
*        Menue_Tracerparameter
*        Programmende
*        Daten_korrekt
*        Editierdatum
*        C_0_setzen
*        Speicher_PRX
*        Ausgabefile
*        Ergebnisausgabe
************************************************************************

      Subroutine gotoxy(i,j)
      integer*2  i, j
      call SET_CURSOR_POS@(i,j)
      END

*************************************************************************
*************************************************************************
*     Save_Screen. Vidpop-Aufruf. Sichert den aktuellen Bildschirm.
*     Wird aufgerufen in:
*        Menue_Zeit
*        Dateiname
*        Warnung
*************************************************************************

      Subroutine Save_Screen(Bildschirm)
      Integer*2 Bildschirm
      write(*,'(3A,I2,A,$)') char(255), char(255), '*FP',Bildschirm,'/'
      END

*************************************************************************
*************************************************************************
*     Restore_Screen. Vidpop-Aufruf. Stellt ein zuvor gesichert
*     aktuellen Bildschirm wieder her.
*     Wird aufgerufen in:
*        Menue_Zeit
*        Dateiname
*        Warnung
*************************************************************************

      Subroutine Restore_Screen(Bildschirm)
      Integer*2   Bildschirm
      write(*,'(3A,I2,A,$)') char(255), char(255), '*DP',Bildschirm,'/'
      END

************************************************************************
************************************************************************
*     Maske_o. Vidpop-Aufruf. Ruft aus der Maskendatei eine durch
*     den bergebenen Parameter spezifizierte Maske auf und stellt
*     sie ohne Schatten auf dem Bildschirm dar.
*     Wird aufgerufen in:
*        Main
*        Namen
*        Menue_System
*        Edit_Pfad
*        Menue_Datei
*        Messwerte_editieren
*        Menue_Zeit
*        Menue_Tracerparameter
*        Start_Simulation
*        Programmende
*        Messwerte_laden
*        Darstellung
*************************************************************************

      Subroutine Maske_o(Bildschirm)
      Character*(*) Bildschirm           ! Bildschirm-Maske
      Character*11  Vidpop_Kommando      ! Vidpop-Kommando
      Vidpop_Kommando = char(255) // char(255) // Bildschirm // '/'
      write(*,'(A)') Vidpop_Kommando
      END

************************************************************************
************************************************************************
*     Maske_m. Vidpop-Aufruf. Ruft aus der Maskendatei eine durch
*     den bergebenen Parameter spezifizierte Maske auf und stellt
*     sie mit Schatten auf dem Bildschirm dar.
*     Wird aufgerufen in:
*        Namen
*        Menue_System
*        Edit_Pfad
*        Menue_Saeule
*        Menue_Hydrodynamik
*        Menue_Zeit
*        Menue_Numerik
*        Menue_Tracerparameter
*        Daten_laden
*        Daten_speichern
*        UMS_File_erstellen
*        PAR_File_erstellen
*        Messwerte_laden
*        Messwerte_speichern
*        Setze_Pfade
*        Schreibe_INI_File
*        LPR_Filename
*        UMS_Filename
*        PHR_Filename
*        PAR_Filename
*        PRX_Filename
*        Export_PRX_to_LOTUS
*        Darstellung
*************************************************************************

      Subroutine Maske_m(Bildschirm)
      Character*(*) Bildschirm           ! Bildschirm-Maske
      Character*11  Vidpop_Kommando      ! Vidpop-Kommando
      write(*,'(3A,$)') char(255), char(255), 'SET SHADOW ON/'
      Vidpop_Kommando = char(255) // char(255) // Bildschirm // '/'
      write(*,'(A)') Vidpop_Kommando
      write(*,'(3A,$)') char(255), char(255), 'SET SHADOW OFF/'
      END

************************************************************************
************************************************************************
*     Warnung. Vidpop-Aufruf. Ruft aus der Maskendatei eine durch
*     den bergebenen Parameter spezifizierte Maske auf und stellt
*     sie mit Schatten auf dem Bildschirm dar. In die Maske wird eine
*     Zahl geschrieben (berschrittenes Limit). Weiter nach Tasten-
*     druck.
*     Wird aufgerufen in:
*        Menue_Zeit
*        Menue_Numerik
*        Daten_korrekt
*************************************************************************

      Subroutine Warnung(Bildschirm,Spalte,Zeile,Zahl)
      Integer*2     Spalte, Zeile        ! Bildschirmkoordinaten
      Integer*2     Zahl                 ! ausgebende Zahl
      Character*(*) Bildschirm           ! Bildschirm-Maske
      Character*11  Vidpop_Kommando      ! Vidpop-Kommando
      call Save_Screen(3)
      write(*,'(3A,$)') char(255), char(255), 'SET SHADOW ON/'
      Vidpop_Kommando = char(255) // char(255) // Bildschirm // '/'
      write(*,'(A)') Vidpop_Kommando
      call SET_CURSOR_POS@(Spalte,Zeile)
      write(*,'(I4)') Zahl
      call Taste
      write(*,'(3A,$)') char(255), char(255), 'SET SHADOW OFF/'
      call Restore_Screen(3)
      END

************************************************************************
************************************************************************
*     Menue_o. Vidpop-Aufruf. Ruft aus der Maskendatei ein durch
*     den bergebenen Parameter spezifiziertes Menue auf und stellt
*     es ohne Schatten auf dem Bildschirm dar. Die Menueauswahl wird
*     in Auswahl zurckgegeben.
*     Wird aufgerufen in:
*        Main
*        Menue_System
*        Menue_Datei
*        Messwerte_editieren
*        Start_Simulation
*        Dateiname
*        Messwerte_laden
************************************************************************

      Subroutine Menue_o(Bildschirm,Auswahl)
      Integer*2     Auswahl              ! getroffene Menauswahl
      Character*(*) Bildschirm           ! Bildschirm-Maske
      Character*11  Vidpop_Kommando      ! Vidpop-Kommando
      Vidpop_Kommando = char(255) // char(255) // Bildschirm // '/'
      write(*,'(A)') Vidpop_Kommando
      call SET_CURSOR_POS@(1,2)
      read(*,*) Auswahl
      call SET_CURSOR_POS@(1,2)
      write(*,'(A,$)') ' '
      END

************************************************************************
************************************************************************
*     Menue_m. Vidpop-Aufruf. Ruft aus der Maskendatei ein durch
*     den bergebenen Parameter spezifiziertes Menue auf und stellt
*     es mit Schatten auf dem Bildschirm dar. Die Menueauswahl wird
*     in Auswahl zurckgegeben.
*     Wird aufgerufen in:
*        Main
*        Menue_System
*        Menue_Saeule
*        Menue_Hydrodynamik
*        Menue_Zeit
*        Menue_Numerik
*        Menue_Tracerparameter
************************************************************************

      Subroutine Menue_m(Bildschirm,Auswahl)
      Integer*2     Auswahl              ! getroffene Menauswahl
      Character*(*) Bildschirm           ! Bildschirm-Maske
      Character*11  Vidpop_Kommando      ! Vidpop-Kommando
      write(*,'(3A,$)') char(255), char(255), 'SET SHADOW ON/'
      Vidpop_Kommando = char(255) // char(255) // Bildschirm // '/'
      write(*,'(A)') Vidpop_Kommando
      call SET_CURSOR_POS@(1,2)
      read(*,*) Auswahl
      call SET_CURSOR_POS@(1,2)
      write(*,'(A,$)') ' '
      write(*,'(3A,$)') char(255), char(255), 'SET SHADOW OFF/'
      END

************************************************************************
************************************************************************
*     Loesch_Zeile. Lscht (Anzahl) Zeichen ab Position (Zeile,Anfang)
*     Wird aufgerufen in:
*        Messwerte_editieren
*        Menue_Saeule
*        Wert_einlesen
*        Simulation
************************************************************************

      Subroutine Loesch_Zeile(Anfang,Zeile,Anzahl)
      Integer*2     i        ! Laufvariable
      Integer*2     Zeile    ! zu lschende Zeile
      Integer*2     Anfang   ! erstes Zeichen (Spalte)
      Integer*2     Anzahl   ! Anzahl der zu lschenden Zahlen
      call HIDE_CURSOR@
      call SET_CURSOR_POS@(Anfang,Zeile)
      do i=1, Anzahl
        write(*,'(A1,$)') ' '
      end do
      call SET_CURSOR_POS@(Anfang,Zeile)
      call RESTORE_CURSOR@
      END

************************************************************************
************************************************************************
*     Wert_einlesen. Liest Wert ein
*     Wird aufgerufen in:
*        Menue_Saeule
*        Menue_Hydrodynamik
*        Menue_Zeit
*        Menue_Numerik
*        Menue_Tracerparameter
************************************************************************

      Subroutine Wert_einlesen(Sf,Spalte,Zeile,l,Wert)
      Integer*2    Spalte, Zeile, l ! Zeilenzeiger
      Integer*2    Sf               ! Speicherflag
      Real         Wert             ! Eingelesener Wert
      Sf = 0
    1 call loesch_Zeile(Spalte,Zeile,l)
      read(*,*,ERR=1) Wert
      call Schreibe_Wert(Spalte,Zeile,Wert)
      END

************************************************************************
************************************************************************
*     Schreibe_Wert. Gibt ein Wert formatiert aus.
*     Wird aufgerufen in:
*        Messwerte_editieren
*        Menue_Saeule
*        Menue_Hydrodynamik
*        Menue_Zeit
*        Menue_Numerik
*        Menue_Tracerparameter
*        Wert_einlesen
*        Ergebnisausgabe
************************************************************************

      Subroutine Schreibe_Wert(Spalte,Zeile,Wert)
      Integer*2   Spalte, Zeile    ! Zeilenzeiger
      Real        Wert             ! zu schreibener Wert
      call SET_CURSOR_POS@(Spalte,Zeile)
      if ((ABS(Wert).LT.1E-4) .OR. (ABS(Wert).GT.9999.9)) then
        write(*,'(1PE10.3,$)') Wert
      else
        write(*,'(F10.4,$)') Wert
      end if
      END

************************************************************************
************************************************************************
*     Lies_Text. Liest einen Text ein bzw. editiert Text.
*     Wird aufgerufen in:
*        Edit_Pfad
*        Menue_Saeule
*        Menue_Tracerparameter
*        Dateiname
************************************************************************

      Subroutine Lies_Text(Text,Spalte,Zeile,Farbe,IC)
      Integer*2      IC                  ! Checkflag
      Integer*2      Farbe               ! Textfarbe
      Integer*2      Spalte, Zeile       ! Zellenzeiger
      Character*(*)  Text
      call read_edited_line@(Text,Spalte,Zeile,Farbe,IC)
      END

************************************************************************
************************************************************************
*     Schreibe_Text. Gibt eine Text aus.
*     Wird aufgerufen in:
*        Menue_Saeule
************************************************************************

      Subroutine Schreibe_Text(Spalte,Zeile,Text)
      Integer*2       Spalte, Zeile      ! Zeilenzeiger
      Character*(*)   Text               ! Text
      call SET_CURSOR_POS@(Spalte,Zeile)
      write(*,'(A37,$)') Text
      END

************************************************************************
************************************************************************
*     Schreibe_Text_unterlegt. Gibt eine farbig unterlegten Text aus.
*     Wird aufgerufen in:
*        Menue_Saeule
*        Menue_Tracerparamter
************************************************************************

      Subroutine Schreibe_Text_unterlegt(Text,Farbe,Spalte,Zeile)
      Integer*2       Farbe              ! Farbe
      Integer*2       Spalte, Zeile      ! Zeilenzeiger
      Character*(*)   Text               ! Text
      call COUP@(Text,Farbe,Spalte,Zeile)
      END

************************************************************************
************************************************************************
*     Aktuelles_Verzeichnis. Ermittelt aktuelles Verzeichnis
*     Wird aufgerufen in:
*        Edit_Pfad
*        Dateipfad
************************************************************************

      Subroutine Aktuelles_Verzeichnis(Pfad)
      Character*42    CURDIR@             ! Funktion (ermittelt DIR)
      Character*42    Pfad                ! zu editierender Pfad
      Pfad = CURDIR@()
      END

************************************************************************
************************************************************************
*     MakeDirectory. Legt ein neues Verzeichnis an
*     Wird aufgerufen in:
*        Lege_Verzeichnis_an
************************************************************************

      Subroutine MakeDirectory(Pfad,ICM)
      Integer*2       IC, ICM             ! Checkflag
      Character*(*)   Pfad                ! Pfad
      call MKDIR@(Pfad,ICM)
      call ATTACH@(Pfad,IC)
      END

************************************************************************
************************************************************************
*     ATTACH. Macht ein Verzeichnis zum aktuellen Verzeichnis
*     Wird aufgerufen in:
*        Lege_Verzeichnis_an
************************************************************************

      Subroutine ATTACH(Pfad)
      Integer*2       IC              ! Checkflag
      Character*(*)   Pfad            ! Pfad
      call ATTACH@(Pfad,IC)
      END

************************************************************************
************************************************************************
*     Schreibe_Pfad. Gibt eine Text aus.
*     Wird aufgerufen in:
*        Menue_System
************************************************************************

      Subroutine Schreibe_Pfad(Spalte,Zeile,Pfad)
      Integer*2      Spalte, Zeile      ! Zeilenzeiger
      Character*30   Pfad               ! Zugriffspfade
      call SET_CURSOR_POS@(Spalte,Zeile)
      write(*,'(A30,$)') Pfad
      END

************************************************************************
************************************************************************
*     Schreibe_MS_Name. Gibt den Namen der Masterspezies aus.
*     Wird aufgerufen in:
*        Menue_Tracerparameter
************************************************************************

      Subroutine Schreibe_MS_Name(Spalte,Zeile,MS_Name)
      Integer*2      Spalte, Zeile      ! Zeilenzeiger
      Character*10   MS_Name            ! Name der Masterspezies
      call SET_CURSOR_POS@(Spalte,Zeile)
      write(*,'(A10,$)') MS_Name
      END

************************************************************************
************************************************************************
*     Links. Macht Text Linksbndig
*     Wird aufgerufen in:
*        Edit_Pfad
*        Dateiname
*        Zerlege_Pfad_Dateiname
*        Setze_Extension
*        Dateipfad
*        Schiebe_Zeichen
************************************************************************

      Subroutine Links(Text)
      Character*(*)  Text
      call TRIM@(Text)
      END

************************************************************************
************************************************************************
*     Gross. Wandelt Text in grosse Buchstaben um.
*     Wird aufgerufen in:
*        Edit_Pfad
*        Dateiname
*        Zerlege_Pfad_Dateiname
*        Setze_Extension
*        Dateipfad
************************************************************************

      Subroutine Gross(Text)
      Character*(*)  Text
      call UPCASE@(Text)
      END

************************************************************************
************************************************************************
*     Warten. Wartet auf Tastendruck, Ausgabe eines Textes in
*     (Spalte,Zeile). Textmodus.
*     Wird aufgerufen in:
*        Main
*        Simulation
************************************************************************

      Subroutine warten(Spalte,Zeile)
      integer*2   Spalte, Zeile, k
      call HIDE_CURSOR@
      call SET_CURSOR_POS@(Spalte,Zeile)
      write(*,'(A,$)') 'Weiter mit beliebiger Taste ...'
      call GET_KEY@(k)
      call SET_CURSOR_POS@(Spalte,Zeile)
      write(*,'(A,$)') '                               '
      call RESTORE_CURSOR@
      END

************************************************************************
************************************************************************
*     Warten_Graphik. Wartet auf Tastendruck, Ausgabe eines Textes.
*     Graphikmodus.
*     Wird aufgerufen in:
*        Simulation
************************************************************************

      Subroutine warten_graphik
      integer*2  k
      call CLEAR_SCREEN_AREA@(360,457,630,475,1)
      call DRAW_TEXT@('Weiter mit beliebiger Taste ...',370,460,14)
      call GET_KEY@(k)
      call CLEAR_SCREEN_AREA@(360,457,630,475,0)
      call CLEAR_SCREEN_AREA@(480,457,630,475,4)
      call DRAW_TEXT@('Abbruch mit <ESC>',490,460,14)
      END

************************************************************************
************************************************************************
*     Lies_Zeichen. Liest ein Zeichen ein und ASCII-Wert zurck.
*     Wird aufgerufen in:
*        Main
*        Namen
*        Edit_Pfad
*        Setze_Pfade
*        Warnung
************************************************************************

      Subroutine Lies_Zeichen(Z)
      Integer*2  Z
      call GET_KEY@(Z)
      END

************************************************************************
************************************************************************
*     Taste. Wartet auf Tastendruck, keine Textausgabe
*     Wird aufgerufen in:
*        Main
*        Namen
*        Edit_Pfad
*        Setze_Pfade
*        Warnung
************************************************************************

      Subroutine Taste
      Integer*2  T
      call SET_CURSOR_POS@(1,2)
      call HIDE_CURSOR@
      write(*,'(A,$)') ' '
      call GET_KEY@(T)
      call RESTORE_CURSOR@
      END

************************************************************************
************************************************************************
*     Loesche_Datei. Lscht eine Datei physikalische vom Massenspeicher.
*     Wird aufgerufen in:
*        Main
*        Menue_System
*        Menue_Datei
************************************************************************

      Subroutine Loesche_Datei(Datei)
      Character*(*)  Datei
      Integer*2      Fehler
      call ERASE@('COTAM.WRK',Fehler)
      END

*************************************************************************
*************************************************************************
*     Datum_Zeit_ermitteln. Aktuelles Datum und Zeit ermitteln.
*     Wird aufgerufen in:
*        Redox
*        Save_Workfile
*        Daten_speichern
*        UMS_File_erstellen
*        PAR_File_erstellen
*        Messwerte_speichern
*        Speicher_PRX
*        Export_PRX_to_LOTUS
*        Ausgabefile
*************************************************************************

      Subroutine Datum_Zeit_ermitteln(Datum,Zeit)
      Character*8  Datum          ! Datum beim ffnen des Files
      Character*8  Zeit           ! Zeit beim ffnen des Files
      Character*8  EDATE@, TIME@  ! FTN77/486 Routinen
      Datum      = EDATE@()
*     Datum      = '07-03-93'
      Datum(3:3) = '.'
      Datum(6:6) = '.'
      Zeit       = TIME@()
*     Zeit       = '19:30'
      Zeit(6:8)  = ' h '
      END

************************************************************************
************************************************************************
*     Berechnet aus aktuellem Datum ein Zahl. Wird nicht mehr bentigt

      Subroutine Date_to_Value(Datum,Datumswert)
      Integer*4    Datumswert
      Integer*4    Char_to_Integer
      Character*8  Datum
      Datumswert =              Char_to_Integer(Datum(7:7))*100000
      Datumswert = Datumswert + Char_to_Integer(Datum(8:8))*10000
      Datumswert = Datumswert + Char_to_Integer(Datum(4:4))*1000
      Datumswert = Datumswert + Char_to_Integer(Datum(5:5))*100
      Datumswert = Datumswert + Char_to_Integer(Datum(1:1))*10
      Datumswert = Datumswert + Char_to_Integer(Datum(2:2))*1
      END

************************************************************************
************************************************************************
*     Wandelt einen String (Ziffern zwischen 0 und 9) in einen Integer
*     um. Wird nicht mehr bentigt.

      Integer*4 Function char_to_Integer(Buchstabe)
      Character*1  Buchstabe
      if (Buchstabe.EQ.'0')  char_to_Integer = 0
      if (Buchstabe.EQ.'1')  char_to_Integer = 1
      if (Buchstabe.EQ.'2')  char_to_Integer = 2
      if (Buchstabe.EQ.'3')  char_to_Integer = 3
      if (Buchstabe.EQ.'4')  char_to_Integer = 4
      if (Buchstabe.EQ.'5')  char_to_Integer = 5
      if (Buchstabe.EQ.'6')  char_to_Integer = 6
      if (Buchstabe.EQ.'7')  char_to_Integer = 7
      if (Buchstabe.EQ.'8')  char_to_Integer = 8
      if (Buchstabe.EQ.'9')  char_to_Integer = 9
      END

